/*****************************************************************************
 *
 * File ..................: acs.c
 * Purpose ...............: Access Control System.
 * Last modification date : 08-Feb-2001
 *
 *****************************************************************************
 * Copyright (C) 2000-2001
 *   
 * Darryl Perry			
 * FIDO:		1:211/105
 * Internet:	dperry.geo@yahoo.com
 *
 * This file is part of Gryphon/X BBS.
 *
 * This BBS is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Gryphon/X BBS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Gryphon/X BBS; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/

#include "structs.h"
#include "defs.h"
#include "acs.h"
#include "basics.h"
#include "mci.h"
#include "conio.h"

char dotwflg[35];

void copy_ACS(ACSrec *To, ACSrec *From)
{
	To->eflags.onn=From->eflags.onn;
	To->eflags.off=From->eflags.off;
	To->fflags.onn=From->fflags.onn;
	To->fflags.off=From->fflags.off;
	To->mgroup.onn=From->mgroup.onn;
	To->mgroup.off=From->mgroup.off;
	To->fgroup.onn=From->fgroup.onn;
	To->fgroup.off=From->fgroup.off;
	To->gender=From->gender;
	To->min_sl=From->min_sl;
	To->dotw=From->dotw;
	To->min_age=From->min_age;
	To->min_logons=From->min_logons;
	To->min_nodes=From->min_nodes;
}

void mod_Sflag(ACSrecS *flg)
{
	int done=FALSE;
	char ch;
	int num;

	mci("~SM");
	while(!done){
		mci("~SMSelect (A-P, Q=Quit):[%s]: ",Sflag2str(flg));
		switch((ch=onekey("ABCDEFGHIJKLMNOPQ"))){
			case 'Q':	done=TRUE;	break;
			default:
				num=ch-'A';
				if(BitTst(flg->onn,num) && BitTst(flg->off,num)){
					flg->onn=BitClr(flg->onn,num);
					}
				else{
					if(BitTst(flg->onn,num) && !BitTst(flg->off,num)){
						flg->off=BitSet(flg->off,num);
						}
					else{
						if(!BitTst(flg->onn,num) && !BitTst(flg->off,num)){
							flg->onn=BitSet(flg->onn,num);
							}
						else{	
							if(!BitTst(flg->onn,num) && BitTst(flg->off,num)){
								flg->off=BitClr(flg->off,num);
								}
							}
						}
					}
				break;
			}
		}
}

char *Sflag2str(ACSrecS *flg)
{
	int i;

	memset(dotwflg,'\0',35);

	for(i=0;i<16;i++){
		if( BitTst(flg->onn,i) &&  BitTst(flg->off,i))	dotwflg[i]='!';
		if(!BitTst(flg->onn,i) &&  BitTst(flg->off,i))	dotwflg[i]=i+'a';
		if( BitTst(flg->onn,i) && !BitTst(flg->off,i))	dotwflg[i]=i+'A';
		if(!BitTst(flg->onn,i) && !BitTst(flg->off,i))	dotwflg[i]='-';
		}	

	dotwflg[16]='\0';

	return(dotwflg);
}


void mod_Lflag(ACSrecL *flg)
{
	int done=FALSE;
	char ch;
	int num;

	mci("~SM");
	while(!done){
		mci("~SMSelect (A-Z, <CR>=Quit):[%s]: ",Lflag2str(flg));
		switch((ch=onekey("@ABCDEFGHIJKLMNOPQRSTUVWXYZ\n\r"))){
			case '\r':
			case '\n':	done=TRUE;	break;
			case '@':
				if(flg->onn) 	flg->onn=0L;
				else			flg->onn=0xFFFFFFFF;
				break;
			default:
				num=ch-'A';
				if(BitTst(flg->onn,num) && BitTst(flg->off,num)){
					flg->onn=BitClr(flg->onn,num);
					}
				else{
					if(BitTst(flg->onn,num) && !BitTst(flg->off,num)){
						flg->off=BitSet(flg->off,num);
						}
					else{
						if(!BitTst(flg->onn,num) && !BitTst(flg->off,num)){
							flg->onn=BitSet(flg->onn,num);
							}
						else{	
							if(!BitTst(flg->onn,num) && BitTst(flg->off,num)){
								flg->off=BitClr(flg->off,num);
								}
							}
						}
					}
				break;
			}
		}
}

char *Lflag2str(ACSrecL *flg)
{
	int i;

	memset(dotwflg,'\0',35);

	for(i=0;i<26;i++){
		if( BitTst(flg->onn,i) &&  BitTst(flg->off,i))	dotwflg[i]='!';
		if(!BitTst(flg->onn,i) &&  BitTst(flg->off,i))	dotwflg[i]=i+'a';
		if( BitTst(flg->onn,i) && !BitTst(flg->off,i))	dotwflg[i]=i+'A';
		if(!BitTst(flg->onn,i) && !BitTst(flg->off,i))	dotwflg[i]='-';
		}	

	dotwflg[32]='\0';

	return(dotwflg);
}


void mod_dotw(unsigned int *DOTW)
{
	int done=FALSE;
	char ch;
	int onn,off;

	mci("~SM");
	while(!done){
		mci("~SMSelect (A-G, Q=Quit):[%s]: ",flag2dotw(*DOTW));
		switch((ch=onekey("ABCDEFGQ"))){
			case 'Q':	done=TRUE;	break;
			default:
				onn=ch-'A';
				off=onn+7;
				if(BitTst(*DOTW,onn) && BitTst(*DOTW,off)){
					*DOTW=BitClr(*DOTW,onn);
					}
				else{
					if(BitTst(*DOTW, onn) && !BitTst(*DOTW,off)){
						*DOTW=BitSet(*DOTW,off);
						}
					else{
						if(!BitTst(*DOTW,onn) && !BitTst(*DOTW,off)){
							*DOTW=BitSet(*DOTW,onn);
							}
						else{	
							if(!BitTst(*DOTW,onn) && BitTst(*DOTW,off)){
								*DOTW=BitClr(*DOTW,off);
								}
							}
						}
					}
				break;
			}
		}
}

char *flag2dotw(unsigned int DOTW)
{
	char dotwchars[17];
	int i,onn,off;

	strcpy(dotwchars,"SMTWTFSsmtwtfs");
	memset(dotwflg,'\0',8);

	for(i=0;i<7;i++){
		onn=i;off=onn+7;
		if( BitTst(DOTW,onn) &&  BitTst(DOTW,off))	dotwflg[onn]='!';
		if(!BitTst(DOTW,onn) &&  BitTst(DOTW,off))	dotwflg[onn]=i+'a';
		if( BitTst(DOTW,onn) && !BitTst(DOTW,off))	dotwflg[onn]=i+'A';
		if(!BitTst(DOTW,onn) && !BitTst(DOTW,off))	dotwflg[onn]='-';
		}	

	dotwflg[8]='\0';

	return(dotwflg);
}

void ACS_setup(ACSrec *acs,char *fstr)
{
	int done=FALSE;
	char ttxt[21],*gentxt[3]={"Don\'t Care","Male","Female"};

	while(!done){
		clr_scr();
		mci("~SMSecurity Setup for %s~SM~SM",fstr);
		mci("(S) Min SecLev  : %-20d (D) Days/Week : %s~SM",
			acs->min_sl,flag2dotw(acs->dotw));
		mci("(G) Gender      : %-20s (E) E Flags   : %s~SM",
			gentxt[acs->gender],Sflag2str(&acs->eflags));
		mci("(N) Minimum Node: %-20d (F) F Flags   : %s~SM",
			acs->min_nodes,Sflag2str(&acs->fflags));
		mci("(L) Min. Logins : %-20d (A) Min. Age  : %d~SM",
			acs->min_logons,acs->min_age);
		mci("(M) Msg Groups  : %s~SM",
			Lflag2str(&acs->mgroup));
		mci("(I) File Groups : %s~SM",
			Lflag2str(&acs->fgroup));
		mci("~SMSelect A-Z, Q=Quit): ",sizeof(ACSrec));
		switch(onekey("ABCDEFGHIJKLMNOPQRSTUVWXYZ")){
			case 'Q':	done=TRUE;	break;
			case 'A':
				mci("~SMMinimum Age: ");
				*ttxt='\0';
				acs->min_age=(char)get_num(ttxt);
				break;
			case 'D':	mod_dotw(&acs->dotw);	break;
			case 'E':	mod_Sflag(&acs->eflags);	break;
			case 'F':	mod_Sflag(&acs->fflags);	break;
			case 'G':
				acs->gender++;
				if(acs->gender>2)	acs->gender=0;
				break;
			case 'I':	mod_Lflag(&acs->fgroup); break;
			case 'L':
				mci("~SMMinimum Logons: ");
				*ttxt='\0';
				acs->min_logons=(char)get_num(ttxt);
				break;
			case 'M':	mod_Lflag(&acs->mgroup); break;
			case 'N':
				mci("~SMMinimum Node Number: ");
				*ttxt='\0';
				acs->min_nodes=get_num(ttxt);
				break;
			case 'S':
				mci("~SMMinimum Security Level: ");
				*ttxt='\0';
				acs->min_sl=get_num(ttxt);
				break;
			}
		}
}
