/*****************************************************************************
 *
 * File ..................: basics.c
 * Purpose ...............: Basic functions
 * Last modification date : 08-Feb-2001
 *
 *****************************************************************************
 * Copyright (C) 2000-2001
 *   
 * Darryl Perry			
 * FIDO:		1:211/105
 * Internet:	dperry.geo@yahoo.com
 *
 * This file is part of Gryphon/X BBS.
 *
 * This BBS is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Gryphon/X BBS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Gryphon/X BBS; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/

#include <stdarg.h>
#include "structs.h"
#include "defs.h"
#include "bbs.h"
#include "basics.h"
#include "conio.h"
#include "fileio.h"
#include "mci.h"
#include "misc.h"
#include "sysop.h"

int exist(char *fname)
{
	FILE *fptr;
	int x;

	fptr=fopen(fname,"rb");

	if(fptr!=NULL){
		x=TRUE;
		fclose(fptr);
		}
	else
		x=FALSE;
	return(x);
}

void nl()
{
	mci("\n");
}

void paws()
{
	language(320);
	getkey(TRUE);
	mci("\b\b\b\b\b\b\b`0F");
}


int yesno()
{
	char ch;
	int x=FALSE;

	ch=onekey("YN");
	if(ch=='Y') x=TRUE;
	return(x);
}

int noyes()
{
	char ch;
	int x=FALSE;

	ch=onekey("YN\n\r");
	if(ch=='N' || ch=='\n' || ch=='\r') x=TRUE;
	return(x);
}

int printfile(char *fname) 
{
	FILE *fptr;
	int done=FALSE,cnt=0,x=FALSE;
	char ttxt[161],ch;

	fptr=fopen(fname,"rt");
	if(fptr!=NULL){
		while(fgets(ttxt,161,fptr)!=NULL && !done){
			mci(ttxt);
			cnt++;
			if(cnt>=thisuser.pagelen-3){
				language(295);
				ch=onekey(lingostr(296));
				if(ch=='Y')
					cnt=0;
				else
					done=TRUE;
				}
			}
		x=TRUE;
		}

	fclose(fptr);
	return(x);
}

void strupr(char *text)
{
	int i;
	for(i=0;i<strlen(text);i++)
		if(text[i]>='a' && text[i]<='z')
			text[i]-=32;
}

void strlwr(char *text)
{
	int i;
	for(i=0;i<strlen(text);i++)
		if(text[i]>='A' && text[i]<='Z')
			text[i]+=32;
}

void center(char *text)
{
	int i;
	

	for(i=0;i<(40-(mcistrlen(text)/2));i++)
		printf(" ");
	mci(text);
}

int tm_copy(struct tm *fr, struct tm *to)
{
	to->tm_sec=fr->tm_sec;
	to->tm_min=fr->tm_min;
	to->tm_hour=fr->tm_hour;
	to->tm_mday=fr->tm_mday;
	to->tm_mon=fr->tm_mon;
	to->tm_year=fr->tm_year;
	to->tm_wday=fr->tm_wday;
	to->tm_yday=fr->tm_yday;
	to->tm_isdst=fr->tm_isdst;
	return 1;
}

char moreyn()
{
	char ch,ttxt[51];
	int i,s;

	strcpy(ttxt,lingostr(295));
	s=mcistrlen(ttxt);
	language(295);
	ch=onekey(lingostr(296));
	for(i=0;i<s;i++){
		printf("\b \b");
		}
	if(ch=='\n')	{
		ch='Y';
		}
	return(ch);
}

int mcistrset(char *mcstr, int chop)
{
	int i,x;

	i=strlen(mcstr);	
	if(mcistrlen(mcstr)>chop){
		for(x=0;x<chop;x++){
			if(mcstr[x]=='`'){
				chop+=3;
				}
			}
		if(x<i)	mcstr[x]='\0';
		}
	else{
		for(x=mcistrlen(mcstr);x<chop;x++){
			strcat(mcstr," ");
			}
		}
	return 0;
}

int mcistrrset(char *mcstr, int chop)
{
	int i,x;
	char t1[191];

	i=strlen(mcstr);	
	if(mcistrlen(mcstr)>chop){
		for(x=0;x<chop;x++){
			if(mcstr[x]=='`'){
				chop+=3;
				}
			}
		if(x<i)	mcstr[x]='\0';
		}
	else{
		*t1='\0';
		for(x=mcistrlen(mcstr);x<chop;x++){
			strcat(t1," ");
			}
		strcat(t1,mcstr);
		strcpy(mcstr,t1);
		}
	return 0;
}

int mcistrcset(char *mcstr, int chop)
{
	int i,x,num,num1;
	char t1[191];

	i=strlen(mcstr);	
	if(mcistrlen(mcstr)>chop){
		for(x=0;x<chop;x++){
			if(mcstr[x]=='`'){
				chop+=3;
				}
			}
		if(x<i)	mcstr[x]='\0';
		}
	else{
		num=chop-mcistrlen(mcstr);  /*  How many total blanks */
		num1=(num/2);  /* How many blanks in front */
		*t1='\0';
		for(x=0;x<num1;x++){
			strcat(t1," ");
			}
		strcat(t1,mcstr);
		for(x=num1;x<num;x++){   /* How many blanks in back */
			strcat(t1," ");
			}
		strcpy(mcstr,t1);
		}
	return 0;
}
