/*****************************************************************************
 *
 * File ..................: bbs.c
 * Purpose ...............: The main bbs file.
 * Last modification date : 08-Feb-2001
 *
 *****************************************************************************
 * Copyright (C) 2000-2001
 *   
 * Darryl Perry			
 * FIDO:		1:211/105
 * Internet:	dperry.geo@yahoo.com
 *
 * This file is part of Gryphon/X BBS.
 *
 * This BBS is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Gryphon/X BBS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Gryphon/X BBS; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include "structs.h"
#include "acs.h"
#include "bbs.h"
#include "basics.h"
#include "misc.h"
#include "config.h"
#include "defs.h"
#include "fileio.h"
#include "lineedit.h"
#include "logon.h"
#include "conio.h"
#include "chat.h"
#include "mail.h"
#include "misc.h"
#include "mci.h"
#include "mbasedit.h"
#include "msgbase.h"
#include "nodedit.h"
#include "sysop.h"
#include "oneliners.h"


int current_menu_idx=0;
char menu_stack[20][36];
int what2run=0;
int ScanOrRead=TRUE;
int multi=FALSE;


void make_door_sys();

int main(int argc, char *argv[])
{
	init(argc, argv);
	print_system_text("logon");
	run_menu(menu_stack[current_menu_idx]);
	return(0);
}

void rotate_logs()
{
	int i;
	char old[91],new[91];
	
	for(i=config.logdays;i>0;i--){
		sprintf(old,"%slogfile%d.log",config.datapath,i);
		sprintf(new,"%slogfile%d.log",config.datapath,i+1);
		if((i+1) >= config.logdays)
			remove(old);
		else
			rename(old,new);
		}
}

void new_day()
{
	rotate_logs(); 
}

void init(int argc, char *argv[])
{
	int n;
	lingorec lr;
	time_t t;
	struct tm *tm;

	config.KbTimeOut=180;
	thisuser.tltoday=15*60;
	thisuser.pagelen=24;

	config.bbspath[0]='\0';
	strcpy(config.bbspath,argv[0]);
	n=strlen(config.bbspath)-1;
	while(config.bbspath[n]!='/' && n>0){
		config.bbspath[n]='\0';
		n--;
		}

	if(readconfigdat()==0){
		mci("~SMError reading config.data~SMExiting..~SM~SP");
		exit(1);
		}

	t=time(NULL);
	tm=localtime(&t);

	if(tm->tm_year != config.today->tm_year && 
	   tm->tm_mday != config.today->tm_mday &&
	   tm->tm_mon  != config.today->tm_mon){
		new_day();
		}

	strcpy(yna[1],lingostr(1));
	strcpy(yna[0],lingostr(2));
	strcpy(yna[2],lingostr(12));

	total_users=countusers();
	total_mbases=countmbases();
	total_fbases=countfbases();
	total_nodes=countnodes();
	total_lingo=countlingo();
	total_FSEs=countFSE();
	readzlog();
	strcpy(menu_stack[current_menu_idx],config.startmenu);
	randomize();
	findnode();
	fill_temp_path();
	config.today=tm;
	saveconfigdat();
	Syslog("Starting session");

	if(readLingo(&lr,0)){
		strcpy(defmenupath,lr.menupath);
		strcpy(deftextpath,lr.textpath);
		strcpy(deflingofile,lr.lingofile);
		}
	else{
		Syslog("No language file found.");
		strcpy(defmenupath,config.menupath);
		strcpy(deftextpath,config.textpath);
		strcpy(deflingofile,"english.txt");
		}

	if(curnode.sysoplogin==TRUE && read_usr(&thisuser,0) && 
		config.fastsysoplogon && strcmp(getenv("LOGNAME"),config.unixsysop)==0){
		update_caller(0);
		}
	else
		logon();
	Syslog("%s (%s) logging on",thisuser.realname,thisuser.alias);
}

int run_cmd(menucmdrec McCmd) 
{
	int x1=9,retval=1;
	char cmd2run[256];
	unsigned long num;
	lingorec lr;

	switch(McCmd.cmdtype[0]){
		case '*':	
			switch(McCmd.cmdtype[1]){
				case '#':	retval=0;	break;	
				case 'L':	retval=0;	break;
				case 'M':	retval=0;	break;	
				case 'N':	retval=0;	break;	
				case 'S':	retval=0;	break;	
				case 'T':	retval=0;	break;	
				case 'U':	retval=0;	break;	
				}	
			break;
		case '-':	
			switch(McCmd.cmdtype[1]){
				case 'E':
					mci(McCmd.options);
					break;
				case 'H':
					print_system_text(OptStr[0]);
					Syslog("Displayed file [%s]",OptStr[0]);
					break;
				case 'V':
					bbsinfo();
					Syslog("Displayed BBS Info");
					break;
				case '/':
					current_menu_idx++;
					strncpy(menu_stack[current_menu_idx],OptStr[0],35);
					onlyonce=TRUE;
					retval=0;
					Syslog("Gosub to Menu [%s]",menu_stack[current_menu_idx]);
					break;
				case '\\':
					current_menu_idx--;
					retval=0;
					Syslog("Return from Gosub Menu [%s]",menu_stack[current_menu_idx]);
					break;
				case '=':
					onlyonce=TRUE;
					strncpy(menu_stack[current_menu_idx],OptStr[0],35);
					retval=0;
					Syslog("Goto Menu [%s]",menu_stack[current_menu_idx]);
					break;
				case '^':
					onlyonce=TRUE;
					strncpy(menu_stack[current_menu_idx],OptStr[0],35);
					Syslog("Goto Menu [%s]",menu_stack[current_menu_idx]);
					retval=0;
					break;
				}
			break;
		case 'D':	
			switch(McCmd.cmdtype[1]){
				case 'G':
				case 'C':
				case 'D':
					if(strlen(OptStr[1])>0)
						UpdateNodeStatus(OptStr[1]);
					else
						UpdateNodeStatus("In A Door");
					make_door_sys();
					make_door32sys();
					strcpy(cmd2run,OptStr[0]);
					mcimacros(cmd2run);
					Syslog("Running Door [%s]",cmd2run);
					system(cmd2run);
					retval=0;
					break;
				}
			break;
		case 'F':	break;
		case 'H':	
			switch(McCmd.cmdtype[1]){
				case 'C':	
					qbbs(FALSE);
					current_menu_idx=0;
					strncpy(menu_stack[current_menu_idx],config.startmenu,35);
					logon();	
					retval=0;
					Syslog("Relogging On");
					break;
				case 'H':	qbbs(TRUE);	paws(); break;
				case 'I':	break;
				case 'X':	break;
				}
			break;
		case 'L':	break;
		case 'M':	
			switch(McCmd.cmdtype[1]){	
				case '*':		
					Syslog("Listing Message Bases");
					list_mbases();	
					retval=0;	
					break;
				case '!':	
					Syslog("Checking Mail Stats");
					mail_stats();	
					retval=0;	
					break;
				case '#':	
					num=atol(McCmd.options)-1;
					if(num>=0 && num<total_mbases)
						thisuser.lastmbarea=num;
					thisuser.lastmsg=0L;
					save_usr(&thisuser,thisuser.userID);
					read_mbaselist(&current_mb,thisuser.lastmbarea);
					break;
				case 'A':
					thisuser.lastmsg=0;
					if(strstr(McCmd.options,"+"))
						GoNextMsgArea();
					if(strstr(McCmd.options,"-"))
						GoPrevMsgArea();
					read_mbaselist(&current_mb,thisuser.lastmbarea);
					save_usr(&thisuser,thisuser.userID);
					Syslog("Moved to message area [%s]",current_mb.mbdisplay);
					break;
				case 'E':
					SendEmail(OptStr[0],OptStr[1]);
					break;
				case 'N':	
					multi=TRUE;
					current_menu_idx++;
					strcpy(menu_stack[current_menu_idx],"msgread");
					thisuser.lastmbarea=0L;
					language(504); /* ~SMScanning ~MB ... */
					Syslog("Performing Message Newscan");
					ReadOrScanMsgs(ScanOrRead,multi);	
					if(!x1)	current_menu_idx--;
					break;	
				case 'P':	
					if(strlen(McCmd.options)>0){
						if(isdigit(McCmd.options[0]))
							PostNewMsg(atoi(McCmd.options));
						else
							language(388); /* Invalid command option. */
						}
					else{
						PostNewMsg(thisuser.lastmbarea);
						}
					Syslog("Posted Message to [%d]",thisuser.lastmbarea);
					break;
				case 'R':	
					multi=FALSE;
					current_menu_idx++;
					strcpy(menu_stack[current_menu_idx],"msgread");
					if(ReadMessages(thisuser.lastmbarea)!='Q')
						run_menu(menu_stack[current_menu_idx]);
					Syslog("Read Messages");
					break;
				case 'S':
					if(strlen(McCmd.options)>0){
						if(isdigit(McCmd.options[0]))
							MsgScanArea(atoi(McCmd.options));
						else
							language(388);	/* Invalid command option. */
						}
					else
						MsgScanArea(thisuser.lastmbarea);
					Syslog("Scanned Message Headers");
					break;
				}
			break;
		case 'N':	
			switch(McCmd.cmdtype[1]){	
				case 'W': 
					UpdateNodeStatus(OptStr[0]);
					WhoIsOnline();	
					retval=0;	
					Syslog("Who Is Online");
					break;
				}
			break;
		case 'O':
			switch(McCmd.cmdtype[1]){	
				case 'A':
					OneLiner();
					break;
				case 'C':
					Chat();
					break;
				case 'U': 
					Syslog("Browsing Userlist");
					if(strlen(OptStr[0]))
						UpdateNodeStatus(OptStr[0]);
					else
						UpdateNodeStatus("Browsing Userlist");
					browse_userlist(); 
					retval=0;	
					break;
				case 'L': 
					Syslog("Last On");
					laston(atoi(OptStr[0])); 		
					retval=0;	
					break;
				case 'P':
					if(isdigit(McCmd.options[0])){
						switch(atoi(McCmd.options)){
							case 1:	get_real_name(&thisuser);	break;
							case 2: get_alias(&thisuser);		break;
							case 3: get_street(&thisuser);		break;
							case 4: get_location(&thisuser);	break;
							case 5: get_zipcode(&thisuser);		break;
							case 6: get_email(&thisuser);	break;
							case 7: get_voice_phone(&thisuser);	break;
							case 8: get_new_password(&thisuser);	break;
							case 9: get_birthdate(&thisuser);	break;
							case 10: break;
							case 11: get_notes(1,&thisuser);	break;
							case 14: 
								get_screen_width(&thisuser);	
								get_screen_length(&thisuser);	break;
							case 15: get_termtype(&thisuser);	break;
							case 16: get_fse(&thisuser);	break;
							case 18: 
								pick_lingo(&thisuser);	
								if(readLingo(&lr,(int)thisuser.language[0])){
									strcpy(defmenupath,lr.menupath);
									strcpy(deftextpath,lr.textpath);
									strcpy(deflingofile,lr.lingofile);
									}
								break;
							}
						save_usr(&thisuser,thisuser.userID);
						}
					break;
				case 'Q':	SelectGroup(1,OptStr[0]);	break;
				case 'R':	SelectGroup(0,OptStr[0]);	break;
				case 'S':
					if(strlen(OptStr[1]))
						UpdateNodeStatus(OptStr[1]);
					bulletins(OptStr[0]);
					break;
				case 'T':	EditSig();	break;
				}
			break;
		case 'Q':	break;
		case 'R':	
			switch(McCmd.cmdtype[1]){
				case '#':
					thisuser.lastmsg=atol(OptStr[0]);
					x1=ReadOrScanMsgs(ScanOrRead,multi);	
					if(!x1)	current_menu_idx--;
					break;
				case '[':	GoToReplyTo(thisuser.lastmbarea);	break;
				case 'A':	
					x1=ReadOrScanMsgs(ScanOrRead,multi);	
					if(!x1) current_menu_idx--; 
					ScanOrRead=TRUE;
					break;
				case 'D':	
					DelCurMsg(thisuser.lastmbarea,thisuser.lastmsg);
					break;
				case 'I':	
					IgnoreTheRest(thisuser.lastmbarea);	
					x1=ReadOrScanMsgs(ScanOrRead,multi);	
					if(!x1) current_menu_idx--;
					ScanOrRead=TRUE;
					break;
				case 'K':	ToggleKludges();	break;
				case 'N':	
					thisuser.lastmsg++;	
					x1=ReadOrScanMsgs(ScanOrRead,multi);	
					if(!x1)	current_menu_idx--;
					break;
				case 'P':	
					thisuser.lastmsg--;
					x1=ReadOrScanMsgs(ScanOrRead,multi);	
					if(!x1)	current_menu_idx--;
					break;
				case 'Q':	
					SetLastRead(thisuser.userID,thisuser.lastmsg);
					save_usr(&thisuser,thisuser.userID);
					if(strcmp(OptStr[0],"S")==0){
						current_menu_idx--;
						}
					else{
						BypassTheRest(thisuser.lastmbarea);
						x1=ReadOrScanMsgs(ScanOrRead,multi);	
						if(!x1) current_menu_idx--;
						}
					break;
				case 'R':	PostReplyMsg(thisuser.lastmbarea);	break;
				case 'T':	
					ScanOrRead=FALSE;
					x1=ReadOrScanMsgs(ScanOrRead,multi);	
					if(!x1)	current_menu_idx--;
					break;
				case 'X':	MsgExtractFull();	break;
				}
			break;
		case 'S':	break;
		case 'T':	break;
		case 'U':	
			switch(McCmd.cmdtype[1]){	
				case 'W': 
					Syslog("Writing Automessage");
					if(strlen(OptStr[0]))
						UpdateNodeStatus(OptStr[0]);	
					else
						UpdateNodeStatus("Writing Automessage");	
					automsg_add(); 
					break;
				case 'R': 
					Syslog("Reading Automessage");
					if(strlen(OptStr[0]))
						UpdateNodeStatus(OptStr[0]);	
					else
						UpdateNodeStatus("Reading Automessage");	
					automsg_read();
					break;
				}
			break;
		}
	return(retval);
}

int load_menu(char *curmenu, char keys[76])
{
	int maxc,kcnt,retval=FALSE;

	keys[0]='\0';
	kcnt=maxc=0;
	while(readmenucmd(curmenu,maxc++)){
		if(checkACS(menucmd.ACS)){ 
			if(strcmp("AUTOEXEC",menucmd.keys)==0){
				ParseOpt(menucmd.options);
				if(run_cmd(menucmd)==0){
					keys[kcnt++]=2;
					}
				}
			else {
				if(strcmp("ENTER",menucmd.keys)==0){
					keys[kcnt++]=3;
					}
				else{
					if(strcmp("ONLYONCE",menucmd.keys)==0 && onceonly==TRUE){
						if(run_cmd(menucmd)==0){
							keys[0]=kcnt=maxc=0;
							onceonly=FALSE;
							}
						}
					else	
						keys[kcnt++]=menucmd.keys[0]; 	
					}
				}
			}
		}
	keys[kcnt]='\0';
	return retval;
}

int FindAndRunCmd(char *newmenu,char *ch,int maxc)
{
	int flag;
	int retval=FALSE;
	maxc=0;
	while(readmenucmd(newmenu,maxc++)){ 
		flag=TRUE;
		if(strcmp(menucmd.keys,"AUTOEXEC")==0)	flag=FALSE;
		if(strcmp(menucmd.keys,"ONLYONCE")==0 && onceonly==TRUE)	flag=TRUE;
		if(strcmp(menucmd.keys,"SUBHEADER")==0)	flag=FALSE;

		if(strcmp(menucmd.keys,"ENTER")==0 && ch[0]==3)	{
			flag=TRUE;
			strcpy(ch,"ENTER");
			}
		if(strcmp(menucmd.cmdtype,"R#")==0 && isdigit(ch[0])){
			flag=TRUE;
			sprintf(menucmd.options,"%s",ch);
			strcpy(ch,"#");
			}
		if(strcmp(menucmd.cmdtype,"M#")==0 && isdigit(ch[0]))	{	
			flag=TRUE;
			sprintf(menucmd.options,"%s",ch);
			strcpy(ch,"#");
			}
		if(strcmp(menucmd.cmdtype,"F#")==0 && isdigit(ch[0]))	{	
			flag=TRUE;
			sprintf(menucmd.options,"%s",ch);
			strcpy(ch,"#");
			}

		if(flag==TRUE){
			if(strncasecmp(ch,menucmd.keys,strlen(menucmd.keys))==0){
				ParseOpt(menucmd.options);
				retval=TRUE;
				run_cmd(menucmd);
				if(strcmp(menucmd.keys,"ONLYONCE")==0 && onceonly==TRUE)	
					onceonly=FALSE;
				}
			}
		}
	return retval;
}

void run_menu(char *menuname) 
{
	int done,kcnt=0,r=0,n;
	char morekeys[90],keys[76],newmenu[36];
	char ch1,ch[13],viewmode=0;

	while(TRUE){
		do{
			strncpy(newmenu,menu_stack[current_menu_idx],35);
			load_menu(menu_stack[current_menu_idx],keys);
			}while(strcmp(newmenu,menu_stack[current_menu_idx])!=0);
		sprintf(morekeys,"%s1234567890?\n",keys);
		n=strlen(morekeys);
		showmenu(newmenu,viewmode);
		kcnt=0;
		done=FALSE;
		while(!done){
			ch1=onekey(morekeys);   /* Get a key */
			switch(ch1){
				case 10 :
					if(kcnt==0){
						ch[0]=3;
						ch[1]='\0';
						}
						FindAndRunCmd(newmenu,ch,r);
					done=TRUE;
					kcnt=0;
					break;
				case '?':	showmenu(newmenu,1);	break;
				case '1': case '2': case '3': case '4': case '5':
				case '6': case '7': case '8': case '9': case '0':
					ch[kcnt++]=ch1;
					ch[kcnt]='\0';
					if(strchr(keys,ch1)!=NULL){
						FindAndRunCmd(newmenu,ch,r);
						kcnt=0;
						done=TRUE;
						}
					break;
				default:	
					ch[kcnt++]=ch1;
					ch[kcnt]='\0';
					FindAndRunCmd(newmenu,ch,r);
					kcnt=0;
					done=TRUE;
					break;
				}
			}
		}
}

void browse_userlist()
{
	int cnt,i1,ksrch=FALSE,doit=TRUE;
	userrec tuser;
	char schstr[37],tustr[37],buf[256];
	struct tm *tm;

	while(doit){
		language(1607); /* Enter search string or <ENTER> to view all users:*/
		schstr[0]='\0';
		get_str(schstr,30);
		strupr(schstr);
		if(strcmp(schstr,"")==0 || strcmp(schstr,"ALL")==0){		
			language(1610);  /* Searching User Listing - All users */
			}
		else {
			char2A(1,schstr);
			language(1611); /* Searching User Listing - Keyword \"%s\" */
			ksrch=TRUE;
			}
		language(1612);
		language(1613);
		i1=0;cnt=0;
		while(read_usr(&tuser,i1)){
			strcpy(tustr,tuser.alias);
			strupr(tustr);
			if( (ksrch==TRUE && strstr(tustr,schstr)) || ksrch==FALSE){
				*buf='\0';
				char2A(2,tuser.alias);
				char2A(5,tuser.location);
				tm=localtime(&tuser.laston);
				strftime(buf,21,"%m/%d/%Y",tm);
				char2A(3,buf);
				strftime(buf,21,"%H:%M:%S",tm);
				char2A(4,buf);	
				language(1615);
				cnt++;
				int2A(1,cnt);
				}
			i1++;
			}
		if(ksrch)
			if(cnt<1)	language(1617);
			else 		language(1619);
		else
			if(cnt<1)	language(1616);
			else		language(1618);
		language(1620);
		doit=yesno();
			
		}
}

void laston(int count)
{
	int i1=0,i2=0;
	lastcallrec lcr;
	struct tm *tm;
	char l1[21];

	while(read_laston(&lcr,i2++));

	language(1599);
	language(1600);
	language(1601);
	i1=i2-count;
	if(i1<0)
		i1=0;
	while(read_laston(&lcr,i1) && i1<=i2){
		tm=localtime(&lcr.laston);
		strftime(l1,20,"%m/%d/%y %I:%M %p",tm);	
		int2A(1,lcr.caller);
		char2A(2,lcr.alias);
		char2A(3,lcr.location);
		int2A(4,(int)lcr.node);
		char2A(5,"Telnet");
		char2A(6,l1);
		language(1603);
		i1++;
		}
}

void bbsinfo()
{
	mci("~SM`0E");
	center(PROGNAME);nl();
	center("Copyright 2000 by Darryl Perry.  All rights reserved.");nl();

	mci("~SM`06Compilation date  `0BTue 14 Nov 2000 22:00p");
	mci("~SM");
	mci("~SM`07Squish is a trademark of Scott J. Dudley.");
	mci("~SM`07JAM(mbp) - Copyright 1993 Joaquim Homrighausen, Anrew Milner, Mats Birch,");
	mci("~SM             Mats Wallin.  All Righs Reserved.~SM~SM");
	paws();
}

