/*****************************************************************************
 *
 * File ..................: cfg_fileio.c
 * Purpose ...............: gycfg file io functions.
 * Last modification date : 08-Feb-2001
 *
 *****************************************************************************
 * Copyright (C) 2000-2001
 *   
 * Darryl Perry			
 * FIDO:		1:211/105
 * Internet:	dperry.geo@yahoo.com
 *
 * This file is part of Gryphon/X BBS.
 *
 * This BBS is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Gryphon/X BBS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Gryphon/X BBS; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/

#include "structs.h"
#include "defs.h"
#include "basics.h"
#include "cfg_fileio.h"
#include "fileio.h"
#include "mci.h"
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>

void change_mode(char *fname)
{
	if(chmod(fname,S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH)==-1){
		mci("~SMError changing modes~SM");paws();
		}
}

int save_usr_temp(userrec *ur, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%susers.data.temp",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		fptr=fopen(ttxt,"wb");
		if(fptr==NULL) {
			nl();
			printf("Error creating users.data");nl();
			return(FALSE);
			}
		}

	if(fseek(fptr,(long)recno*sizeof(userrec),SEEK_SET)==0)
		x=fwrite(ur,sizeof(userrec),1,fptr);

	fclose(fptr);
	return(x);
}



int read_usr_temp(userrec *ur, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%susers.data.temp",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		return(x);
		}
	if(fseek(fptr,(long)recno*sizeof(userrec),SEEK_SET)==0){
		x=fread(ur,sizeof(userrec),1,fptr);
		}

	fclose(fptr);
	return(x);
}

void restore_user_data()
{
	char ttxt1[81],ttxt2[81];
	int i=0;
	userrec othr;

	sprintf(ttxt1,"%susers.data",config.datapath);
	sprintf(ttxt2,"%susers.data.temp",config.datapath);

	remove(ttxt1);
	while(read_usr_temp(&othr,i)){
		save_usr(&othr,i);	
		i++;
		}
	remove(ttxt2);
}

int savenodetemp(noderec *nr, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%snode.data.temp",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		fptr=fopen(ttxt,"wb");
		if(fptr==NULL) {
			nl();
			printf("Error creating node.data");nl();
			return(FALSE);
			}
		}

	if(fseek(fptr,(long)recno*sizeof(noderec),SEEK_SET)==0)
		x=fwrite(nr,sizeof(noderec),1,fptr);

	fclose(fptr);
	return(x);
}

int readnodetemp(noderec *nr, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%snode.data.temp",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		return(x);
		}

	if(fseek(fptr,(long)recno*sizeof(noderec),SEEK_SET)==0)
		x=fread(nr,sizeof(noderec),1,fptr);

	fclose(fptr);
	return(x);
}

int savemenutop(char *menufile)
{
	FILE *fptr;
	int x=FALSE;
	char menupath[81];

	sprintf(menupath,"%s%s.mnu",defmenupath,menufile);

	fptr=fopen(menupath,"rb+");
	if(fptr==NULL){
		fptr=fopen(menupath,"wb");
		x=fwrite(&menutop,sizeof(menutoprec),1,fptr);
		}
	else
		x=fwrite(&menutop,sizeof(menutoprec),1,fptr);
	fclose(fptr);
	return(x);
}

int savemenucmd(char *menufile, int cmdnum)
{
	FILE *fptr;
	char menupath[81];
	int x=FALSE;
	menucmdrec mc;
	menutoprec mt;

	sprintf(menupath,"%s%s.mnu",defmenupath,menufile);

	fptr=fopen(menupath,"rb+");
	if(fptr==NULL)
		x=FALSE;
	else{
		if(fseek(fptr,(sizeof(mc)*(long) cmdnum) + sizeof(mt),SEEK_SET)==0)
			x=fwrite(&menucmd,sizeof(mc),1,fptr);
			fclose(fptr);
		}
	return(x);
}

void delmnucmd(char *menuname,int cmdnum)
{
	FILE *fptr;
	char tempfile[81];
	char menufile[81];
	int i,cnt;
	menutoprec mt;
	menucmdrec mc;

	sprintf(tempfile,"%s%s.tmp",defmenupath,menuname);
	sprintf(menufile,"%s%s.mnu",defmenupath,menuname);

	fptr=fopen(tempfile,"wt");
	if(fptr==NULL)
		;
	readmenutop(menuname);
	fwrite(&menutop,sizeof(menutoprec),1,fptr);
	i=0;cnt=0;
	while(readmenucmd(menuname,i)){
		if(i!=cmdnum){
			if(fseek(fptr,(sizeof(mc)*(long)cnt)+sizeof(mt),SEEK_SET)==0){
				if(fwrite(&menucmd,sizeof(menucmdrec),1,fptr)==1){
					cnt++;
					}
				}
			}
		i++;
		}
	fclose(fptr);
	remove(menufile);
	rename(tempfile,menufile); 
} 

int save_mbasetemp(mb_list_rec *mr, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%smbases.data.temp",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		fptr=fopen(ttxt,"wb");
		if(fptr==NULL) {
			nl();
			printf("Error creating mbases.data.temp");nl();
			return(FALSE);
			}
		}

	if(fseek(fptr,(long)recno*sizeof(mb_list_rec),SEEK_SET)==0)
		x=fwrite(mr,sizeof(mb_list_rec),1,fptr);

	fclose(fptr);
	return(x);
}

int save_mbaselist(mb_list_rec *mr, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%smbases.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		fptr=fopen(ttxt,"wb");
		if(fptr==NULL) {
			nl();
			printf("Error creating .data");nl();
			return(FALSE);
			}
		}

	if(fseek(fptr,(long)recno*sizeof(mb_list_rec),SEEK_SET)==0)
		x=fwrite(mr,sizeof(mb_list_rec),1,fptr);

	fclose(fptr);
	return(x);
}


int read_mbasetemp(mb_list_rec *mr, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%smbases.data.temp",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		return(x);
		}

	if(fseek(fptr,(long)recno*sizeof(mb_list_rec),SEEK_SET)==0)
		x=fread(mr,sizeof(mb_list_rec),1,fptr);

	fclose(fptr);
	return(x);
}

int save_fbasetemp(fb_list_rec *fr, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%sfbases.data.temp",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		fptr=fopen(ttxt,"wb");
		if(fptr==NULL) {
			nl();
			printf("Error creating fbases.data.temp");nl();
			return(FALSE);
			}
		}

	if(fseek(fptr,(long)recno*sizeof(fb_list_rec),SEEK_SET)==0)
		x=fwrite(fr,sizeof(fb_list_rec),1,fptr);

	fclose(fptr);
	return(x);
}

int save_fbaselist(fb_list_rec *fr, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%sfbases.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		fptr=fopen(ttxt,"wb");
		if(fptr==NULL) {
			nl();
			printf("Error creating .data");nl();
			return(FALSE);
			}
		}

	if(fseek(fptr,(long)recno*sizeof(fb_list_rec),SEEK_SET)==0)
		x=fwrite(fr,sizeof(fb_list_rec),1,fptr);

	fclose(fptr);
	return(x);
}


int read_fbasetemp(fb_list_rec *fr, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%sfbases.data.temp",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		return(x);
		}

	if(fseek(fptr,(long)recno*sizeof(fb_list_rec),SEEK_SET)==0)
		x=fread(fr,sizeof(fb_list_rec),1,fptr);

	fclose(fptr);
	return(x);
}

int saveFSE(fserec *fe, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%sfse.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		fptr=fopen(ttxt,"wb");
		if(fptr==NULL){
			printf("\n\rError creating node.data\n\r");
			return(FALSE);
			}
		}

	if(fseek(fptr,(long)recno*sizeof(fserec),SEEK_SET)==0)
		x=fwrite(fe,sizeof(fserec),1,fptr);

	fclose(fptr);
	return(x);
}

int saveFSEtemp(fserec *fe, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%sfse.data.temp",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		fptr=fopen(ttxt,"wb");
		if(fptr==NULL) {
			printf("\n\rError creating node.data\n\r");
			return(FALSE);
			}
		}

	if(fseek(fptr,(long)recno*sizeof(fserec),SEEK_SET)==0)
		x=fwrite(fe,sizeof(fserec),1,fptr);

	fclose(fptr);
	return(x);
}

int readFSEtemp(fserec *fe, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%sfse.data.temp",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		return(x);
		}

	if(fseek(fptr,(long)recno*sizeof(fserec),SEEK_SET)==0)
		x=fread(fe,sizeof(fserec),1,fptr);

	fclose(fptr);
	return(x);
}

int saveLingo(lingorec *fe, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%slanguage.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		fptr=fopen(ttxt,"wb");
		if(fptr==NULL){
			printf("\n\rError creating language.data\n\r");
			return(FALSE);
			}
		}

	if(fseek(fptr,(long)recno*sizeof(lingorec),SEEK_SET)==0)
		x=fwrite(fe,sizeof(lingorec),1,fptr);

	fclose(fptr);
	return(x);
}

int saveLingotemp(lingorec *fe, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%slanguage.data.temp",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		fptr=fopen(ttxt,"wb");
		if(fptr==NULL) {
			printf("\n\rError creating language.data\n\r");
			return(FALSE);
			}
		}

	if(fseek(fptr,(long)recno*sizeof(lingorec),SEEK_SET)==0)
		x=fwrite(fe,sizeof(lingorec),1,fptr);

	fclose(fptr);
	return(x);
}

int readLingotemp(lingorec *fe, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%slanguage.data.temp",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		return(x);
		}

	if(fseek(fptr,(long)recno*sizeof(lingorec),SEEK_SET)==0)
		x=fread(fe,sizeof(lingorec),1,fptr);

	fclose(fptr);
	return(x);
}

int savegroup(mfgrouprec *grp, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%sgroups.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		return(x);
		}

	if(fseek(fptr,(long)recno*sizeof(mfgrouprec),SEEK_SET)==0)
		x=fwrite(grp,sizeof(mfgrouprec),1,fptr);

	fclose(fptr);
	return(x);
}

int savelevel(levelsrec *lr, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%slevels.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		fptr=fopen(ttxt,"wb");
		if(fptr==NULL)
			mci("\r\nUnable to open %s\n\r",ttxt);	
			paws();
		}

	if(fseek(fptr,(long)recno*sizeof(levelsrec),SEEK_SET)==0)
		x=fwrite(lr,sizeof(levelsrec),1,fptr);

	fclose(fptr);
	return(x);
}

