/*****************************************************************************
 *
 * File ..................: chat.c
 * Purpose ...............: Sysop to user chat utility
 * Last modification date : 08-Feb-2001
 *
 *****************************************************************************
 * Adapted for use with the Gryphon/X BBS system
 * Darryl Perry
 * Fido: 1:211/105
 * email: dperry.geo@yahoo.com
 * Original copyright is listed below
 *****************************************************************************
 * Copyright (C) 1997-1999
 *   
 * Michiel Broek		FIDO:		2:2801/16
 * Beekmansbos 10		Internet:	mbroek@ux123.pttnwb.nl
 * 1971 BV IJmuiden
 * the Netherlands
 *
 * This file is part of MBSE BBS.
 *
 * This BBS is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * MBSE BBS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with MBSE BBS; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "structs.h"
#include "defs.h"
#include "chat.h"
#include "conio.h"
#include "mci.h"
#include "sysop.h"

#define DEVICE "/tmp/chatdev"

char pTTY[181];




void Chat(void)
{
	FILE	*pGetDev, *pBusy, *pChat;
	int	ch;
	char	sDevice[20];
	char	temp[81] = "";

/*	WhosDoingWhat(SYSOPCHAT); */

	strcpy(pTTY,ttyname(0));

	clr_scr();

	if((pGetDev = fopen(DEVICE,"r")) == NULL)
			Syslog("Can't open file: %s", DEVICE);
	else {
		fscanf(pGetDev, "%19s", sDevice);
		fclose(pGetDev);
	}

	if(( pChat = fopen(sDevice,"w")) == NULL)
		perror("Error");

	/*
	 * Check to see if it must load a external chat program
	 * Check the length of the chat program is greater than Zero
	 * Check if user has execute permisson on the chat program
	 */
	if(!config.iExternalChat || (strlen(config.sExternalChat) < 1) || \
		(access(config.sExternalChat, X_OK) != 0)) {
		if ((pBusy = fopen("/tmp/.BusyChatting", "w")) == NULL)
			Syslog("Unable to open BusyChatting file %s","/tmp/.BusyChatting");
		else {
			fprintf(pBusy, "%s", pTTY);
			fclose(pBusy);
		}

		sprintf(temp, "/tmp/.chat.%s", pTTY);
		if(( pBusy = fopen(temp, "w")) == NULL)
			Syslog("Unable to open chat.tty file %s", temp);
		else
			fclose(pBusy);

		printf("%s\n\r", (char *) lingostr(59));
		fflush(stdout);
		open_keyboard();

		Syslog("Sysop chat started");

		fprintf(pChat, "%s is ready ...  \n\r",thisuser.alias);

		while (1) {
			ch = getkey1();
			ch &= '\377';
			/* The next statement doesn't work, the chat will start again */
			if (ch == '\007') {
				Syslog("Sysop chat ended - User exited chat");
				unlink("/tmp/chatdev");
				sprintf(temp, "/tmp/.chat.%s", pTTY);
				unlink(temp);
				unlink("/tmp/.BusyChatting");
				close_keyboard();
				break;
			}
			putchar(ch);
			putc(ch, pChat);

			if (ch == '\n') {
				ch = '\r';
				putchar(ch);
				putc(ch, pChat);
			}

			if (ch == '\r') {
				ch = '\n';
				putchar(ch);
				putc(ch, pChat);
			}

			if (ch == '\b') {
				ch = ' ';
				putchar(ch);
				putc(ch, pChat);
				ch = '\b';
				putchar(ch);
				putc(ch, pChat);

			}

			/* Check if log chat is on and if so log chat to disk */
			if(access("/tmp/chatdev", R_OK) != 0) {
				printf("\n\n\n%s\n\n\r", (char *) lingostr(60));
				Syslog("Sysop chat ended");
				sprintf(temp, "/tmp/.chat.%s", pTTY);
				unlink(temp);
				unlink("/tmp/.BusyChatting");
				close_keyboard();
				mci("~SM~SP");
				break;
			}
		}
	/* End of ExternalChat Check */
	} 

	fclose(pChat);
}


