/*****************************************************************************
 *
 * File ..................: config.c
 * Purpose ...............: The main gycfg file.
 * Last modification date : 08-Feb-2001
 *
 *****************************************************************************
 * Copyright (C) 2000-2001
 *   
 * Darryl Perry			
 * FIDO:		1:211/105
 * Internet:	dperry.geo@yahoo.com
 *
 * This file is part of Gryphon/X BBS.
 *
 * This BBS is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Gryphon/X BBS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Gryphon/X BBS; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/

#include "structs.h"
#include "defs.h"
#include "acs.h"
#include "basics.h"
#include "config.h"
#include "fileio.h"
#include "cfg_fileio.h"
#include "mbasedit.h"
#include "fbasedit.h"
#include "mci.h"
#include "misc.h"
#include "menuedit.h"
#include "msgapi.h"
#include "nodedit.h"
#include "conio.h"
#include "useredit.h"

char mftxt[2][9]={"Message","File"};

void configmanager(int cm)
{
	while(cm!=0){
		switch(cm){
			case 0:	break;
			case 1:	cm=configmenu();	break;
			case 2: cm=managermenu();	break;
			}
		}
}

int configmenu()
{
	char ch,retval=0;
	int done=FALSE;

	while(!done){
		mci("~SC~SM`0ESystem Configuration~SM~SM");
		mci("`08(`0FA`08)Node Setup~SM");
		mci("`08(`0FB`08)BS Site Information~SM");
		mci("`08(`0FC`08)onfiguration Limits~SM");
		mci("`08(`0FF`08)ile System~SM");
		mci("`08(`0FL`08)ogin~SM");
		mci("`08(`0FM`08)essage System~SM");
		mci("`08(`0FN`08)ewUsers~SM");
		mci("`08(`0FO`08)ffline Mail~SM");
		mci("`08(`0FP`08)aths~SM");
		mci("`08(`0FV`08)alidation Levels~SM");
		mci("`08(`0F*`08)Manager Menu~SM");
		mci("~SM`0FConfig Menu `0F: ");
		ch=onekey("ANLBMPQV*");
		switch(ch){
			case 'A':	nodedit();			break;
			case 'B':	bbsconfigmenu(); 	break;
			case 'L':	logon_menu();		break;
			case 'M':	msgsysconfig();		break;
			case 'N':	newuser_defaults();	break;
			case 'P':	pathmenu();			break;
			case 'Q':	retval=0;			done=TRUE;			break;
			case 'V':	levelsedit();		break;
			case '*':	retval=2;			done=TRUE;			break; 
			}
		}
	return(retval);
}

int managermenu()
{
	int done=FALSE;
	char ch,retval=0;

	while(!done){
		clr_scr();
		nl();
		mci("`0ESystem Manager");nl();
		nl();
		mci("`08(`0FA`08)rchive Manager");nl();
		mci("`08(`0FC`08)all Limits Manager");nl();
		mci("`08(`0FE`08)vent Manager");nl();
		mci("`08(`0FF`08)ile Area Manager");nl();
		mci("`08(`0FG`08)roup Manager");nl();
		mci("`08(`0FL`08)anguage Manager");nl();
		mci("`08(`0FM`08)essage Area Manager");nl();
		mci("`08(`0FN`08)ode Manager");nl();
		mci("`08(`0FP`08)rotocol Manager");nl();
		mci("`08(`0FS`08)FSE Manager");nl();
		mci("`08(`0FU`08)ser Manager");nl();
		mci("`08(`0FV`08)oting Question Manager");nl();
		mci("`08(`0FW`08)Voting Results");nl();
		mci("`08(`0F#`08)Menu Manager");nl();
		mci("`08(`0F*`08)System Configuration");nl();
		nl();
		mci("`09Enter selection or (Q)uit `0F: ");
		ch=onekey("ACEFGLMNPUSVW#*Q");
		switch(ch){
			case 'C':	ModCallLimits();	break;
			case 'F':	fbeditmenu();	break;
			case 'G':	PickGrp2Mod();	break;
			case 'L':	lingoconfig();	break;
			case 'M':	mbeditmenu();	break;
			case 'N':	nodedit();		break;
			case 'Q':	retval=0;		done=TRUE;		break;
			case 'U':	useredit();		break;
			case 'S':	FSEconfig();	break;
			case '#':	menuedit();		break;
			case '*':	retval=1;		done=TRUE;		break;
			}
		}
	return(retval);
}

void bbsconfigmenu()
{
	char ch,ttxt[21];
	int done=FALSE;

	while(!done){
			mci("~SC~SM`0EBBS Config Menu~SM~SM");
			mci("`07A. BBS Name            `0F%s~SM",config.bbsname);
			mci("`07B. Location            `0F%s~SM",config.location); 
			mci("`07C. Sysop               `0F%s~SM",config.sysopname);
			mci("`07D. BBS Phone           `0F%s~SM",config.phone);
			mci("`07E. System Calls        `0F%d~SM",config.systemcalls);
		    mci("`07F. System Password     `0F%s~SM~SM",config.systempw);
			mci("`07G. SysOp log colour    `0FYes~SM");
			mci("`07H. # SysOp backlogs    `0F%d days~SM",config.logdays);
			mci("`07I. Inactivity bell     `0F%d minutes~SM",
				config.inactivebell);
			mci("`07J. Inactivity logoff   `0F%d minutes~SM",
				config.inactivelogoff);
			mci("`07K. Highbit user info   `0FNo~SM");
			mci("`07L. User info colour    `0FYes~SM~SM");

			mci("`07M. SysOp ACS           `0FSL=%3d, E=%s, F=%s~SM",
				config.SysopACS.min_sl,
				Sflag2str(&config.SysopACS.eflags),
				Sflag2str(&config.SysopACS.fflags));
			mci("`07N. Co-SysOp ACS        `0FSL=%3d, E=%s, F=%s~SM",
				config.CoSysACS.min_sl,
				Sflag2str(&config.CoSysACS.eflags),
				Sflag2str(&config.CoSysACS.fflags));
			mci("`07O. SysOp LoginPW ACS   `0FSL=%3d, E=%s, F=%s~SM",
				config.LoginACS.min_sl,
				Sflag2str(&config.LoginACS.eflags),
				Sflag2str(&config.LoginACS.fflags));
			mci("~SM`09BBS Config Menu : ");
			ch=onekey("ABCDFHMNOQ");
			switch(ch){
				case 'A':
					mci("~SMBBS Name : ");
					get_str(config.bbsname,30);
					break;
				case 'B':
					mci("~SMLocation : ");
					get_str(config.location,30);
					break;
				case 'C':
					mci("~SMSysop    : ");
					get_str(config.sysopname,40);
					break;
				case 'D':	
					mci("~SMPhone    : ");
					get_str(config.phone,65);
					break;
				case 'E':	
					mci("~SMSystem Calls: ");
					*ttxt='\0';
					get_num(ttxt);
					config.systemcalls=atoi(ttxt);	
					break;
				case 'F':
					mci("~SMSystem Password: ");
					*ttxt='\0';
					get_upcase(config.systempw,8);
					break;
				case 'H':
					mci("~SMDays to keep the logs: ");
					*ttxt='\0';
					config.logdays=get_num(ttxt);
					break;
				case 'M':	ACS_setup(&config.SysopACS,"Sysop"); break;
				case 'N':	ACS_setup(&config.CoSysACS,"Co-Sysop"); break;
				case 'O':	ACS_setup(&config.LoginACS,"Login Password"); break;
				case 'Q': 
					saveconfigdat();
					done=TRUE;
				}
		}
}

void pathmenu()
{
	char ch;
	int done=FALSE;

	getcwd(pwd,81);

	if(strlen(config.bbspath)<1)	sprintf(config.bbspath,"%s/",pwd);
	if(strlen(config.datapath)<1)	sprintf(config.datapath,"%s/data/",pwd);
	if(strlen(config.menupath)<1)	sprintf(config.menupath,"%s/menu/",pwd);
	if(strlen(config.textpath)<1)	sprintf(config.textpath,"%s/text/",pwd);
	if(strlen(config.msgspath)<1)	sprintf(config.msgspath,"%s/msgs/",pwd);
	if(strlen(config.filepath)<1)	sprintf(config.filepath,"%s/file/",pwd);
	if(strlen(config.homepath)<1)	sprintf(config.homepath,"%s/home/",pwd);

	while(!done){
		clr_scr();
		mci("%s Path Editor",PROGNAME);nl();
		nl();
		mci(" G. BBS Path  : %s",config.bbspath);nl();
		mci(" A. Data Path : %s",config.datapath);nl();
		mci(" B. Menu Path : %s",config.menupath);nl();
		mci(" C. Text Path : %s",config.textpath);nl();
		mci(" D. Msgs Path : %s",config.msgspath);nl();
		mci(" E. File Path : %s",config.filepath);nl();
		mci(" F. Home Path : %s",config.homepath);nl();
		nl();
		mci(" Path Editor (Q=Quit): ");
		ch=onekey("ABCDEFGQ");
		switch(ch){
			case 'G':
				nl();
				mci("BBS Path: ");
				get_str(config.bbspath,60);
				if(config.bbspath[strlen(config.bbspath)-1]!='/') 
					strcat(config.bbspath,"/");
				break;
			case 'A':
				nl();
				mci("Data Path: ");
				get_str(config.datapath,60);
				if(config.datapath[strlen(config.datapath)-1]!='/') 
					strcat(config.datapath,"/");
				break;
			case 'B':
				nl();
				mci("Menu Path: ");
				get_str(config.menupath,60);
				if(config.menupath[strlen(config.menupath)-1]!='/') 
					strcat(config.menupath,"/");
				break;
			case 'C':
				nl();
				mci("Text Path: ");
				get_str(config.textpath,60);
				if(config.textpath[strlen(config.textpath)-1]!='/') 
					strcat(config.textpath,"/");
				break;
			case 'D':
				nl();
				mci("Msgs Path: ");
				get_str(config.msgspath,60);
				if(config.msgspath[strlen(config.msgspath)-1]!='/') 
					strcat(config.msgspath,"/");
				break;
			case 'E':
				nl();
				mci("File Path: ");
				get_str(config.filepath,60);
				if(config.filepath[strlen(config.filepath)-1]!='/') 
					strcat(config.filepath,"/");
				break;
			case 'F':
				nl();
				mci("Home Path: ");
				get_str(config.homepath,60);
				if(config.homepath[strlen(config.homepath)-1]!='/') 
					strcat(config.homepath,"/");
				break;
			case 'Q':	
				saveconfigdat();
				done=TRUE;	
				break;
			}
		}
}

void init_config()
{
	int i;

	time_t t;

	(void) time(&t);
	config.today=localtime(&t);

	getcwd(pwd,81);
	sprintf(config.bbspath,"%s/",pwd);
	sprintf(config.datapath,"%s/data/",pwd);
	sprintf(config.menupath,"%s/menu/",pwd);
	sprintf(config.textpath,"%s/text/",pwd);
	sprintf(config.msgspath,"%s/msgs/",pwd);
	sprintf(config.filepath,"%s/file/",pwd);
	sprintf(config.homepath,"%s/home/",pwd);

	strcpy(config.DefMsg.mbpath,config.msgspath);
	strcpy(config.DefMsg.OriginLine,
			"A New Gryphon BBS : Somewhere, USA : 000-000-0000");
	config.DefMsg.colors[MSG_QUOTE]=2;
	config.DefMsg.colors[MSG_TEXT]=15;
	config.DefMsg.colors[MSG_TEAR]=14;
	config.DefMsg.colors[MSG_ORIGIN]=9;
	
	config.DefMsg.idx=0;
	config.DefMsg.Kind=LOCAL;
	config.DefMsg.Pubpriv=PUBLIC;
	config.DefMsg.Allowalias=1;
	config.DefMsg.scantype=1;
	config.DefMsg.MaxMsgs=200L;
	config.DefMsg.MaxAge=30L;
	config.DefMsg.Type=MSGTYPE_SQUISH;

	strcpy(config.bbsname,"New Gryphon BBS");
	strcpy(config.sysopname,"New Gryphon Sysop");
	strcpy(config.location,"Anywhere USA");
	strcpy(config.startmenu,"main");
	strcpy(config.systempw,"SYSOP");

	config.NewU.OpenSystem=YES;
	config.NewU.AskBDate=NO;
	config.NewU.AskRandPassw=NO;
	config.NewU.AskAnsi=ASK;
	config.NewU.AskClrScr=ASK;
	config.NewU.AskPause=ASK;
	config.NewU.AskMailAddress=NO;
	config.NewU.AskHotKeys=YES;
	config.NewU.AskGender=NO;
	config.NewU.AskDataPhone=NO;
	config.NewU.AskVoicePhone=NO;
	config.NewU.PageLen=24;
	config.NewU.ScreenLen=80;
	config.NewU.AskLang=NO;
	config.NewU.AskDateFormat=NO;
	config.NewU.AskGeoLoc=NO;
	config.NewU.AskFSE=NO;
	config.NewU_feedback=YES;
	config.newu_val=0;

	for(i=0;i<255;i++){
		config.ULim[i].LogonsPerDay=5;
		config.ULim[i].SecondsPerDay=60*60;
		config.ULim[i].DlPerDay=5;
		config.ULim[i].UlPerDay=5;
		config.ULim[i].UlKbPerDay=1000;
		config.ULim[i].DlKbPerDay=1000;
		config.ULim[i].P2CRatio=5.00;
		config.ULim[i].UlDlRatio=5.00;
		if(i>200){
			config.ULim[i].LogonsPerDay=20;
			config.ULim[i].SecondsPerDay=(24*60)*60;
			config.ULim[i].DlPerDay=0;
			config.ULim[i].UlPerDay=0;
			config.ULim[i].UlKbPerDay=0;
			config.ULim[i].DlKbPerDay=0;
			config.ULim[i].P2CRatio=0.00;
			config.ULim[i].UlDlRatio=0.00;
			}
		else {
		if(i>100){
			config.ULim[i].LogonsPerDay=10;
			config.ULim[i].SecondsPerDay=(3*60)*60;
			config.ULim[i].DlPerDay=20;
			config.ULim[i].UlPerDay=20;
			config.ULim[i].UlKbPerDay=20000;
			config.ULim[i].DlKbPerDay=20000;
			config.ULim[i].P2CRatio=10.00;
			config.ULim[i].UlDlRatio=10.00;
			}
			}
		}

	init_ACS(&config.SysopACS,255);
	init_ACS(&config.CoSysACS,200);
	init_ACS(&config.LoginACS,200);

	saveconfigdat();
}

void newuser_defaults()
{
	int done=FALSE,num;
	char ch,ttxt[21],yna1[3][19]={"No","Yes","Allow Anon."};
	levelsrec lv;

	readlevel(&lv,config.newu_val);

	while(!done){ 
		clr_scr(); 
		mci("~SM`0ENew User Applicant Configuration~SM~SM");
		mci("`07A. Open system       `0F%-20s`07M. Date of birth     `0F%s~SM",
			yna[(int)config.NewU.OpenSystem],yna[(int)config.NewU.AskBDate]);
		mci("`07B. New User level    `0F%-20c`07N. Random password   `0F%s~SM",
			config.newu_val+'A',yna[(int)config.NewU.AskRandPassw]);
		mci("`07C. Application to    `0F%-20s`07O. ANSI              `0F%s~SM",
			config.NewU_ApplyTo,yna[(int)config.NewU.AskAnsi]);
		mci("`07E. Language          `0F%-20s`07R. Clear screen      `0F%s~SM",
			yna[(int)config.NewU.AskLang],yna[(int)config.NewU.AskClrScr]);
		mci("`07F. Date format       `0F%-20s`07S. Screen pauses     `0F%s~SM",
			"mm/dd/yyyy",yna[(int)config.NewU.AskPause]);
		mci("`07G. Ask Street        `0F%-20s`07T. Hotkeys           `0F%s~SM",
			yna[(int)config.NewU.AskMailAddress],
			yna[(int)config.NewU.AskHotKeys]);
		mci("`07H. Ask City/St       `0F%-20s`07U. FSE usage         `0F%s~SM",
			yna[(int)config.NewU.AskGeoLoc],yna[(int)config.NewU.AskFSE]);
		mci("`07I. Gender            `0F%-20s`07V. Full-line input   `0F%s~SM",
			yna1[(int)config.NewU.AskGender],yna[(int)config.NewU.AskFLI]);
		mci("`07J. Email Address     `0F%-20s`07W. Page length       `0F%2d lines~SM",
			yna[(int)config.NewU.AskDataPhone],config.NewU.PageLen);
		mci("`07K. Voice phone       `0F%-20s`07X. Line length       `0F%2d columns~SM",
			yna[(int)config.NewU.AskVoicePhone],config.NewU.ScreenLen);
		mci("`07L. Scan phone/email  `0F%-20s`07Y. NewUser Feedback  `0F%s~SM~SM",yna[(int)config.NewU.AskScanPhones],yna[(int)config.NewU_feedback]);
		mci("`09New User Defaults (Q=Quit): ");
		ch=onekey("ABCDEFGHIJKLMNOPQRSTUVWXY");
		switch(ch){
			case 'A':
				config.NewU.OpenSystem=(config.NewU.OpenSystem)?0:1;break;
			case 'B':	
				nl();nl();
				mci("`09New Validation Level`0F: ");
				config.newu_val=onekey("ABCDEFGHIJKLMNOPQRSTUVWXYZ")-'A';
				break;
			case 'C':
				mci("~SM~SMNew User Apply to who?: ");
				*config.NewU_ApplyTo='\0';
				get_str(config.NewU_ApplyTo,36);
				break;
			case 'G':
				config.NewU.AskMailAddress=(config.NewU.AskMailAddress)?0:1;
				break;
			case 'H':
				config.NewU.AskGeoLoc=(config.NewU.AskGeoLoc)?0:1;break;
			case 'I':
				config.NewU.AskGender++;
				if(config.NewU.AskGender>2)
					config.NewU.AskGender=0;
				break;
			case 'J':
				config.NewU.AskDataPhone=(config.NewU.AskDataPhone)?0:1;break;
			case 'K':
				config.NewU.AskVoicePhone=(config.NewU.AskVoicePhone)?0:1;break;
			case 'L':
				config.NewU.AskScanPhones=(config.NewU.AskScanPhones)?0:1;break;
			case 'M':
				config.NewU.AskBDate=(config.NewU.AskBDate)?0:1;break;
			case 'N':
				config.NewU.AskRandPassw=(config.NewU.AskRandPassw)?0:1;break;
			case 'O':
				config.NewU.AskAnsi++;
				if(config.NewU.AskAnsi>2)
					config.NewU.AskAnsi=0;
				break;
			case 'R':
				config.NewU.AskClrScr++;
				if(config.NewU.AskClrScr>2)
					config.NewU.AskClrScr=0;
				break;
			case 'S':
				config.NewU.AskPause++;
				if(config.NewU.AskPause>2)
					config.NewU.AskPause=0;
				break;
			case 'T':
				config.NewU.AskHotKeys++;
				if(config.NewU.AskHotKeys>2)
					config.NewU.AskHotKeys=0;
				break;
			case 'U':
				config.NewU.AskFSE=(config.NewU.AskFSE)?0:1;break;
			case 'V':
				config.NewU.AskFLI=(config.NewU.AskFLI)?0:1;break;
			case 'W':
				mci("~SM~SMDefault Page Length [10-50]: ");
				*ttxt='\0';
				num=get_num(ttxt);
				if(num>=10 && num<=50)
					config.NewU.PageLen=num;
				break;
			case 'X':
				mci("~SM~SMDefault Screen Length [10-80]: ");
				*ttxt='\0';
				num=get_num(ttxt);
				if(num>=10 && num<=80)
					config.NewU.ScreenLen=num;
				break;
			case 'Q':	
				if(!saveconfigdat()) 
					{mci("~SMError");paws();}	done=TRUE;	break;
			case 'Y':
				config.NewU_feedback=(config.NewU_feedback)?0:1;break;
			}
		}
}


void modify_level(int num)
{
	int done=FALSE,num1;
	char ch,dum2[11],ttxt[11];
	levelsrec lev;

	readlevel(&lev,num);

	if(lev.tolev>0)	sprintf(dum2,"%c",lev.tolev+'A');
	else				strcpy(dum2,"N/A");
	while(!done){
		clr_scr();
		nl();
	mci("`0EValidation Level Configuration - Editing Level %c",num+'A');nl();
		nl();
		mci("`08A. Security         `0F%d",lev.sl);nl();
		mci("`08B. Description      `0F%s",lev.description);nl();
		mci("`08C. Flags 1          `0F%s",lev.EFlags);nl();
		mci("`08D. Flags 2          `0F%s",lev.FFlags);nl();
		mci("`08E. Restrictions     `0F-----------/---------");nl();
		mci("`08F. +Filepoints      `0F%d",lev.addfp);nl();
		mci("`08G. +Netcredit       `0F%d",lev.addcredit);nl();
		mci("`08H. +Timebank        `0F%d",lev.addtb);nl();
		mci("`08I. Expiry time      `0F%d days",lev.expireday);nl();
		mci("`08J. To level         `0F%s",dum2);nl();
		mci("`08   Notices");nl();
		mci("`08K.  *Upgrade        `0F\"%s\"",lev.upgradefn);nl();
		mci("`08L.  *Downgrade      `0F\"%s\"",lev.dngradefn);nl();
		nl();
		mci("`09Enter selection or (Q)uit : `0F");
		ch=onekey("CDQ");
		switch(ch){	
			case 'A':	
				mci("`09~SMNew Sec. Level`0F: `1F");
				get_num(ttxt);
				num1=atoi(ttxt);
				if(num1>0 && num<256)
					lev.sl=num1;
				break;	
			case 'C':	modflags(lev.EFlags);	break;
			case 'D':	modflags(lev.FFlags);	break;
			case 'Q':	savelevel(&lev,num);	done=TRUE;	break;
			}
		}
}
void showlevels()
{
	int i1;
	char dump[11],dum2[11];
	levelsrec lev;

		mci("`09Lev Description                              SL  +FP   +Cred +Bank ExpDay ToLev");nl();
		mci("--- ---------------------------------------- --- ----- ----- ----- ------ ---");nl();
		for(i1=0;i1<26;i1++){
			readlevel(&lev,i1);
			if(lev.active==TRUE){
				if(lev.expireday>0)	sprintf(dump,"%d",lev.expireday);
				else				strcpy(dump,"Never");
				if(lev.tolev>0)	sprintf(dum2,"%c",lev.tolev+'A');
				else				strcpy(dum2,"N/A");
				mci(" `0F%c  `0E%s",i1+'A',lev.description);
				repeat(' ',40-mcistrlen(lev.description));
				mci(" %3d %5d %5d %5d %6s %3s",
					lev.sl, lev.addfp,lev.addcredit,lev.addtb,dump,dum2);
				nl();
				}
			}
		mci("--- ---------------------------------------- --- ----- ----- ----- ------ ---");nl();
}

void levelsedit()
{
	int done=FALSE,num;
	char ch;
	levelsrec lev;

	init_levels();

	while(!done){
		clr_scr();
		nl();
		mci("`0EValidation Level Configuration");nl();
		nl();
		showlevels();
		mci("`09Validataion level editor (?=Help) : ");
		ch=onekey("DIMQ");
		switch(ch){
			case 'D':
				nl(); nl();
				mci("Delete which level? [A-Z]: ");
				num=onekey("ABCDEFGHIJKLMNOPQRSTUVWXYZ") -'A';
				readlevel(&lev,num);
				lev.active=FALSE;
				savelevel(&lev,num);
				break;
			case 'M':
				nl(); nl();
				mci("Modify which level? [A-Z]: ");
				num=onekey("ABCDEFGHIJKLMNOPQRSTUVWXYZ") -'A';
				readlevel(&lev,num);
				lev.active=TRUE;
				savelevel(&lev,num);
				modify_level(num);
				break;
			 case 'Q':	done=TRUE;	break;
			}
		}
}

void msgsysconfig()
{
	char ch;
	int done=FALSE;

	while(!done){
		clr_scr();
		mci("~SM`0EMessage System Configuration~SM~SM");
		mci("`07A. Define system addresses~SM");
		mci("`07B. Default area configuration~SM");
		mci("`07C. User access configuration~SM");
		mci("`07D. Message Reply Header:~SM:%s~SM",config.MsgReplyHdr);
		mci("~SM`09Enter selection or (Q)uit : `0F");
		ch=onekey("ABCDQ");
		switch(ch){
			case 'Q':	saveconfigdat();	done=TRUE;	break;
			case 'A':	MSC_NA();	break;
			case 'B': 	MSC_DAS();	break;
			case 'D':
				mci("~SM`09Enter new message reply header:~SM: ");
				get_str(config.MsgReplyHdr,75);
				break;
			}
		}
}

void msg_color_config(mb_list_rec *mb)
{
	int done=FALSE;
	while(!done){
		mci("~SM~SM `0F(A) Message Text : %sMessage Text",
			ansic(mb->colors[MSG_TEXT]));
		mci("~SM `0F(B) Quoted Test  : %sQuoted Text",
			ansic(mb->colors[MSG_QUOTE]));
		mci("~SM `0F(C) Tear Lines   : %s--- %s",
			ansic(mb->colors[MSG_TEAR]),PROGNAME);
		mci("~SM `0F(D) Origin Lines : %s * Origin (1:234/567.890)~SM",
			ansic(mb->colors[MSG_ORIGIN]));

		mci("~SM`09Select (ABCD, Q=Quit): `0F");
		switch(onekey("ABCDQ")){
			case 'A':
				mci("~SM~SM`0FMessage Text Color~SM");
				mb->colors[MSG_TEXT]=input_color();	
				break;
			case 'B':
				mci("~SM~SM`0FQuote Text Color~SM");
				mb->colors[MSG_QUOTE]=input_color();	
				break;
			case 'C':
				mci("~SM~SM`0FTear Line Color~SM");
				mb->colors[MSG_TEAR]=input_color();	
				break;
			case 'D':
				mci("~SM~SM`0FOrigin Line Color~SM");
				mb->colors[MSG_ORIGIN]=input_color();	
				break;
			case 'Q': done=TRUE;	break;
			}
		}	
}

void MSC_DAS()
{
	int done=FALSE;
	char ch,ttxt[11],faka[21];
	char scantxt[3][16]={"Default ON","Default OFF","Mandatory"};
	char mbkind[5][11]={"Local","Netmail","Echomail","Email","News"};
	char annony[6][21]={"Yes","No","Forced Anony","Dear Abby",
						"Any Name","Realname/Handle"};

	while(!done){
	faddr2char(faka,&config.aka[config.DefMsg.fidoaddr]);
	clr_scr();
	mci("~SM`0EMessage System Configuration - Default Area Setup~SM~SM");
	mci("`07A. Area format      `0F%s~SM",
		config.DefMsg.Type==MSGTYPE_JAM?"Jam":"Squish");
	mci("`07B. Message path     \"`0F%s`07\"~SM",config.DefMsg.mbpath);
	mci("`07C. Reading ACS      : SL=%3d, E=[%s], F=[%s]~SM",
		config.DefMsg.ReadACS.min_sl,
		Sflag2str(&config.DefMsg.ReadACS.eflags),
		Sflag2str(&config.DefMsg.ReadACS.fflags));
	mci("`07D. Posting ACS      : SL=%3d, E=[%s], F=[%s]~SM",
		config.DefMsg.WriteACS.min_sl,
		Sflag2str(&config.DefMsg.WriteACS.eflags),
		Sflag2str(&config.DefMsg.WriteACS.fflags));
	mci("`07E. Network ACS      : SL=%3d, E=[%s], F=[%s]~SM",
		config.DefMsg.NetworkACS.min_sl,
		Sflag2str(&config.DefMsg.NetworkACS.eflags),
		Sflag2str(&config.DefMsg.NetworkACS.fflags));
	mci("`07F. SysOp ACS        : SL=%3d, E=[%s], F=[%s]~SM",
		config.DefMsg.SysopACS.min_sl,
		Sflag2str(&config.DefMsg.SysopACS.eflags),
		Sflag2str(&config.DefMsg.SysopACS.fflags));
	mci("`07G. Area type        `0F%s`07~SM",mbkind[config.DefMsg.Kind]);
	mci("`07H. Scan type        `0F%s`07~SM",scantxt[config.DefMsg.scantype]);
	mci("`07J. Annonymous       `0F%s`07~SM",annony[config.DefMsg.Allowalias]);
	mci("`07K. Mail address     `0F%s`07~SM",faka);
	mci("`07L. Max Msgs         `0F%u`07~SM",config.DefMsg.MaxMsgs);
	mci("`07M. Max Age          `0F%u`07~SM",config.DefMsg.MaxAge);
	mci("`07O. Colors           `0F");
	mci("%sQuote(%d)`07, ",
		ansic(config.DefMsg.colors[MSG_QUOTE]),
		config.DefMsg.colors[MSG_QUOTE]);
	mci("%sText(%d)`07, ",
		ansic(config.DefMsg.colors[MSG_TEXT]),
		config.DefMsg.colors[MSG_TEXT]);
	mci("%sTear(%d)`07, ",
		ansic(config.DefMsg.colors[MSG_TEAR]),
		config.DefMsg.colors[MSG_TEAR]);
	mci("%sOrigin(%d)",
		ansic(config.DefMsg.colors[MSG_ORIGIN]),
		config.DefMsg.colors[MSG_ORIGIN]);
	mci("~SM`07N. Origin line      \"`0F%s`07\"~SM",config.DefMsg.OriginLine);
	mci("~SM`09Message area manager (?=Help) : `0F");
	ch=onekey("ABCDEFGHIJKLMNOPQ");
		switch(ch){
			case 'A':
				if(config.DefMsg.Type==MSGTYPE_JAM) 	
					config.DefMsg.Type=MSGTYPE_SQUISH;
				else 
					config.DefMsg.Type=MSGTYPE_JAM;
				break;
			case 'B':
				mci("~SM`09Default Message Base Path: ~SM: `1F");
				get_filename(config.DefMsg.mbpath,65);
				break;
			case 'C':	ACS_setup(&config.DefMsg.ReadACS,"");	break;
			case 'D':	ACS_setup(&config.DefMsg.WriteACS,"");	break;
			case 'E':	ACS_setup(&config.DefMsg.NetworkACS,"");	break;
			case 'F':	ACS_setup(&config.DefMsg.SysopACS,"");	break;
			case 'G':		
				config.DefMsg.Kind++;
				if(config.DefMsg.Kind>4)
					config.DefMsg.Kind=0;
				break;
			case 'H':		
				config.DefMsg.scantype++;
				if(config.DefMsg.scantype>2)
					config.DefMsg.scantype=0;
				break;
			case 'J':		
				config.DefMsg.Allowalias++;
				if(config.DefMsg.Allowalias>5)
					config.DefMsg.Allowalias=0;
				break;
			case 'K':
				config.DefMsg.fidoaddr=pick_aka();
				break;
			case 'L':
				mci("~SMMaximum Number of Messages:");
				*ttxt='\0';
				config.DefMsg.MaxMsgs=get_num(ttxt);
				break;
			case 'M':
				mci("~SMMaximum Message Age:");
				*ttxt='\0';
				config.DefMsg.MaxAge=get_num(ttxt);
				break;
			case 'O':
				msg_color_config(&config.DefMsg);
				break;
			case 'N':
				mci("~SMDefault Origin Line~SM:");
				get_str(config.DefMsg.OriginLine,65);
				break;
			case 'Q':	done=TRUE;	break;
			}
		}
}

void edit_aka(int num)
{
	char ttxt[16];
	char *p;

	mci("~SM`09Enter Fido Address: `0F");
	ttxt[0]='\0';
	get_aka(ttxt);

	p=strtok(ttxt,":/.");
	if(p)	config.aka[num].zone=atoi(p);
	p=strtok(NULL,":/.");
	if(p)	config.aka[num].net=atoi(p);
	p=strtok(NULL,":/.");
	if(p)	config.aka[num].node=atoi(p);
	p=strtok(NULL,":/.");
	if(p)	config.aka[num].point=atoi(p);

	mci("~SM`09Domain`0F: `1F");
	ttxt[0]='\0';
	get_str(config.aka[num].domain,21);
}

void list_akas()
{
	int i;
	char akas[41];

	mci("~SM`0EMessage System Configuration - Network Addresses~SM~SM");
	mci("`09## Address           MatchAKA NetArea   ");
	mci("## Address           MatchAKA NetArea   ");nl();
	mci("-- ----------------- -------- --------  ");
	mci("-- ----------------- -------- --------  ");nl();
	for(i=0;i<10;i++){
		faddr2char(akas,&config.aka[i]);
		mci("`0F%-2d `0E%-17.17s %-18.18s",i+1,akas,config.aka[i].domain);
		faddr2char(akas,&config.aka[i+10]);
		mci("`0F%-2d `0E%-17.17s %-18.18s",i+11,akas,config.aka[i+10].domain);
		nl();
		}
}

void MSC_NA()
{
	int done=FALSE;
	int num;
	char ch,ttxt[5];

	while(!done){
		clr_scr();
		mci("~SM`0EMessage System Configuration - Network Addresses~SM~SM");
		list_akas();
		mci("~SM`09Network address configuration (?=Help) :`0F");
		ch=onekey("\rQDM?");
		switch(ch){
			case '?':
				mci("~SM~SM<ENTER>:Redisplay    (Q)uit~SM");
				mci("(D)elete address     (M)odify address~SM");
				break;
			case 'Q':
				saveconfigdat();
				done=TRUE;
				break;
			case 'D':
				break;
			case 'M':
				mci("~SM~SM`09Modify which? : ");
				ttxt[0]='\0';
				num=get_num(ttxt)-1;
				if(num>=0 && num<20)
					edit_aka(num);	
				break;	
			}
		}
}

void logon_menu()
{
	int done=FALSE;
	char ttxt[41],lctxt[2][11]={"Real Names","Aliases"};
	char entxt[2][11]={"Disabled","Enabled"};
	char RealA[2][16]={"Real Names","Handles Only"};

	while(!done){
		sprintf(ttxt,"%d seconds",config.KbTimeOut);
		clr_scr();
		mci("~SMLogin Procedure Configuration~SM~SM");
		mci("`07A. Ansi Login           `0F%-16s ",yna[(int)config.AllowAnsi]);
		mci("`07N. Hack warning area    `0F%s~SM",config.hackwarnarea);
		mci("`07B. Login attempts       `0F%2d attempts      ",config.LogTrys);
		mci("`07O. PW inquiry area      `0F%s~SM",config.pwinqarea);
		mci("`07C. Login timelimit      `0F%2d min.          ",config.LogMin);
		mci("`07P. Last callers kept    `0F%d Days~SM",config.LcAge);
		mci("`07D. Check email addy     `0F%-16s ",
				entxt[(int)config.CheckEmail]);
		mci("`07R. Password updates     `0F%d days~SM",config.PwAge);
		mci("`07E. Check voice #        `0F%-16s ",
				entxt[(int)config.CheckVoice]);
		mci("`07S. Alias/Handles        `0F%s~SM",RealA[(int)config.RnOrAl]);
		mci("`07F.                      `0F%-16s ","");
		mci("`07T. Login last callers   `0F%s~SM",
				lctxt[(int)config.LoginLastCall]);
		mci("`07G. Hide Sysop           `0F%-16s ",yna[(int)config.hidesysop]);
		mci("`07U. Login menu           `0F%s~SM",config.startmenu); 
		mci("`07H. Inactivity Timeout   `0F%-16s ",ttxt);
		mci("`07V. Add Sysop To Stats   `0F%s~SM",
				entxt[(int)config.Sysop2Stats]);
		mci("`07I. Force voting         `0F%-16s ",yna[(int)config.ForceVote]);
		mci("`07W. No timeleft bank?    `0F%s~SM",entxt[(int)config.NoTlBank]);
		mci("`07J. Check multi-logins   `0F%-16s ",
				entxt[(int)config.ChkMltiLogins]);
		mci("`07X. Language prompt      `0F%s~SM",entxt[(int)config.AskLingo]);
		mci("`07K. UNIX name of Sysop   `0F%s~SM",config.unixsysop); 
		mci("`07L. Fast Sysop Login?    `0F%s~SM",yna[config.fastsysoplogon]);
		mci("`07M. ~SM"); 

		mci("~SM`09Enter selection or (Q)uit : ");
		switch(onekey("ABCDEFGHIJKLNOPQRSTUVWXY")){
			case 'A':	config.AllowAnsi=(config.AllowAnsi)?0:1; 	break;
			case 'B':	
				mci("~SM~SMNumber of Trys to Login: ");
				*ttxt='\0';
				config.LogTrys=get_num(ttxt);
				break;
			case 'C':	
				mci("~SM~SMNumber of Minutes to Login: ");
				*ttxt='\0';
				config.LogMin=get_num(ttxt);
				break;
			case 'D':	config.CheckEmail=(config.CheckEmail)?0:1;	break;
			case 'E':	config.CheckVoice=(config.CheckVoice)?0:1;	break;
			case 'G':	config.hidesysop=(config.hidesysop)?0:1;	break;
			case 'H':
				mci("~SM`09Inactivity timeout in seconds: (`0F180`09)`0F: ");
				*ttxt='\0';
				config.KbTimeOut=get_num(ttxt);
				break;
			case 'I':	config.ForceVote=(config.ForceVote)?0:1;	break;
			case 'J':	config.ChkMltiLogins=(config.ChkMltiLogins)?0:1;break;
			case 'K':
				mci("~SMThe UNIX name of the sysop.~SMThis person will be able to log on quickly.~SM: ");
				*ttxt='\0';
				get_filename(ttxt,8);
				strcpy(config.unixsysop,ttxt);
				break;
			case 'L':
				config.fastsysoplogon=(config.fastsysoplogon)?FALSE:TRUE;
				break;
			case 'N':
				mci("~SM~SMMessage Area Filename to Send Hack Warnings~SM: ");
				*config.hackwarnarea='\0';
				get_str(config.hackwarnarea,35);
				break;
			case 'O':
				mci("~SM~SMMessage Area Filename to Send PW inquiries~SM: ");
				*config.pwinqarea='\0';
				get_str(config.pwinqarea,35);
				break;
			case 'P':
				mci("~SM~SMDays to keep Last Call:  ~SM: ");
				*ttxt='\0';
				config.LcAge=get_num(ttxt);
				break;
			case 'Q':	saveconfigdat();	done=TRUE; break;
			case 'R':
				mci("~SM~SMDays Before Changing PW:  ~SM: ");
				*ttxt='\0';
				config.PwAge=get_num(ttxt);
				break;
			case 'S':	config.RnOrAl=(config.RnOrAl)?0:1;	break;
			case 'T':	config.LoginLastCall=(config.LoginLastCall)?0:1;break;
			case 'U':
				mci("~SMLogin Menu Name: ");
				get_filename(config.startmenu,30);
				break;
			case 'V':	config.Sysop2Stats=(config.Sysop2Stats)?0:1;	break;
			case 'W':	config.NoTlBank=(config.NoTlBank)?0:1;	break;
			case 'X':	config.AskLingo=(config.AskLingo)?0:1;	break;
			}
		}

}


unsigned char input_color()
{
	unsigned char ret;
	int FG,BG,BL,IN; 
	int fg,bg,bl,in;
	char ttxt[11];
	char inttxt[2][11]={"Normal","Bold"};
	char blntxt[2][11]={"","Blinking"};
	char colorstr[8][11]={"Black","Blue","Green","Cyan",
							"Red","Pink","Yellow","White"};

	FG=BG=BL=IN=0;
	fg=bg=bl=in=0;
	do{
		mci("~SM`09Foreground (0-15): `0F");
		*ttxt='\0';
		FG=get_num(ttxt);
		}while(FG<0 || FG>15);

	fg=FG;

	if(FG>8){
		IN=1;
		FG-=8;
		}

	do{
		mci("~SM`0FBackground (0-7) : `0F");
		*ttxt='\0';
		BG=get_num(ttxt);
		}while(BG<0 || BG>7);

	
	mci("~SM`0CBlink? [y/n]: `0F");
	if(onekey("YN")=='Y')	BL=1;

	if(BL){
		bl+=8;
		ret+=bl;
		}

	ret=bg;
	ret=ret<<4;
	ret+=fg;

	mci("~SM`0FYou Selected :%s %s %s %s on %s",
			ansic(ret),blntxt[BL],inttxt[IN],colorstr[FG],colorstr[BG]);

	mci("~SM`09Is this ok? (Y/n): `0F");
	if(onekey("YN")=='N')
		ret=105;

	return(ret);	
}

void ModCallLimits()
{
	int done=FALSE,slnum=0,num;
	char ch,ttxt[41];

	while(!done){
		clr_scr();
		show_timeleft(config.ULim[slnum].SecondsPerDay,ttxt);
		mci("~SMCall Limits Manager~SM~SM");
		mci("Daily Limits for Security Level %d~SM~SM",slnum+1);
		mci("A. Max. Logons     : %d~SM",config.ULim[slnum].LogonsPerDay);
		mci("B. Max. Minutes    : %s~SM",ttxt);
		mci("C. Max. Downloads  : %u KBytes~SM",config.ULim[slnum].DlKbPerDay);
		mci("D. Max. Uploads    : %u Kbytes~SM",config.ULim[slnum].UlKbPerDay);
		mci("E. Max. Downloads  : %u files~SM",config.ULim[slnum].DlPerDay);
		mci("F. Max. Uploads    : %u files~SM",config.ULim[slnum].UlPerDay);
		mci("G. Ul/Dl Ratio     : %2.2f~SM",config.ULim[slnum].UlDlRatio);
		mci("H. Post/Call Ratio : %2.2f~SM",config.ULim[slnum].P2CRatio);
		mci("~SMSelect ([/]=Prev/Next, A-M, ?=Help Q=Quit): ");
		ch=onekey("ABCDEFGHJQ[]");
		switch(ch){
			case '[':	
				slnum--;
				if(slnum<0)
					slnum=254;
				break;
			case ']':
				slnum++;
				if(slnum>254)
					slnum=0;
				break;
			case 'A':
				mci("~SM`09How many logons per day? : ");
				*ttxt='\0';
				num=get_num(ttxt);
				if(num>0 && num<=32000)
					config.ULim[slnum].LogonsPerDay=num;
				break;
			case 'B':
				mci("~SM`09How many Minutes Per Day? (1-1440): ");
				*ttxt='\0';
				num=get_num(ttxt);
				if(num>0 && num<=1440)
					config.ULim[slnum].SecondsPerDay=num*60;
				break;
			case 'J':
				mci("~SM`09Jump to which? (`0F1-255`09)`0F: ");
				*ttxt='\0';
				num=get_num(ttxt)-1;	
				if(num>=0 && num <255)
					slnum=num;
				break;
			case 'Q':	done=TRUE;	break;
			}
		}
	saveconfigdat();
}

void initgroup(mfgrouprec *grp)
{
	strcpy(grp->grp[0].display,"New Message Group");
	strcpy(grp->grp[1].display,"New File Group");
	grp->grp[0].isused=FALSE;
	grp->grp[1].isused=FALSE;
	init_ACS(&grp->grp[0].ACS,5);
	init_ACS(&grp->grp[1].ACS,5);
}

int creategroups()
{
	int i=0;
	mfgrouprec grp;

	for(i=0;i<26;i++){
		if(!readgroup(&grp,i)){
			initgroup(&grp);
			if(!savegroup(&grp,i)){
				mci("~SMError saving group %c~SM~SP",i+'A');
				}
			}
		}
	return i;
}

void PickGrp2Mod()
{
	char ch;

	mci("~SMModify which group type?");
	mci("~SM(A) Message Groups");
	mci("~SM(B) File Groups");
	mci("~SM~SMSelect (AB, Q=Quit): ");
	ch=onekey("ABQ");
	if(ch=='Q')	return;
	GroupEdit(ch-'A');
}

void modgrp(int gnum, int mf)
{
	int done=FALSE;
	mfgrouprec grp;

	readgroup(&grp,gnum);

	while(!done){
		mci("~SC~SMModify %s Group (%c)~SM~SM",mftxt[mf],gnum+'A');
		mci("(A) Display     : %s~SM",grp.grp[mf].display);
		mci("(B) ACS         : %d ",grp.grp[mf].ACS.min_sl);
		mci("~SM~SMSelect (AB, Q=Quit): ");
		switch(onekey("ABQ")){
			case 'A':	
				mci("~SMDisplay: ");
				get_str(grp.grp[mf].display,30);
				break;
			case 'B':
				ACS_setup(&grp.grp[mf].ACS,"");
				break;
			case 'Q':	
				savegroup(&grp,gnum);
				done=TRUE;	break;
			}
		}
}

void GroupEdit(int mf)
{
	int i=0,done=FALSE;
	char ch;
	mfgrouprec grp;
	
	creategroups();

	while(!done){
		mci("~SC~SM%s Group Edit~SM~SM",mftxt[mf]);
		mci("~SMKey Display                        ACS");
		mci("~SM--- ------------------------------ ---");
		i=0;
		while(readgroup(&grp,i)){
			if(grp.grp[mf].isused){
				mci("~SM %c  %-30.30s %d",
					i+'A',grp.grp[mf].display,grp.grp[mf].ACS.min_sl);
				}
			i++;
			}
		mci("~SM~SM`09Edit Group (?=Help, Q=Quit): ");
		switch(onekey("DMQ")){
			case 'Q':	done=TRUE;	break;
			case 'M':	
				mci("~SMModify which group? (A-Z): ");
				ch=onekey("ABCDEFGHIJKLMNOPQRSTUVWXYZ");
				if(ch!='\n'){
					readgroup(&grp,ch-'A');
					grp.grp[mf].isused=TRUE;
					savegroup(&grp,ch-'A');
					modgrp(ch-'A',mf);
					}
				break;
			case 'D':
				mci("~SMDelete which group? (A-Z): ");
				ch=onekey("ABCDEFGHIJKLMNOPQRSTUVWXYZ");
				if(ch!='\n'){
					readgroup(&grp,ch-'A');
					grp.grp[mf].isused=FALSE;
					savegroup(&grp,ch-'A');
					}
				break;
			}
		}
}

void init_levels()
{
	char ppath[81];
	levelsrec lev;
	int i1;

	sprintf(ppath,"%slevels.data",config.datapath);
	if(exist(ppath))	return;

	for(i1=0;i1<26;i1++){
		strcpy(lev.description,"");
		strcpy(lev.EFlags,"--------------------------");
		strcpy(lev.FFlags,"--------------------------");
		strcpy(lev.upgradefn,"");
		strcpy(lev.dngradefn,"");
		lev.active=FALSE;
		lev.sl=0;
		lev.addfp=0;
		lev.addcredit=0;
		lev.addtb=0;
		lev.tolev=0;
		lev.expireday=0;
		savelevel(&lev,i1);
		}

	strcpy(lev.description,"New User");
	strcpy(lev.EFlags,"--------------------------");
	strcpy(lev.FFlags,"--------------------------");
	lev.active=TRUE;
	lev.sl=5;
	savelevel(&lev,0);
	
	strcpy(lev.description,"Twit User");
	strcpy(lev.EFlags,"--------------------------");
	strcpy(lev.FFlags,"--------------------------");
	lev.active=TRUE;
	lev.sl=1;
	savelevel(&lev,1);
	
	strcpy(lev.description,"Regular User");
	strcpy(lev.EFlags,"--------------------------");
	strcpy(lev.FFlags,"--------------------------");
	lev.active=TRUE;
	lev.sl=20;
	savelevel(&lev,5);
	
	strcpy(lev.description,"Sysop Level");
	strcpy(lev.EFlags,"--------------------------");
	strcpy(lev.FFlags,"--------------------------");
	lev.active=TRUE;
	lev.sl=255;
	savelevel(&lev,25);
}

