/*****************************************************************************
 *
 * File ..................: fbasedit.c
 * Purpose ...............: File Base Editor Routines.
 * Last modification date : 08-Feb-2001
 *
 *****************************************************************************
 * Copyright (C) 2000-2001
 *   
 * Darryl Perry			
 * FIDO:		1:211/105
 * Internet:	dperry.geo@yahoo.com
 *
 * This file is part of Gryphon/X BBS.
 *
 * This BBS is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Gryphon/X BBS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Gryphon/X BBS; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/

#include "structs.h"
#include "defs.h"
#include "acs.h"
#include "basics.h"
#include "config.h"
#include "fileio.h"
#include "mci.h"
#include "misc.h"
#include "fbasedit.h"
#include "conio.h"

void fbeditmenu()
{
	int done=FALSE,page=0;
	char ch;
	
	while(!done){
		clr_scr();
		mci("~SM`0EFile Area Manager`09~SM~SM");
		mci("`09Area# Description               Filename        File Path~SM"); 
		mci("`09----- ------------------------- --------------- ------------------------------~SM");
		list_file_bases(page);mci("`09");
		mci("~SM~SMFile Editor (]/[=Next/Prev, Q=Quit, ?=Help)`0F: ");
		ch=onekey("[]IMDPQ");
		switch(ch){
			case 'D':	delete_fbase();	break;
			case 'I': 	insert_fbase();	break;
			case 'M':	modify_fbase();	break;
			case 'P':	move_fbase();	break;
			case 'Q': 	done=TRUE;		break;
			}
		}
	nl();nl();
}

void list_file_bases(int page)
{
	int i1,rno;
	fb_list_rec fbl;
	char disp[61];

	for(i1=0;i1<15;i1++){
		rno=(page*15);
		if(read_fbaselist(&fbl,rno+i1)){
			strcpy(disp,fbl.fbdisplay);
			mcistrset(disp,25);
			mci("`0F%5d `0E%s `0F%-15.15s `09%-30.30s",
				rno+1+i1,disp,fbl.fbfile,fbl.fbpath);
			}
		else {
			mci("`0F%5d",rno+1+i1);
			}
		nl();
		}
}

void init_fbase(fb_list_rec *fb)
{
	strcpy(fb->fbdisplay,"New File Area");
	strcpy(fb->fbfile,"new_file_datafile");
	strcpy(fb->fbpath,"/home/ftp/");
	strcpy(fb->password,"");
	init_ACS(&fb->ReadACS,(unsigned char)5);
	init_ACS(&fb->WriteACS,(unsigned char)5);
	init_ACS(&fb->SysopACS,(unsigned char)200);
/*	char colors[4]; */
	fb->scantype=0;
	fb->MaxFiles=500;
	fb->MaxAge=730;
}

void kill_fbase(int fbnum)
{
	fb_list_rec fbin;
	int i1,count=0;
	char ppath[81];

	i1=0;
	while(read_fbaselist(&fbin,i1)){
		if(i1!=fbnum){
			fbin.idx=count;
			count++;
			if(!save_fbasetemp(&fbin,fbin.idx)){
				mci("Error saving to temp file.");nl();
				}
			}
		i1++;	
		}

	sprintf(ppath,"%sfbases.data",config.datapath); 
	remove(ppath);
	i1=0;
	while(read_fbasetemp(&fbin,i1)){
		save_fbaselist(&fbin,fbin.idx);
		i1++;
		}
	sprintf(ppath,"%sfbases.data.temp",config.datapath); 
	remove(ppath);
	total_fbases--;
}

void delete_fbase()
{
	char ttxt[21];
	int num;

	nl();
	mci("Delete which? [1-%d]: ",total_fbases);
	*ttxt='\0';
	num=get_num(ttxt);
	if(num>=0 && num<=total_fbases){
		kill_fbase(num);
		}
}

void poke_fbase(int pokenum)
{
	fb_list_rec fbin;
	int i1;

	if(total_fbases>0){
		for(i1=total_fbases;i1>pokenum;i1--){
			printf("\n\rA");
			read_fbaselist(&fbin,i1-1);
			printf("\n\rB");
			fbin.idx++;
			printf("\n\rC");
			save_fbaselist(&fbin,fbin.idx);
			printf("\n\rD");
			}
		}
	else
		pokenum=0;
	init_fbase(&fbin);
	fbin.idx=pokenum;
	save_fbaselist(&fbin,fbin.idx);
	total_fbases++;
}

void insert_fbase()
{
	char ttxt[21];
	int num;
	fb_list_rec fbin;

	nl();
	mci("Insert before which? [1-%d]: ",total_fbases+1);
	*ttxt='\0';
	num=get_num(ttxt)-1;
	if(num>=0 && num<=total_fbases){
		if(num==0 && total_fbases==0){
			init_fbase(&fbin);
			fbin.idx=total_fbases;
			save_fbaselist(&fbin,fbin.idx);
			total_fbases++;
			}
		else{
			poke_fbase(num);
			}
		}
	else {
		nl();
		mci("Invalid nufber.  Try again!");nl();
		paws();
		}
}

void swap_fbase(int iFrom, int iTo)
{
	fb_list_rec fbto,fbfrom;
	int i1;


	read_fbaselist(&fbfrom,iFrom);

	if(iFrom<iTo){
		for(i1=iFrom+1;i1<=iTo;i1++){
			read_fbaselist(&fbto,i1);
			fbto.idx--;
			save_fbaselist(&fbto,fbto.idx);
			}
		}
	else{
		for(i1=iFrom;i1>iTo;i1--){
			read_fbaselist(&fbto,i1-1);
			fbto.idx++;
			save_fbaselist(&fbto,fbto.idx);
			}
		}

	fbfrom.idx=iTo;
	save_fbaselist(&fbfrom,fbfrom.idx);
}


void move_fbase()
{
	char ttxt[21],ttxt1[21];
	int num,num1;

	nl();
	mci("Position which? [1-%d]: ",total_fbases);
	*ttxt1='\0';
	num1=get_num(ttxt1)-1;
	if(num1>=0 && num1<total_fbases){
		mci("`09    Move to which? [1-%d]: ",total_fbases);
		*ttxt='\0';
		num=get_num(ttxt)-1;
		if(num>=0 && num<total_fbases)
			swap_fbase(num1,num);
		else {
			nl();
			mci("Invalid nufber.  Try again!");nl();
			paws();
			}
		}
	else{
		nl();
		mci("Invalid Nufber.  Try again!");nl();
		paws();
		}
}


void modify_fbase()
{
	char ttxt[21];
	int num;

	nl();
	mci("Modify which? [1-%d]: ",total_fbases);
	*ttxt='\0';
	num=get_num(ttxt)-1;
	num=atoi(ttxt)-1;
	if(num>=0 && num<=total_fbases){
		mod_fbase(num);
		}
}

void mod_fbase(int fbnum)
{
	int done=FALSE,yr,mo;
	char ch,ttxt[11],*sttxt[3]={"Default ON","Default OFF","Manditory"};
	fb_list_rec fbl;

	read_fbaselist(&fbl,fbnum);
	yr=fbl.MaxAge/365;
	mo=(fbl.MaxAge-(yr*365))/30;
	while(!done){
		clr_scr();
		mci("~SM`0EModifying File Base %d of %d~SM~SM",fbnum+1,total_fbases);
		mci("`07(A) Area Name         : `0F%s~SM",fbl.fbdisplay);
		mci("`07(B) Database Filename : `0F%s~SM",fbl.fbfile);
		mci("`07(C) Directory Path    : `0F%s~SM",fbl.fbpath);
		mci("`07(D) List Security     : `0FSL=%3d, E=[%s], F=[%s]~SM",
			fbl.ReadACS.min_sl,
			Sflag2str(&fbl.ReadACS.eflags),
			Sflag2str(&fbl.ReadACS.fflags));
		mci("`07(E) Upload Security   : `0FSL=%3d, E=[%s], F=[%s]~SM",
			fbl.WriteACS.min_sl,
			Sflag2str(&fbl.WriteACS.eflags),
			Sflag2str(&fbl.WriteACS.fflags));
		mci("`07(F) Sysop Security    : `0FSL=%3d, E=[%s], F=[%s]~SM",
			fbl.SysopACS.min_sl,
			Sflag2str(&fbl.SysopACS.eflags),
			Sflag2str(&fbl.SysopACS.fflags));
		mci("`07(G) Maximnum Files    : `0F%d~SM",fbl.MaxFiles);
		mci("`07(H) Maximnum Files Age: `0F%d (%d years, %d months)~SM",
			fbl.MaxAge,yr,mo);
		mci("`07(I) Scan Type         : `0F%s~SM",sttxt[(int)fbl.scantype]);
		mci("~SM`09Modify Messegebase (]/[=Next/Prev, Q=Quit ?=Help)`0F: ");
		ch=onekey("ABCDEFGHIJKLQ");
		switch(ch){
			case 'A':
				mci("~SM`09Area Name: `0F");
				get_str(fbl.fbdisplay,60);
				break;
			case 'B':
				mci("~SM`09Database File Name: `0F");
				get_filename(fbl.fbfile,35);
				break;
			case 'C':
				mci("~SM`09Directory Path: ~SM`0F");
				get_filename(fbl.fbpath,75);
				break;
			case 'D':	ACS_setup(&fbl.ReadACS,"");	break;
			case 'E':	ACS_setup(&fbl.WriteACS,"");	break;
			case 'F':	ACS_setup(&fbl.SysopACS,"");	break;
			case 'G':
				mci("~SM`09Maximum Files: `0F");
				*ttxt='\0';
				fbl.MaxFiles=get_num(ttxt);
				break;
			case 'H':
				mci("~SM`09Maximum Files Age (days): `0F");
				*ttxt='\0';
				fbl.MaxAge=get_num(ttxt);
				yr=fbl.MaxAge/365;
				mo=(fbl.MaxAge-(yr*365))/30;
				break;
			case 'I':	
				fbl.scantype++;
				if(fbl.scantype>2)
					fbl.scantype=0;
				break;
			case '[':
				save_fbaselist(&fbl,fbnum);
				if(fbnum>0)	fbnum--;	
				else		fbnum=0;
				read_fbaselist(&fbl,fbnum);
				break;
			case ']':
				save_fbaselist(&fbl,fbnum);
				if(fbnum<total_fbases)	fbnum++;	
				else					fbnum=total_fbases-1;
				read_fbaselist(&fbl,fbnum);
				break;
			case 'Q':	
				save_fbaselist(&fbl,fbnum); 
				done=TRUE;
				break;
			}
		}
}
