/*****************************************************************************
 *
 * File ..................: fileio.c
 * Purpose ...............: File IO Routines.
 * Last modification date : 08-Feb-2001
 *
 *****************************************************************************
 * Copyright (C) 2000-2001
 *   
 * Darryl Perry			
 * FIDO:		1:211/105
 * Internet:	dperry.geo@yahoo.com
 *
 * This file is part of Gryphon/X BBS.
 *
 * This BBS is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Gryphon/X BBS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Gryphon/X BBS; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/

#include "structs.h"
#include "defs.h"
#include "basics.h"
#include "fileio.h"
#include "mci.h"
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>

int save_usr(userrec *ur, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%susers.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		fptr=fopen(ttxt,"wb");
		if(fptr==NULL) {
			printf("\n\rError creating users.data\n\r");
			return(FALSE);
			}
		}

	if(fseek(fptr,(long)recno*sizeof(userrec),SEEK_SET)==0)
		x=fwrite(ur,sizeof(userrec),1,fptr);

	fclose(fptr);
	return(x);
}



int read_usr(userrec *ur, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%susers.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		return(x);
		}
	if(fseek(fptr,(long)recno*sizeof(userrec),SEEK_SET)==0){
		x=fread(ur,sizeof(userrec),1,fptr);
		}

	fclose(fptr);
	return(x);
}

int savenode(noderec *nr, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%snode.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		fptr=fopen(ttxt,"wb");
		if(fptr==NULL) {
			nl();
			printf("Error creating node.data");nl();
			return(FALSE);
			}
		}

	if(fseek(fptr,(long)recno*sizeof(noderec),SEEK_SET)==0)
		x=fwrite(nr,sizeof(noderec),1,fptr);

	fclose(fptr);
	return(x);
}

int readnode(noderec *nr, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%snode.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		return(x);
		}

	if(fseek(fptr,(long)recno*sizeof(noderec),SEEK_SET)==0)
		x=fread(nr,sizeof(noderec),1,fptr);

	fclose(fptr);
	return(x);
}

int readconfigdat()
{
	FILE *fptr;
	char path[81];

	sprintf(path,"%sconfig.data",config.bbspath);
	fptr=fopen(path,"rb");
	if(fptr==NULL){
		return(0);
		}
	else{
		fread(&config,sizeof(configrec),1,fptr);
		fclose(fptr);
		}
	return(1);
}

int saveconfigdat()
{
	FILE *fptr;
	int retval=0;
	char path[81];

	sprintf(path,"%sconfig.data",config.bbspath);

	fptr=fopen(path,"wb");
	if(fptr==NULL){
		printf("\r\n\nUnable to save %s!!!\n\r",path);
		paws();
		retval=0;
		}
	else{
		if(fwrite(&config,sizeof(configrec),1,fptr)==1){
			retval=1;
			}
		else{
			mci("~SMUnable to save $s file~SM",path);
			paws();
			retval=0;
			}
		fclose(fptr);
		}
	return(retval);
}

int readmenutop(char *menufile)
{
	FILE *fptr;
	char menupath[81];

	sprintf(menupath,"%s%s.mnu",defmenupath,menufile);

	fptr=fopen(menupath,"rb+");
	if(fptr==NULL)
		return 0;
	else{
		fread(&menutop,sizeof(menutoprec),1,fptr);
		fclose(fptr);
		return 1;
		}
}

int readmenucmd(char *menufile, int cmdnum)
{
	FILE *fptr;
	char menupath[81];
	int x=FALSE;
	menucmdrec mc;
	menutoprec mt;

	sprintf(menupath,"%s%s.mnu",defmenupath,menufile);

	fptr=fopen(menupath,"rb+");
	if(fptr==NULL)
		x=FALSE;
	else{
		if(fseek(fptr,(sizeof(mc)*(long) cmdnum) + sizeof(mt),SEEK_SET)==0)
			x=fread(&menucmd,sizeof(mc),1,fptr);
			fclose(fptr);
		}
	return(x);
}

void readmenu(char *menuname) 
{
	readmenutop(menuname);
	numcmds=0;
	while(readmenucmd(menuname,numcmds++));
	numcmds--;
}

int print_system_text(char *fname)
{
	char ppath[81],file[36],path1[91];
	int cnt=0,num,retval=FALSE;
	
	strcpy(file,fname);
	basename(file);
	strcpy(path1,fname);
	dirname(path1);

	if(strlen(path1)>0)	strcpy(path1,deftextpath);
	sprintf(ppath,"%s%s",path1,file);
	if(strchr(file,".")==NULL){
		if(thisuser.ugraphics){
			sprintf(ppath,"%s%s.ans",path1,file);
			if(fexist(ppath))	retval=send_file(ppath);
			}
		else{
			sprintf(ppath,"%s%s.asc",path1,file);
			if(fexist(ppath))	retval=send_file(ppath);
			}
		}
	return(FALSE);
}

int read_mbaselist(mb_list_rec *mr, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%smbases.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		return(x);
		}

	if(fseek(fptr,(long)recno*sizeof(mb_list_rec),SEEK_SET)==0)
		x=fread(mr,sizeof(mb_list_rec),1,fptr);

	fclose(fptr);
	return(x);
}

int save_laston(lastcallrec *lc)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%slastcall.data",config.datapath);

	fptr=fopen(ttxt,"ab+");
	if(fptr==NULL) {
		fptr=fopen(ttxt,"wb");
		if(fptr==NULL)
			mci("\r\nUnable to open %s\n\r",ttxt);	
			paws();
		}

	x=fwrite(lc,sizeof(lastcallrec),1,fptr);

	fclose(fptr);
	return(x);
}

int read_laston(lastcallrec *lc, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%slastcall.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		return(x);
		}

	if(fseek(fptr,(long)recno*sizeof(lastcallrec),SEEK_SET)==0)
		x=fread(lc,sizeof(lastcallrec),1,fptr);

	fclose(fptr);
	return(x);
}

int readlevel(levelsrec *lr, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%slevels.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		mci("Unable to open %s",ttxt);nl();
		return(x);
		}

	if(fseek(fptr,(long)recno*sizeof(levelsrec),SEEK_SET)==0)
		x=fread(lr,sizeof(levelsrec),1,fptr);

	fclose(fptr);
	return(x);
}

void make_door32sys()
{
	FILE *fptr;
	char s[81];
	time_t t;
	struct tm *ttm;
	

	sprintf(s,"%s/door32.sys",thisuser_temp_path);
	fptr=fopen(s,"wt");
	if(fptr==NULL){
		mci("~SMError creating %s",s);
		return;
		}

	(void) time(&t);
	ttm=localtime(&t);

	fprintf(fptr,"2\n");  /* Comm Type (0=Local, 1=Serial, 2=Telnet) */
	fprintf(fptr,"0\n");  /* Comm or socket handle */
	fprintf(fptr,"Telnet\n"); /* Baud rate */
	fprintf(fptr,"%s\n",PROGNAME); /* BBSID (software name and version ) */
	fprintf(fptr,"%ld\n",thisuser.userID+1); /*User record position (1-based )*/
	fprintf(fptr,"%s\n",thisuser.realname); /* User's real name */
	fprintf(fptr,"%s\n",thisuser.alias); /* User's handle/alias */
	fprintf(fptr,"%d\n",thisuser.sl); /* User's security level */
		/* User's time left (in minutes) */
	fprintf(fptr,"%ld\n",(thisuser.tltoday/60)); 
	fprintf(fptr,"%d\n",(thisuser.ugraphics)?1:0); /*Emulation */
	fprintf(fptr,"%d\n",iMyNode);
	
	fclose(fptr);
}

void make_door_sys()
{
	FILE *fptr;
	char s[81],*p;

	sprintf(s,"%s/door.sys",thisuser_temp_path);
	fptr=fopen(s,"wt");
	if(fptr==NULL){
		mci("~SMError creating %s",s);
		return;
		}
	
	fputs("COM2:\n",fptr);
	fputs("Local\n",fptr);
	fputs("8\n",fptr);
	sprintf(s,"%d\n",iMyNode);
	fputs(s,fptr);
	fputs("57600\n",fptr);
	fputs("Y\n",fptr);
	fputs("N\n",fptr);
	fputs("N\n",fptr);
	fputs("N\n",fptr);
	fprintf(fptr,"%s\n",thisuser.realname); 	
	fprintf(fptr,"%s\n",thisuser.location); 	
	fprintf(fptr,"%s\n",thisuser.phone1);
	fprintf(fptr,"%s\n",thisuser.phone2);
	fprintf(fptr,"%s\n",thisuser.pwtext);
	fprintf(fptr,"%d\n",thisuser.sl);
	strcpy(s,"~TP"); mcimacros(s); strcat(s,"\n"); fputs(s,fptr);
	strcpy(s,"~UI"); mcimacros(s); strcat(s,"\n"); fputs(s,fptr);
	fprintf(fptr,"100\n");
	fprintf(fptr,"%ld\n",thisuser.tltoday/60);
	fprintf(fptr,"%s\n",(thisuser.ugraphics)?"GR":"G");
	fprintf(fptr,"%d\n",thisuser.pagelen);
	fputs("N\n",fptr);
	fputs("A\n",fptr);
	fputs("A\n",fptr);
	fputs("00/00/00\n",fptr);
	fprintf(fptr,"%lu\n",thisuser.userID);
	fprintf(fptr,"%c\n",thisuser.defprotocol);
	fprintf(fptr,"%u\n",thisuser.uploads);
	fprintf(fptr,"%u\n",thisuser.downloads);
	fprintf(fptr,"%lu\n",thisuser.todaydk);
	fputs("00/00/00\n",fptr);
	strcpy(s,"~TE"); mcimacros(s); fprintf(fptr,"%s\n",s);
	strcpy(s,"~TE"); mcimacros(s); fprintf(fptr,"%s\n",s);
	strcpy(s,"~SS"); mcimacros(s); 
		if((p=strchr(s,' '))!=NULL)
			s[p-s]='\0';
		strcat(s,"\n"); fputs(s,fptr);
	strcpy(s,"~SS"); mcimacros(s); strcat(s,"\n"); fputs(s,fptr);
	fputs("00:00\n",fptr);
	fputs("Y\n",fptr);
	fputs("N\n",fptr);
	fputs("N\n",fptr);
	fputs("15\n",fptr);
	fputs("0\n",fptr);
	strcpy(s,"~UI"); mcimacros(s); strcat(s,"\n"); fputs(s,fptr);
	strcpy(s,"~UJ"); mcimacros(s); strcat(s,"\n"); fputs(s,fptr);
	fputs("00:00\n",fptr);
	fputs("4\n",fptr);
	fputs("0\n",fptr);
	fputs("0\n",fptr);
	fputs("0\n",fptr);
	fputs("0\n",fptr);
	fputs("\n",fptr);
	fputs("0\n",fptr);
	fputs("0\n",fptr);
	fclose(fptr);
}

int file_exist(char *fname)
{
	FILE *fptr;

	fptr=fopen(fname,"rb");
	if(fptr!=NULL){
		fclose(fptr);
		return TRUE;
		}
	return FALSE;
}

int read_fbaselist(fb_list_rec *fr, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%sfbases.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		return(x);
		}

	if(fseek(fptr,(long)recno*sizeof(fb_list_rec),SEEK_SET)==0)
		x=fread(fr,sizeof(fb_list_rec),1,fptr);

	fclose(fptr);
	return(x);
}

int readFSE(fserec *fe, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%sfse.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		return(x);
		}

	if(fseek(fptr,(long)recno*sizeof(fserec),SEEK_SET)==0)
		x=fread(fe,sizeof(fserec),1,fptr);

	fclose(fptr);
	return(x);
}

int readzlog()
{
	FILE *fptr;
	int i,x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%szlog.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		for(i=0;i<365;i++){
			zlog.day[i].logons=0;
			zlog.day[i].pubmsgs=0;
			zlog.day[i].privmsgs=0;
			zlog.day[i].netmsgs=0;
			zlog.day[i].newusers=0;
			zlog.day[i].minactive=0;
			}
		return TRUE;
		}

	if(fseek(fptr,sizeof(zlogrec),SEEK_SET)==0)
		x=fread(&zlog,sizeof(zlogrec),1,fptr);

	fclose(fptr);
	return(x);
}

int savezlog()
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%szlog.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		return(x);
		}

	if(fseek(fptr,sizeof(zlogrec),SEEK_SET)==0)
		x=fwrite(&zlog,sizeof(zlogrec),1,fptr);

	fclose(fptr);
	return(x);
}

int readLingo(lingorec *fe, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%slanguage.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		return(x);
		}

	if(fseek(fptr,(long)recno*sizeof(lingorec),SEEK_SET)==0)
		x=fread(fe,sizeof(lingorec),1,fptr);

	fclose(fptr);
	return(x);
}

int readgroup(mfgrouprec *grp, int recno)
{
	FILE *fptr;
	int x=FALSE;
	char ttxt[81];

	sprintf(ttxt,"%sgroups.data",config.datapath);

	fptr=fopen(ttxt,"rb+");
	if(fptr==NULL) {
		return(x);
		}

	if(fseek(fptr,(long)recno*sizeof(mfgrouprec),SEEK_SET)==0)
		x=fread(grp,sizeof(mfgrouprec),1,fptr);

	fclose(fptr);
	return(x);
}
void dirname(char *path)
{
	int i;
	for(i=strlen(path)-1;i>0;i--){
		if(path[i]=='/'){
			path[i+1]='\0';
			return;
			}
		}
}

void basename(char *path)
{
	int i;
	char temp[91];

	strcpy(temp,path);
	for(i=strlen(path)-1;i>0;i--){
		if(path[i]=='/'){
			strcpy(path,temp+i+1);
			return;
			}
		}
}
