/*****************************************************************************
 *
 * File ..................: gycfg.c
 * Purpose ...............: The main gycfg file.
 * Last modification date : 08-Feb-2001
 *
 *****************************************************************************
 * Copyright (C) 2000-2001
 *   
 * Darryl Perry			
 * FIDO:		1:211/105
 * Internet:	dperry.geo@yahoo.com
 *
 * This file is part of Gryphon/X BBS.
 *
 * This BBS is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Gryphon/X BBS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Gryphon/X BBS; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/

#include <stdio.h>

#include "structs.h"
#include "defs.h"
#include "acs.h"
#include "basics.h"
#include "cfg_fileio.h"
#include "config.h"
#include "conio.h"
#include "fileio.h"
#include "gycfg.h"
#include "logon.h"
#include "mbasedit.h"
#include "mci.h"
#include "menuedit.h"
#include "misc.h"
#include "nodedit.h"
#include "useredit.h"

int main(int argc, char *argv[])
{
	init(argc,argv);
	configmanager(1);
	nl();
	nl();
	return 0;
}

void init(int argc, char *argv[])
{
	int n;

	config.KbTimeOut=180;
	config.bbspath[0]='\0';
	strcpy(config.bbspath,argv[0]);
	n=strlen(config.bbspath)-1;
	while(config.bbspath[n]!='/' && n>0){
		config.bbspath[n]='\0';
		n--;
		}

	if(!readconfigdat()){
		init_config();
		saveconfigdat();
		}
	total_users=countusers();
	total_mbases=countmbases();
	total_fbases=countfbases();
	total_nodes=countnodes();
	total_lingo=countlingo();
	total_FSEs=countFSE();

	read_usr(&thisuser,0);
	total_users=countusers();
	thisuser.tltoday=1440;
	thisuser.ugraphics=TRUE;
	thisuser.pagelen=24;
	thisuser.linelen=80;
	thisuser.language[0]=0;
	strcpy(defmenupath,config.menupath);
	strcpy(deftextpath,config.textpath);
	strcpy(deflingofile,"english.txt");

	strcpy(yna[1],lingostr(1));
	strcpy(yna[0],lingostr(2));
	strcpy(yna[2],lingostr(12));
}

void Select_Lingo()
{
	lingorec lingo;

	pick_lingo(&thisuser);
	if(readLingo(&lingo,thisuser.language[0])){
		strcpy(defmenupath,lingo.menupath);
		strcpy(deftextpath,lingo.textpath);
		strcpy(deflingofile,lingo.lingofile);
		}
	else{
		strcpy(defmenupath,config.menupath);
		strcpy(deftextpath,config.textpath);
		strcpy(deflingofile,"english.txt");
		}
}
