/*****************************************************************************
 *
 * File ..................: logon.c
 * Purpose ...............: The routines for logging a user on to the BBS.
 * Last modification date : 08-Feb-2001
 *
 *****************************************************************************
 * Copyright (C) 2000-2001
 *   
 * Darryl Perry			
 * FIDO:		1:211/105
 * Internet:	dperry.geo@yahoo.com
 *
 * This file is part of Gryphon/X BBS.
 *
 * This BBS is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Gryphon/X BBS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Gryphon/X BBS; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/

#include <strings.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include "structs.h"
#include "defs.h"
#include "bbs.h"
#include "basics.h"
#include "fileio.h"
#include "logon.h"
#include "conio.h"
#include "mci.h"
#include "misc.h"
#include "mail.h"
#include "useredit.h"
#include "sysop.h"

char notelist[50][51];
int notecnt;

int finduser(char *tuser)
{
	int idx=0;
	char rn2[37],al1[37],al2[37];
	userrec fuser;

	strcpy(al1,tuser);
	strupr(al1);

	while(read_usr(&fuser,idx)){
		strcpy(al2,fuser.alias);
		strcpy(rn2,fuser.realname);
		strupr(al2);
		strupr(rn2);
	
		if(strcmp(al1,al2)==0 || strcmp(al1,rn2)==0 )   {
			return(idx);
			}
		idx++;
		}	
	return(-1);
}

int FindMatch(char *match,int rnal)
{
	int idx=0;
	char rn2[37],al1[37],al2[37];
	userrec fuser;

	strcpy(al1,match);
	strupr(al1);
	while(read_usr(&fuser,idx)){
		strcpy(al2,fuser.alias);
		strcpy(rn2,fuser.realname);
		strupr(al2);
		strupr(rn2);
	
		if(	strstr(al1,al2) || strstr(al1,rn2)) {
			mci("~SM`09Do you mean `0F%s`09? (`0FY/n`09)`0F: ",fuser.alias);
			if(yesno()){
				if(rnal)
					strcpy(match,fuser.alias);
				else
					strcpy(match,fuser.realname);
				return(idx);
				}
			}
		idx++;
		}	
	language(1105);
	return(-1);
}

void get_user_name()
{
	language(341);
	language(342);
	get_name(thisuser.alias,36);
}

void update_caller(int uid)
{
	time_t t;
	struct tm *ttm,*lasttime;
	lingorec lr;
	char t1[41],t2[41];

	if(!read_usr(&thisuser,uid)){
		mci("~SMUnable to read user %ld~SM~SP",uid);
		return;
		}
	lasttime=localtime(&thisuser.laston);
	strftime(t2,40,"%m/%d/%Y",lasttime);

	t=time(NULL);
	ttm=localtime(&t);
	strftime(t1,40,"%m/%d/%Y",ttm);

	if(strcmp(t1,t2)!=0){			
		thisuser.todaycalls=0;
		thisuser.tltoday=(longint)(config.ULim[thisuser.sl-1].SecondsPerDay);
		thisuser.todaydl=0;
		thisuser.todaydk=0.00;
		}

	(void) time(&thisuser.laston);
	thisuser.totalcalls++;
	thisuser.todaycalls++;
	if(!save_usr(&thisuser,thisuser.userID)){
		mci("~SMUnable to save user record.~SM~SP");
		}
	read_mbaselist(&current_mb,thisuser.lastmbarea);

	if(!readLingo(&lr,(int)thisuser.language[0])){
		if(!readLingo(&lr,(int)0)){
			strcpy(defmenupath,config.menupath);
			strcpy(deftextpath,config.textpath);
			strcpy(deflingofile,"english.txt");
			}
		else{
			strcpy(defmenupath,lr.menupath);
			strcpy(deftextpath,lr.textpath);
			strcpy(deflingofile,lr.lingofile);
			}
		}

/*
	if(config.ULim[thisuser.sl].LogonsPerDay>0 &&
			thisuser.todaycalls>config.ULim[thisuser.sl].LogonsPerDay){
		mci("~SMYou have reached the maximum amount of logons for today.");
		mci("~SMPlease try calling again tommorrow.~SM");
		qbbs(TRUE);
		}
*/

	strcpy(curnode.realname,thisuser.realname);
	strcpy(curnode.alias,thisuser.alias);
	strcpy(curnode.location,thisuser.location);
	strcpy(curnode.nodestatus,"Logging On...");
	strftime(curnode.starttime,5,"%H:%M",lasttime);
	strcpy(curnode.homepath,ttyname(0));
	curnode.inuse=TRUE;
	savenode(&curnode,iMyNode-1);

	zlog.day[lasttime->tm_wday].logons++;
	savezlog();
	update_lastcall(&thisuser);
}


void logon()
{
	int i1,tcnt=0,done=FALSE;
	char alias[81],ttxt1[81];

	print_system_text("welcome");
	thisuser.tltoday=15*60;
	thisuser.userID=-1L;
	int2A(1,(int)config.LogTrys);
	while(tcnt<config.LogTrys && !done){
		get_user_name();
		strcpy(alias,thisuser.alias);
		strupr(alias);
		strcpy(ttxt1,"NEW");
		if(strncasecmp(alias,ttxt1,strlen(ttxt1))==0) {
			new_user();
			done=TRUE;
			}
		else{
			i1=finduser(thisuser.alias);
			if(i1<0){
				language(374);
				char2A(1,thisuser.alias);
				language(345);  
				language(359);	/* Login as a new user? [Yes]:  */
				if(yesno()){
					new_user();
					done=TRUE;
					}
				}
			else{
				read_usr(&thisuser,i1);
				if(check_password(&thisuser)){
					update_caller(i1);
					done=TRUE;
					}
				}
			tcnt++;
			}
		}
	thisuser.illegal=tcnt;
	if(tcnt>2){
		mci("~SM~SM~&1 strikes and you're out.  Please call back when you~SM");
		mci("have your act together.~SM~SM");
		exit(2);
		}
}

void get_real_name(userrec *tu)
{
	language(160);	/* Enter your first & last name:  */
	get_name(tu->realname,36);
}

void get_alias(userrec *tu)
{
	language(161);
	strcpy(tu->alias,tu->realname);
	get_str(tu->alias,36);
	if(strcmp(tu->alias,"")==0)
		strcpy(tu->alias,tu->realname);
}

void get_street(userrec *tu)
{

	language(165);
	get_str(tu->street,25);
}

int checkhighascii(unsigned char *ttxt)
{
	int i;

	for(i=0;i<strlen(ttxt);i++)
		if(ttxt[i]>127 || ttxt[i]<32){
			return TRUE;
			}
	return FALSE;
}


void get_location(userrec *tu)
{	
	int done=FALSE;

	while(!done){
		language(166);
		if(checkhighascii(tu->location))	tu->location[0]='\0';
		get_str(tu->location,25);
		done=TRUE;
		}
}

void get_zipcode(userrec *tu)
{
	language(174);
	get_num(tu->zipcode);
}

void get_datefmt(userrec *tu)
{
	char ttxt[5];

	language(255);
	language(256);
	language(257);
	int2A(1,1);
	int2A(2,3);
	language(258);
	*ttxt='\0';
	tu->datefmt=get_num(ttxt)-1;
	if(tu->datefmt>2)
		tu->datefmt=0;
	
	language(273 + tu->datefmt);
}

void get_birthdate(userrec *tu)
{
	int done=FALSE;

	while(!done){
		language(204);
		switch(tu->datefmt){
			case 0:
				*tu->birthday_mo='\0';
				get_str(tu->birthday_mo,1);
				mci("%s",lingostr(83));
				*tu->birthday_dy='\0';
				get_str(tu->birthday_dy,1);
				mci("%s",lingostr(83));
				*tu->birthday_yr='\0';
				get_filename(tu->birthday_yr,3);
				break;
			case 1:
				*tu->birthday_dy='\0';
				get_str(tu->birthday_dy,1);
				mci("%s",lingostr(83));
				*tu->birthday_mo='\0';
				get_str(tu->birthday_mo,1);
				mci("%s",lingostr(83));
				*tu->birthday_yr='\0';
				get_filename(tu->birthday_yr,3);
				break;
			case 2:
				*tu->birthday_yr='\0';
				get_str(tu->birthday_yr,3);
				mci("%s",lingostr(83));
				*tu->birthday_mo='\0';
				get_str(tu->birthday_mo,1);
				mci("%s",lingostr(83));
				*tu->birthday_dy='\0';
				get_str(tu->birthday_dy,1);
				break;
			}
		if( atoi(tu->birthday_mo) > 0 && atoi(tu->birthday_mo)<=12 &&
			atoi(tu->birthday_dy) > 0 && atoi(tu->birthday_dy)<=31 &&
			atoi(tu->birthday_yr) > 1900 && atoi(tu->birthday_yr)<2100)
			done=TRUE;
		}
	save_usr(tu,tu->userID);
}

void get_gender(userrec *tu)
{
	char ok[5]={"MF"};
	if(config.NewU.AskGender==2){
		language(198);
		strcat(ok,"*");
		}
	else
		language(199);
	thisuser.gender=onekey(ok);
	save_usr(tu,tu->userID);

}

void get_fse(userrec *tu)
{
	int i=0,num;
	char ttxt[11];
	fserec fse;

	mci("~SC~SMSelect a default Full Screen Editor~SM~SM");
	mci(" 0. Line Editor");
	while(readFSE(&fse,i)){
		mci("~SM%2d. %s",i+1,fse.display);
		i++;
		}
	mci("~SM~SMSelect (0-%d): ",total_FSEs);
	*ttxt='\0';
	num=get_num(ttxt);
	if(num>=0 && num<=total_FSEs){
		tu->deffse=(BYTE) num;
		}
	nl();
}

int check_password(userrec *tu)
{
	char try1[21],retval=FALSE;
	time_t t;
	struct tm *tm;

	(void) time(&t);
	tm=localtime(&t);

	language(356);
	get_password(try1,20);
	if(strcmp(tu->pwtext,try1)==0 && strlen(try1)>0){
		retval=TRUE;
		}
	else
		mci("~SM~SM`0E>> INCORRECT PASSWORD <<~SM~SM");
	return(retval);
}

void get_new_password(userrec *tu)
{
	int done=FALSE;
	char try1[21],try2[21];

	while(!done){
		language(185);
		language(186);
		get_password(try1,20);
		language(187);
		get_password(try2,20);
		if(strcmp(try1,try2)!=0)
			language(192);
		else{
			strcpy(tu->pwtext,try1);
			language(184);
			done=TRUE;
			(void) time(&tu->pwexpire);
			}
		}
}

void get_termtype(userrec *tu)
{
	tu->ugraphics=TRUE;
	mci("~SM`07Do you see `0EYELLOW`07 or `1E HIGHLIGHTES `07? [~&Y]:");
	tu->ugraphics=yesno();
}

void get_screen_width(userrec *tu)
{
	char ttxt[5]={"80"};
	language(209);
	tu->linelen=get_num(ttxt);
}

void get_screen_length(userrec *tu)
{
	char ttxt[5]={"24"};
	language(208);
	tu->pagelen=get_num(ttxt);
}

void get_clrscr(userrec *tu)
{
	mci("~SM`07Clear Screen? (Y/n): ");
	thisuser.clrscr=yesno();
}

void get_voice_phone(userrec *tu)
{
	language(180);
	get_phone(tu->phone1);
}

void get_email(userrec *tu)
{
	mci("~SM`07Enter your email address: `1F");
	get_str(tu->email,35);
}

void list_notes(char wn)
{
	FILE *fptr;
	char ttxt[81];
	char disp[81];
	int i;


	sprintf(ttxt,"%snotes%d.dat",config.textpath,wn);

	fptr=fopen(ttxt,"rt");
	if(fptr==NULL)
		;
	else{
		notecnt=0;
		while(fgets(disp,81,fptr)){
			disp[strlen(disp)-1]=0;
			if(strlen(disp)>0){
				strcpy(notelist[notecnt],disp);
				}
			notecnt++;
			}
		strcpy(notelist[notecnt],"Other");
		}
		
	for(i=0;i<notecnt;i++){
		mci("`08%2d. %s",i+1,notelist[i]);
		if(i % 2) 	nl();
		else		repeat(' ',35-mcistrlen(notelist[i]));
		}
}

void get_notes(int notenum, userrec *tu)
{
	char ttxt[51];
	int num;

	sprintf(ttxt,"notes%d",notenum);

	print_system_text(ttxt);
	list_notes(notenum);
	switch(notenum){
		case 1:	language(244);	break;
		case 2:	language(248);	break;
		case 3:	language(252);	break;
		}
	*ttxt='\0';
	num=get_num(ttxt)-1;
	if(num==notecnt){
		switch(notenum){
			case 1:	language(246);	break;
			case 2:	language(250);	break;
			case 3:	language(253);	break;
			}
		get_str(ttxt,50);
		strcpy(tu->notes[notenum],ttxt);
		}
	strcpy(tu->notes[notenum],notelist[num]);
}

int ScanPhones(userrec *tu)
{
	userrec t1;
	int i=0,retval=FALSE;

	language(139);
	while(read_usr(&t1,i++)){
		if(strcmp(tu->phone1,t1.phone1)==0)	retval=TRUE;
		if(strcmp(tu->phone1,t1.phone2)==0)	retval=TRUE;
		if(strcmp(tu->phone2,t1.phone1)==0)	retval=TRUE;
		if(strcmp(tu->phone2,t1.phone2)==0)	retval=TRUE;
		}	
	return retval;
}

void new_user() 
{
	levelsrec lr;
	time_t t;
	int i,count;

	nl();
	print_system_text("newuser1");
	language(110);
	if(!yesno()) {
		nl();
		exit(0);
		}

	(void) time(&t);
	thisuser.firston=time(NULL);
	thisuser.laston=time(NULL);

	thisuser.userID=total_users;
	get_termtype(&thisuser);
	get_screen_width(&thisuser);
	get_screen_length(&thisuser);
	thisuser.clrscr=config.NewU.AskClrScr;
	if(config.NewU.AskClrScr){
		if(config.NewU.AskClrScr>1){
			get_clrscr(&thisuser);
			}
		}

	count=0;
	do{
		get_real_name(&thisuser);
		i=finduser(thisuser.realname);
		if(i>=0){
			char2A(1,thisuser.realname);
			language(162);
			Syslog(" `0C* `0FNew user trying to use existing username");
			Syslog(" `0C* `0FRealname=%s, Alias=%s",
				thisuser.realname,thisuser.alias);
			count++;
			}
		}while(i>=0 && count<3);
	if(count>=3)	exit(0);
	count=0;
	do{
		get_alias(&thisuser);
		i=finduser(thisuser.alias);
		if(i>=0){
			char2A(1,thisuser.alias);
			language(162);
			Syslog(" `0C* `0FNew user trying to use existing alias");
			Syslog(" `0C* `0FRealname=%s, Alias=%s",
				thisuser.realname,thisuser.alias);
			count++;
			}
		}while(i>=0 && count<3);
	if(count>=3)	exit(0);

	if(config.NewU.AskGender)
		get_gender(&thisuser);
	else
		thisuser.gender='*';
	get_datefmt(&thisuser);
	if(config.NewU.AskBDate)
		get_birthdate(&thisuser);
	else{
		strcpy(thisuser.birthday_mo,"01");
		strcpy(thisuser.birthday_dy,"01");
		strcpy(thisuser.birthday_yr,"1970");
		}
	if(config.NewU.AskMailAddress){
		get_street(&thisuser);
		get_zipcode(&thisuser);
		}
	if(config.NewU.AskGeoLoc){
		get_location(&thisuser);
		}
	if(config.NewU.AskVoicePhone)
		get_voice_phone(&thisuser);
	if(config.NewU.AskDataPhone)
		get_email(&thisuser);

	if(config.NewU.AskScanPhones)
		if(ScanPhones(&thisuser)){
			language(140);
			}
		
	get_notes(1, &thisuser);	
	get_notes(2, &thisuser);	
	get_notes(3, &thisuser);	
	get_new_password(&thisuser);
	thisuser.lastmbarea=0;
	thisuser.lastfile=0;
	readlevel(&lr,config.newu_val);
	thisuser.sl=lr.sl;
	strcpy(thisuser.EFlags,lr.EFlags);
	strcpy(thisuser.FFlags,lr.FFlags);
	save_usr(&thisuser,thisuser.userID);	
	update_caller(thisuser.userID);
	total_users=countusers();
	init_sig();
	thisuser.tltoday=config.ULim[thisuser.sl-1].SecondsPerDay*60*60;
	Syslog("New User %s (%s) signed up.",thisuser.alias,thisuser.realname);
	if(config.NewU_feedback){
		print_system_text("newapp");
		SendEmail(config.NewU_ApplyTo,"New User Feedback Message");	
		}
}

void capname(char *Name2Cap)
{
	int i;

	strlwr(Name2Cap);
	for(i=0;i<strlen(Name2Cap);i++)
		if(i==0 || Name2Cap[i-1]==' ')
			if(Name2Cap[i]>='a' && Name2Cap[i]<='z')
				Name2Cap[i]-=32;
}

void update_lastcall(userrec *usr)
{
	lastcallrec lc;

	if(so() && config.hidesysop)	return;

	strcpy(lc.realname,usr->realname);
	strcpy(lc.alias,usr->alias);
	lc.laston=usr->laston;
	strcpy(lc.location,usr->location);
	lc.caller=config.systemcalls;
	lc.node=(char)iMyNode;
	config.systemcalls++;
	saveconfigdat();
	save_laston(&lc);
}

void findnode()
{
	int i1;
	iMyNode=-1;

	i1=0;
	while(readnode(&curnode,i1)){
		if(!curnode.inuse || strcmp(curnode.homepath,ttyname(0))==0){
			iMyNode=i1+1;
			return;
			}
		i1++;
		}
	if(iMyNode<0){
		add_node();
		iMyNode=countnodes();
		}
}

void fill_temp_path()
{
	sprintf(thisuser_temp_path,"%stemp%d",config.bbspath,iMyNode-1);

	if(chdir(thisuser_temp_path)){
		if(mkdir(thisuser_temp_path,S_IRWXO | S_IRWXG | S_IRWXU)){
			mci("~SMUnable to make dir %s~SM~SP",thisuser_temp_path);
			}
		}
	else
		chdir(config.bbspath);
}


void clean_up_tmp()
{
	DIR *dp;
	struct dirent *entry;

	if((dp=opendir(thisuser_temp_path))==NULL){
		mci("~SMUnable to open %s~SM~SP",thisuser_temp_path);
		return;
		}

	chdir(thisuser_temp_path);
	
	while((entry=readdir(dp))!=NULL){
		if(strcmp(entry->d_name,".")!=0 && strcmp(entry->d_name,"..")!=0)
			remove(entry->d_name);
		}
	chdir(config.bbspath);
	closedir(dp);
}

void init_sig()
{
	sprintf(thisuser.sig.shortsig,"I'm a happy %s caller!",config.bbsname);
	sprintf(thisuser.sig.longsig[0],"-Regards,");
	sprintf(thisuser.sig.longsig[1],"%s",thisuser.realname);
	sprintf(thisuser.sig.longsig[2],"Call %s at %s today!",
		config.bbsname,config.phone);
	strcpy(thisuser.sig.longsig[3],"");
}

void EditSig()
{
	int done=FALSE,i;
	char ttxt[4][121];

	while(!done){
		mci("~SC~SM`0ESignature Editor~SM~SM");
		mci("`07A. Short Signature:~SM\"`0F%s`07\"~SM~SM",
			thisuser.sig.shortsig);
		mci("`07B. Long Signature:~SM\"`0F%s`07\"~SM",thisuser.sig.longsig[0]);
		mci("`07\"`0F%s`07\"~SM",thisuser.sig.longsig[1]);
		mci("`07\"`0F%s`07\"~SM",thisuser.sig.longsig[2]);
		mci("`07\"`0F%s`07\"~SM",thisuser.sig.longsig[3]);
	
		mci("~SM`09Signature Editor  (A-B, Q=Quit): `0F");
		switch(onekey("ABQ")){
			case 'A':
				mci("~SMEnter new short signature.~SM:");
				strcpy(ttxt[0],thisuser.sig.shortsig);
				get_str(ttxt[0],78);
				mci("~SMIs this what you want? (Y/n): ");
				if(yesno()){
					strcpy(thisuser.sig.shortsig,ttxt[0]);
					}
				break;
			case 'B':
				mci("~SMEnter new long signature.~SM");
				for(i=0;i<4;i++){
					mci("~SM:");
					strcpy(ttxt[i],thisuser.sig.longsig[i]);
					get_str(ttxt[i],78);
					}
				mci("~SMIs this what you want? (Y/n): ");
				if(yesno()){
					for(i=0;i<4;i++){
						strcpy(thisuser.sig.longsig[i],ttxt[i]);
						}
					}
				break;
			case 'Q':	
				save_usr(&thisuser,thisuser.userID);	done=TRUE;	break;
			}		
		}
}

void pick_lingo(userrec *tu)
{
	int i,l1;
	char ttxt[6];
	lingorec lr;

	language(330);
	for(i=0;i<total_lingo;i++){
		readLingo(&lr,i);
		int2A(1,i+1);
		char2A(2,lr.display);
		char2A(3,lr.lingofile);
		language(335);
		}
	int2A(1,1);
	int2A(2,i);
	language(331);

	*ttxt='\0';
	l1=get_num(ttxt)-1;

	readLingo(&lr,l1);
	char2A(1,lr.display);
	char2A(2,lr.lingofile);
	language(332);
	language(333);
	if(yesno()){
		tu->language[0]=l1;
		}
}
