/*****************************************************************************
 *
 * File ..................: mail.c
 * Purpose ...............: message base routines.
 * Last modification date : 08-Feb-2001
 *
 *****************************************************************************
 * Copyright (C) 2000-2001
 *   
 * Darryl Perry			
 * FIDO:		1:211/105
 * Internet:	dperry.geo@yahoo.com
 *
 * This file is part of Gryphon/X BBS.
 *
 * This BBS is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Gryphon/X BBS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Gryphon/X BBS; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/

#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <ctype.h>
#include <errno.h>
#include "structs.h"
#include "defs.h"
#include "acs.h"
#include "bbs.h"
#include "basics.h"
#include "config.h"
#include "fileio.h"
#include "lineedit.h"
#include "logon.h"
#include "msgapi.h"
#include "mail.h"
#include "misc.h"
#include "mci.h"
#include "conio.h"
#include "useredit.h"
#include "sysop.h"

#define BUFLEN 64000
#define CTLLEN 1024 
#ifndef sopen
#define sopen(a,b,c,d) open((a),(b),(d))
#endif

char buff[BUFLEN];
static char cinfbuf[CTLLEN];    /* control info buffer */
unsigned long buflen=0L, cinflen=0L;
int showkludges=FALSE;
int curmbarea;
extern char msgcolors[16][6];
XMSG xmsg;
MSG *AHandle;
MSGH *mh=NULL;
HMSG  hmsg;
HAREA harea;
MsgInfoRec MI;
mb_list_rec mr;

void MakeCtrlHdr();
void GetMsgID(char *reply);

void MakeCtrlHdr(char *reply)
{
	char adrs[21];
	long somenum;
	
	(void) time(&somenum);

	faddr2char(adrs,&config.aka[mr.fidoaddr]);
	if(reply==(char *)NULL){
		sprintf(cinfbuf,"\01MSGID: %s %ld\01PID: %s", 
			adrs, somenum, PROGNAME);
		}
	else{
		sprintf(cinfbuf,"\01MSGID: %s %ld\01%s\01PID: %s", 
			adrs, somenum, reply,PROGNAME);
		}
}

void Add2MsgInfo()
{
	int i;

	strcpy(MI.AreaName,mr.mbdisplay);
	MI.colors[0]=mr.colors[0];
	MI.colors[1]=mr.colors[1];
	MI.colors[2]=mr.colors[2];
	MI.colors[3]=mr.colors[3];

	strcpy(MI.From,xmsg.from);
	strcpy(MI.To,xmsg.to);
	strcpy(MI.Subj,xmsg.subj);
	MI.orig.zone =xmsg.orig.zone;
	MI.orig.net  =xmsg.orig.net;
	MI.orig.node =xmsg.orig.node;
	MI.orig.point=xmsg.orig.point;
	MI.dest.zone =xmsg.dest.zone;
	MI.dest.net  =xmsg.dest.net;
	MI.dest.node =xmsg.dest.node;
	MI.dest.point=xmsg.dest.point;
	MI.attr		 =xmsg.attr;
	MI.date_written=xmsg.date_written;
	MI.date_arrived=xmsg.date_arrived;
	MI.replyto=xmsg.replyto;

	MI.high_water=AHandle->high_water;
	MI.high_msg  =MsgHighMsg(AHandle);
	MI.cur_msg   =MsgCurMsg(AHandle);
	MI.num_msg   =MsgNumMsg(AHandle);
	MO=MI.cur_msg;
	MH=MI.high_msg;
	ML=1L;
	for(i=0;i<10;i++){
		if(xmsg.replies[i]!=0){
			MI.replies[i]=xmsg.replies[i];
			}
		}
}

int get_to(XMSG *xm)
{
	if(strlen(xmsg.to)<1){
		if(mr.Pubpriv==PRIVATE){
			*xmsg.to='\0';
			language(1104);
			}
		else{
			strcpy(xmsg.to,"All");
			char2A(1,xmsg.to);
			language(1102);
			}
		if(mr.Kind!=NEWS){
			get_str(xm->to,XMSG_TO_SIZE);
			}
		}
	else{
		if(mr.Pubpriv==PRIVATE){
			}
		else{
			char2A(1,xmsg.to);
			language(1102);
			}	
		}
	
	if(mr.Kind==EMAIL){
		if(strlen(xmsg.to)<1)	return FALSE;
		if(FindMatch(xmsg.to,mr.Allowalias)<0){
			language(1105);
			return FALSE;
			}
		}
	return TRUE;
}

void get_address(XMSG *xm)
{
	char *zone,*net,*node,*pt,faddr[21];

	xm->dest.zone=0;
	xm->dest.net=0;
	xm->dest.node=0;
	xm->dest.point=0;

	*faddr='\0';
	language(1113);
	get_str(faddr,20);
	zone=strtok(faddr,":/.\n\r");
	if(zone){
		xm->dest.zone=atoi(zone);
		net=strtok(NULL,":/.\n\r");
		if(net){
			xm->dest.net=atoi(net);
			node=strtok(NULL,":/.\n\r");
			if(node){
				xm->dest.node=atoi(node);
				pt=strtok(NULL,":/.\n\r");
				if(pt){
					xm->dest.point=atoi(pt);
					}
				}
			}
		}
}

int get_subject(XMSG *xm)
{
	if(strlen(xm->subj)>0)
		language(1098);
	else
		language(1099);
	get_str(xm->subj,XMSG_SUBJ_SIZE);
	if(strlen(xm->subj)<1)
		return FALSE;
	else
		return TRUE;
}

void make_msg_tmp()
{
	FILE *fptr;
	char path[91];

	sprintf(path,"%s/msg.tmp",thisuser_temp_path);
	fptr=fopen(path,"wt");
	if(fptr==NULL)
		return;
	fputs("\n\r",fptr);
}

void read_in_msg_tmp()
{
	FILE *fptr;
	char ttxt[121],path[91];

	memset(buff,0,BUFLEN);

	sprintf(path,"%s/msg.tmp",thisuser_temp_path);
	fptr=fopen(path,"rb+");
	if(fptr==NULL)
		;
	else{
		while(fgets(ttxt,121,fptr)!=NULL){
			stripCR(ttxt);
			strcat(buff,ttxt);
			strcat(buff,"\n\r");
			}
/*		fread(buff,1,32000,fptr); */
		fclose(fptr);
		}
}

void kill_msg_tmp()
{
	char  path[91];
	sprintf(path,"%s/msg.tmp",thisuser_temp_path);

	if(file_exist(path))
		remove(path);
}

time_t stampToTimeT(struct _stamp *st)
{
    time_t tt;
    struct tm tms;
    tms.tm_sec = st->time.ss << 1;
    tms.tm_min = st->time.mm;
    tms.tm_hour = st->time.hh;
    tms.tm_mday = st->date.da;
    tms.tm_mon = st->date.mo - 1;
    tms.tm_year = st->date.yr + 80;
    tms.tm_isdst = -1;
    tt = mktime(&tms);
    return tt;
}

struct _stamp *timeTToStamp(time_t tt)
{
    struct tm *tmsp;
    static struct _stamp st;
    tmsp = localtime(&tt);
    st.time.ss = tmsp->tm_sec >> 1;
    st.time.mm = tmsp->tm_min;
    st.time.hh = tmsp->tm_hour;
    st.date.da = tmsp->tm_mday;
    st.date.mo = tmsp->tm_mon + 1;
    st.date.yr = tmsp->tm_year - 80;

    return (&st);
}

void add_sig()
{
	int i;

	if(mr.sigtype==0)	return;

	if(mr.sigtype==1){
		strcat(buff,"\r");
		strcat(buff,thisuser.sig.shortsig);	
		}
	if(mr.sigtype==2){
		for(i=0;i<4;i++){
			if(strlen(thisuser.sig.longsig[i])>0){
				strcat(buff,"\r");
				strcat(buff,thisuser.sig.longsig[i]);
				}
			}
		}
	strcat(buff,"\r");
}

void add_tagline()
{
	FILE *fptr;
	char path[81],ttxt[91];
	int count=0;

	sprintf(path,"%s/taglines.dat",config.datapath);
	fptr=fopen(path,"rt");
	if(fptr==NULL)	return;
	
	while(fgets(ttxt,81,fptr)!=NULL)	count++;

	fclose(fptr);

	fptr=fopen(path,"rt");
	if(fptr==NULL)	return;

	count-=random();
	
	while(fgets(ttxt,81,fptr)!=NULL && count>0)	count--;

	fclose(fptr);

	sprintf(path,"\r... %s",ttxt);
	strcat(buff,path);
		
}

void add_origin()
{
	char fad[21],ttxt[141],txt1[66];

	add_sig();
	add_tagline();
	faddr2char(fad,&config.aka[mr.fidoaddr]);
	strncpy(txt1,mr.OriginLine,50);
	txt1[50]='\0';
	stripCR(txt1);
	memset(ttxt,0,141);
	sprintf(ttxt,"\r--- %s\r * Origin: %s (%s) ",PROGNAME,txt1,fad);	
	strcat(buff,ttxt);
}

void fill_xmsg(char *from, char *to, char *subj)
{
	strcpy(xmsg.to,to);	
	strcpy(xmsg.from,from);	
	strcpy(xmsg.subj,subj);	
}

void PostNewMsg(int mbnum)
{
	make_msg_tmp();

	MakeCtrlHdr((char *)NULL);

	if(!OpenMsgArea(mbnum)){
		mci("~SMUnable to open message area.~SM~SP");
		return;
		}

	if(mr.Allowalias)
		fill_xmsg(thisuser.alias,xmsg.to,"");
	else
		fill_xmsg(thisuser.realname,xmsg.to,"");

	if(mr.Pubpriv==PRIVATE)	{ 
		*xmsg.to='\0';
		language(1104); 
		}
	else{ 
		strcpy(xmsg.to,"All");	
		char2A(1,xmsg.to);
		language(1102); 
		}

	get_str(xmsg.to,XMSG_TO_SIZE);
	if(strlen(xmsg.to)<1)	return;

	PostMsg(mbnum);
}

void PostReplyMsg(int mbnum)
{
	int i,fix=FALSE;
	char reply[51];

	*reply='\0';
	GetMsgID(reply);
	strrepl(reply,50,"MSGID","REPLY");

	MakeCtrlHdr(reply);

	MsgExtractTxt();
	if(mr.Allowalias)
		fill_xmsg(thisuser.alias,xmsg.from,xmsg.subj);
	else
		fill_xmsg(thisuser.realname,xmsg.from,xmsg.subj);
	for(i=0;i<9;i++){
		if(!xmsg.replies[i]){
			xmsg.replies[i]=thisuser.lastmsg;
			fix=TRUE;
			}
		}
	if(!fix) xmsg.replies[9]=thisuser.lastmsg;
	MI.replyto=xmsg.replies[9];

	char2A(1,xmsg.to);
	if(mr.Pubpriv==PRIVATE){
		language(1104);
		}
	else{
		language(1102);
		}

	get_str(xmsg.to,XMSG_TO_SIZE);
	if(strlen(xmsg.to)<1)	return;

	PostMsg(mbnum);
}

void PostMsg(int mbnum)
{
	int i;
	char msgtmp[81];
	struct tm *tm;
	time_t timet;
	fserec fse;

	OpenMsgArea(mbnum);

	xmsg.orig.zone=config.aka[mr.fidoaddr].zone;
	xmsg.orig.net=config.aka[mr.fidoaddr].net;
	xmsg.orig.node=config.aka[mr.fidoaddr].node;
	xmsg.orig.point=config.aka[mr.fidoaddr].point;
	time(&timet);
	tm=localtime(&timet);
	xmsg.date_written=*timeTToStamp(timet);
	xmsg.date_arrived=*timeTToStamp(timet);

	xmsg.attr=0;
	xmsg.attr |= MSGLOCAL;

	if(mr.Kind==NETMAIL){
		get_address(&xmsg);
		xmsg.attr |= MSGPRIVATE;
		xmsg.attr |= MSGCRASH;
		}
	if(!get_subject(&xmsg))	return;
	/* make_msg_tmp(); */

	/* Which msg editor do we use? */
	if(thisuser.deffse>0){
		readFSE(&fse,thisuser.deffse-1);
		strcpy(msgtmp,fse.fsecmdpath);
		mcimacros(msgtmp);
		system(msgtmp);
		}
	else{
		sprintf(msgtmp,"%s/msg.tmp",thisuser_temp_path); 
		Line_Edit(msgtmp,"");
		}

	/* Do we really want to save this message? */
	language(1175);
	if(!yesno()){
		language(1096);
		return;
		}

	/* If this is a reply, update the header of the current msg */
	if(MI.replyto!=0){
		SaveMsg(mbnum,thisuser.lastmsg,FALSE);
		xmsg.replyto=thisuser.lastmsg;
		for(i=0;i<10;i++)
			xmsg.replies[i]=0;
		}
	read_in_msg_tmp();
	if(mr.Type!=LOCAL)
		add_origin(&mr);

	SaveMsg(mbnum,0,TRUE);
	kill_msg_tmp();
	Syslog("User \"~UH\" posted message \"%s\"",xmsg.subj);
	Syslog("  to \"~MB\" message base");
}

int SaveMsg(unsigned long msgarea, unsigned long msgnum, int new)
{

	if(OpenMsgArea(msgarea)){
		if(new)
    		hmsg = MsgOpenMsg(AHandle, MOPEN_CREATE, 0);
		else
    		hmsg = MsgOpenMsg(AHandle, MOPEN_RW, msgnum);

	
       	MsgWriteMsg(hmsg, 0, &xmsg, buff, strlen(buff), strlen(buff), 
				strlen(cinfbuf), cinfbuf);

        MsgCloseMsg(hmsg);
		}
	OpenMsgArea(msgarea);
	return 0;
}

int check_seenby(char *ostr)
{
	if(strstr(ostr,"SEEN-BY"))
		return(TRUE);
	else
		return(FALSE);
}

int check_origin(char *ostr)
{
	if(strstr(ostr," * Origin"))
		return TRUE;
	else
		return FALSE;
}

int check_tags(char *ostr)
{
	if(strncmp(ostr,"--- ",4)==0)
		return TRUE;
	else
		return FALSE;
}

int check_quotes(char *ostr)
{
	char *p;
	
	p=strchr(ostr,'>');
	if(p && (p-ostr<=10))
		return TRUE;
	else
		return FALSE;
}

char ync()
{
	char ch;

	language(295);
	ch=onekey("YNC\n");
	mci("\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b                \b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b");
	return(ch);
}

void GetMsgID(char *reply)
{
	long lbeg, lend;
	char line[121];
	int cnt=0;

	lbeg=0;
	lend=0;

	while(lend<cinflen && lbeg<cinflen){ 
		memset(line,0,120);
		while((	lend<cinflen && lend<(80+lbeg)) && cinfbuf[lend]!='\01'){
			lend++;
			}
		while((	lend>lbeg 			&& 
				lend>0 				&& 
				lend>(80+lbeg-10)) 	&&
				cinfbuf[lend]!='\01'){
			lend--;
			}
		if((lend>=lbeg) && lend<=cinflen){
			memcpy(line,cinfbuf+lbeg,lend-lbeg);
			stripCR(line);
			strcpy(reply,line);
			if(strncmp(line,"MSGID",5)==0){
				break;
				}
			cnt++;
			}
		else{
				return ;
			}
		lend++;
		lbeg=lend;
		}
}


int MsgShowCtlBuf(MsgInfoRec MI)
{
	long lbeg, lend;
	char line[121];
	int cnt=0;

	mci("`0A");
	lbeg=0;
	lend=0;

	while(lend<cinflen && lbeg<cinflen){ 
		memset(line,0,120);
		/* Move along the line until we find a CR/NL or the user's */
		/* screen width */
		while((	lend<cinflen					&& 
				lend<(thisuser.linelen+lbeg)) 	&& 
				cinfbuf[lend]!='\n' 			&& 
				cinfbuf[lend]!='\r' 			&& 
				cinfbuf[lend]!='\01'){
			lend++;
			}
		/* Then we move back to the front of the line until we find a space. */
		while((	lend>lbeg 							&& 
				lend>0 								&& 
				lend>(thisuser.linelen+lbeg-10)) 	&&
				cinfbuf[lend]!=' ' 					&& 
				cinfbuf[lend]!='\r' 					&& 
				cinfbuf[lend]!='\n'){
			lend--;
			}
		if((lend-lbeg)>0){
			memcpy(line,cinfbuf+lbeg,lend-lbeg);
			stripCR(line); 
			printf("%s\n\r",line);
			cnt++;
			}
		else{
			if((lend-lbeg)!=0)
				return cnt;
			}
		lend++;
		lbeg=lend;
		}
	return(cnt);
}

void ToggleKludges()
{
	showkludges=(showkludges)?0:1;
}

void MsgShowTxt()
{
	long lbeg, lend;
	char line[121];
	int plen,iskludge=FALSE;

	DispMsgHdr();
	plen=5;

	mci(ansic(MI.colors[MSG_TEXT]));
	lbeg=0;
	lend=0;
	
	if(showkludges)
		plen+=MsgShowCtlBuf(MI);
	while(lend<buflen && lbeg<buflen){
		iskludge=FALSE;
		memset(line,0,120);
		/* Move along the line until we find a CR/NL or the user's */
		/* screen width */
		while(lend<buflen && lend<(thisuser.linelen+lbeg) && buff[lend]!='\r')
			lend++;
		/* Then we move back to the front of the line until we find a space. */
		while((	lend>lbeg 							&& 
				lend>0 								&& 
				lend>(thisuser.linelen+lbeg-20)) 	&&
				buff[lend]!=' ' 					&& 
				buff[lend]!='\r' 					&& 
				buff[lend]!='\n'){
			lend--;
			}
		if((lend-lbeg)>0){
			memcpy(line,buff+lbeg,lend-lbeg);
			mci(ansic(MI.colors[MSG_TEXT]));
			if(check_origin(line))	mci(ansic(MI.colors[MSG_ORIGIN])); 
			if(check_tags(line)) 	mci(ansic(MI.colors[MSG_TEAR])); 
			if(check_quotes(line))	mci(ansic(MI.colors[MSG_QUOTE]));
			if(check_seenby(line) || line[0]=='\1'){
				iskludge=TRUE;
				if(showkludges){
					mci("`01");
					}
				}
			if(!iskludge || showkludges){
				stripCR(line); 
				printf("%s\n\r",line);
				plen++;
				}
			}
		else{
			if((lend-lbeg)==0){
				mci("~SM");
				plen++;
				}
			else	
				return;
			}

		if(plen>=thisuser.pagelen-2){
			switch(ync()){
				case '\n':
				case 'Y':	plen=0;	break;
				case 'N':	lend=buflen+1;	break;
				case 'C':	plen=0;	break;
				}
			}

		lend++;
		lbeg=lend;
		}
}

void FidoFlags(char *fflags)
{
	if(MI.attr & MSGPRIVATE) 	
		strcat(fflags,"Private");
	if(MI.attr & MSGCRASH)	{
		if(strlen(fflags)>0)	strcat(fflags,", ");
		strcat(fflags,"Crash");
		}
	if(MI.attr & MSGREAD){
		if(strlen(fflags)>0)	strcat(fflags,", ");
		strcat(fflags,"Read");
		}
	if(MI.attr & MSGLOCAL){
		if(strlen(fflags)>0)	strcat(fflags,", ");
		strcat(fflags,"Local");
		}
}


void DispMsgHdr()
{
	time_t tmt;
	struct tm *mtm;
	char faddr[81],timestr[81],fflags[41],namestr[81],tostr[81];
	unsigned int repf,rept;


	rept=MI.replyto;
	repf=MI.replies[0];
	*fflags='\0';
	FidoFlags(fflags);
	
	if(mr.Kind!=LOCAL && mr.Kind!=EMAIL){
		if(MI.orig.point)
			sprintf(faddr,"%d:%d/%d.%d", 
				MI.orig.zone, MI.orig.net, MI.orig.node,MI.orig.point);
		else
			sprintf(faddr,"%d:%d/%d", MI.orig.zone, MI.orig.net, MI.orig.node);
		sprintf(namestr,"%s@%s",MI.From,faddr);
		}
	else{
		sprintf(namestr,"%s",MI.From);
		}

	if(mr.Kind==NETMAIL){
		if(MI.dest.point)
			sprintf(faddr,"%d:%d/%d.%d", 
				MI.dest.zone, MI.dest.net, MI.dest.node,MI.dest.point);
		else
			sprintf(faddr,"%d:%d/%d", MI.dest.zone, MI.dest.net, MI.dest.node);
		sprintf(tostr,"%s@%s",MI.To,faddr);
		}
	else
		sprintf(tostr,"%s",MI.To);

    tmt = stampToTimeT(&MI.date_written);
	mtm=localtime(&tmt);
	strftime(timestr,81,"%H:%M  %m/%d/%Y",mtm);

	char2A(1,namestr);
	char2A(2,tostr);
	char2A(3,MI.Subj);
	char2A(5,fflags);
	char2A(6,timestr);
	mcistrset(MI.AreaName,35);

	language(1030); 
	language(1031);
	language(1032);
	language(1033);
	language(1036);
	language(1039);
}

void GetMsg()
{
	strcpy(buff,"");
	cinflen=MsgGetCtrlLen(mh);
	MsgReadMsg(mh,&xmsg,0L,0L,NULL,cinflen,(char *)cinfbuf);
	cinfbuf[cinflen]='\0';

	buflen=MsgGetTextLen(mh);
	MsgReadMsg(mh,NULL,0L,buflen,buff,0L,NULL);
	Add2MsgInfo();
}

void DelCurMsg(unsigned long mbnum, unsigned long msgnum)
{
	OpenMsgArea(mbnum);
	MsgKillMsg(AHandle,msgnum);
}

char ReadMessages(unsigned long marea)
{
	char ch,teststr[21],keys[21];
	int i,x=7;

	if(!OpenMsgArea(marea)){
		language(1412);
		return 'Q';
		}
	language(1401);
	language(1402);
	language(1403);
	language(1404);
	strcpy(keys,lingostr(1405));
	ch=onekey(keys);
	for(i=0;i<strlen(keys);i++)
		if(keys[i]==ch)
			x=i;
	switch(x){
		case 7:	break;
		case 0:	
			char2A(1,lingostr(1408));
			language(1407);
			language(1410);
			*teststr='\0';
			get_str(teststr,6);
			if(strcmp(teststr,lingostr(1417))==0)	return 'Q';
			if(strlen(teststr)>0)
				thisuser.lastmsg=atol(teststr);
			else
				thisuser.lastmsg=1;
			ReadOrScanMsgs(TRUE,FALSE);
			break;
		case 1:
			language(1101);
			*teststr='\0';
			get_str(teststr,35);
			ReadOrScanMsgs(TRUE,FALSE);
			break;
		case 3:
			mci("~SM`09Search Text: `0F");
			*teststr='\0';
			get_str(teststr,35);
			ReadOrScanMsgs(TRUE,FALSE);
			break;
		case 2:
			thisuser.lastmsg=GetLastRead(thisuser.userID);
			ReadOrScanMsgs(TRUE,FALSE);
			break;
		case 5:
			strcpy(teststr,thisuser.realname);
			ReadOrScanMsgs(TRUE,FALSE);
			break;
		default:
			break;
	
		}
	return(ch);
}

void AskPostNew(unsigned long mbnum)
{
	language(1275);
		if(!noyes()){
			PostNewMsg(mbnum);
			}
}

int ReadMsg(unsigned long mbnum, unsigned long  msgnum, int showit)
{
	int retval=TRUE;

	if(!OpenMsgArea(mbnum)){
		if(showit)
			language(1318);
		retval=FALSE;
		}
	if(msgnum<1 || msgnum>MI.high_msg) 	retval=FALSE;

	if(retval){
		mh= MsgOpenMsg(AHandle, MOPEN_RW,msgnum);
		if(mh!=NULL){
			GetMsg();
			if(showit)
				MsgShowTxt(mbnum);
			SetLastRead(thisuser.userID,msgnum);
			}
		else
			retval=FALSE;
		}
	return retval;
}

void CloseMsgArea(int mbnum)
{
	if(AHandle!=NULL)
		MsgCloseArea(AHandle);
}

int OpenMsgArea(unsigned long mbnum)
{
	char path[81];
	int retval=TRUE;

	if(!read_mbaselist(&mr,mbnum)){
		mci("~SMUnable to read message base #%d~SM~SP",mbnum);
		return FALSE;
		}

	sprintf(path,"%s%s",mr.mbpath,mr.mbfile);
	if(AHandle!=NULL)	MsgCloseArea(AHandle);
    AHandle= MsgOpenArea(path, MSGAREA_CRIFNEC, mr.Type);
    if (AHandle== NULL) retval=FALSE;
	else 	Add2MsgInfo();

	return retval;
}


unsigned long GetLastRead(unsigned long usr)
{
	unsigned long lr=0L;

	switch(mr.Type){
		case MSGTYPE_JAM:	break;
		case MSGTYPE_SQUISH:
			lr=SquishAreaGetLast(usr)+1;
			break;
		}
	return lr;
}

void SetLastRead(unsigned long usr, unsigned long lr)
{
	switch(mr.Type){
		case MSGTYPE_JAM: break;
		case MSGTYPE_SQUISH: 
			if(SquishAreaSetLast(usr,lr)<0){
				mci("~SMErrer setting last read.~SM~SP");
				}
			break;
		}
}


int SquishAreaSetLast(unsigned long usr,unsigned long lr)
{
	char path[91];
	FILE *fptr;
	int x=FALSE;
	unsigned long lr1;

	lr1=lr;

	sprintf(path,"%s%s.sql",mr.mbpath,mr.mbfile);
	fptr=fopen(path,"rb+");
	if(fptr==NULL){
		fptr=fopen(path,"wb");
		if(fptr==NULL)
			return -1;
		}
	if(fseek(fptr,usr * sizeof(unsigned long),SEEK_SET)==0)
		x=fwrite(&lr1,sizeof(unsigned long),1,fptr);
	fclose(fptr);
	return(x);
}


unsigned long SquishAreaGetLast(unsigned long usr)
{
	char path[91];
	FILE *fptr;
	unsigned long lr1;

	sprintf(path,"%s%s.sql",mr.mbpath,mr.mbfile);
	fptr=fopen(path,"rb");
	if(fptr==NULL)
		lr1=1L;
	else{
		if(fseek(fptr,usr * sizeof(unsigned long),SEEK_SET)==0)
			fread(&lr1,sizeof(unsigned long),1,fptr);
		fclose(fptr);
		}
	return lr1;
}

void mail_stats()
{
	unsigned long y,lo,hi,locl,i1,x;

	language(1470);
	language(1471);
	for(i1=0L;i1<total_mbases;i1++){
		y=OpenMsgArea(i1);
		hi=0L;
		lo=0L;
		locl=0L;
		x=0L;
		int2A(1,i1+1);
		char2A(2,mr.mbdisplay);
		mci("~SM`0F~ER3~&1`09) ~EL40~&2");
		if(y){
			hi=MI.high_msg;
			if(hi>0)	lo=1;
			while(ReadMsg(i1,x++,FALSE)){
				if(xmsg.attr & MSGLOCAL)	
					locl++;
				}
			}
		mci("`0F%5ld %5ld %5ld",lo,hi,locl);
		}
}

void get_initials(char *istr)
{
	int i=0,cnt=0;

	istr[cnt]=MI.From[i];	
	i++;
	cnt++;
	while(i<strlen(MI.From)-1){
		if(MI.From[i]==' ' && MI.From[i+1]!=' '){
			istr[cnt++]=MI.From[i+1];
			}
		i++;
		}
	istr[cnt]='\0';
}


void MsgExtractTxt()
{
	FILE *fptr;
	time_t tmt;
	struct tm *mtm;
	long lbeg, lend;
	char timestr[81],uinit[5],path[91],line[121],line2[121];

	strcpy(uinit,"    ");
	get_initials(uinit);	
	
	sprintf(path,"%s/msg.tmp",thisuser_temp_path);
	fptr=fopen(path,"wt");
	if(fptr==NULL)	return;

	lbeg=0;
	lend=0;
    tmt = stampToTimeT(&MI.date_written);
	mtm=localtime(&tmt);
	strftime(timestr,81,"%H:%M  %m/%d/%Y",mtm);

	char2A(1,timestr);
	char2A(2,MI.From);
	char2A(3,MI.To);
	char2A(4,MI.Subj);
	sprintf(line2,"~SM%s~SM",config.MsgReplyHdr);
	mcimacros(line2);
	mcihidden(line2);
	fprintf(fptr,line2);
	while(lend<buflen && lbeg<buflen){
		memset(line,0,120);
		/* Move along the line until we find a CR/NL or the user's */
		/* screen width */
		while((lend<buflen 					&& 
			lend<(thisuser.linelen+lbeg-10))	&& 
			buff[lend]!='\r' ){
			lend++;
			}
		/* Then we move back to the front of the line until we find a space. */
		while(	lend>lbeg 							&& 
				lend>0 								&& 
				buff[lend]!=' ' 					&& 
				buff[lend]!='\r'){
			lend--;
			}
		if((lend-lbeg)>0){
			memcpy(line,buff+lbeg,lend-lbeg);
			stripCR(line); 
			sprintf(line2,"%s> %s",uinit,line);
			if(strlen(line2)>80) line2[81]='\0';
			fprintf(fptr,"%s\n",line2);
			}
		else
			fprintf(fptr,"\n");
		lend++;
		lbeg=lend;
		}
	fclose(fptr);
}

void MsgExtractFull()
{
	FILE *fptr;
	long lbeg, lend;
	char path[91],line[121];
	time_t tmt;
	struct tm *mtm;
	char faddr[81],timestr[81],fflags[41],namestr[81],tostr[81];
	unsigned int repf,rept,i;

	language(1319);
	*path='\0';
	get_str(path,75);

	if(strlen(path)<1) {
		mci("~SMBad path.~SM~SP");
		return;
		}
	fptr=fopen(path,"wt");
	if(fptr==NULL)	{
		mci("~SMCan not open file %s for writing.~SM~SP",path);
		return;
		}

	strcpy(line,"      B  E  G  I  N    E  X  T  R  A  C  T  E  D    M  E  S  S  A  G  E      \n");
	fprintf(fptr,"%s",line);
	strcpy(line,"-----------------------------------------------------------------------------\n");
	fprintf(fptr,"%s",line);
	language(1393);
	if(yesno()){
		rept=MI.replyto;
		repf=MI.replies[0];
		*fflags='\0';
		FidoFlags(fflags);
	
		if(mr.Kind!=LOCAL && mr.Kind!=EMAIL){
			if(MI.orig.point)
				sprintf(faddr,"%d:%d/%d.%d", 
					MI.orig.zone, MI.orig.net, MI.orig.node,MI.orig.point);
			else
				sprintf(faddr,"%d:%d/%d", 
					MI.orig.zone, MI.orig.net, MI.orig.node);
			sprintf(namestr,"%s@%s",MI.From,faddr);
			}
		else{ sprintf(namestr,"%s",MI.From); }
		if(mr.Kind==NETMAIL){
			if(MI.dest.point)
				sprintf(faddr,"%d:%d/%d.%d", 
					MI.dest.zone, MI.dest.net, MI.dest.node,MI.dest.point);
			else
				sprintf(faddr,"%d:%d/%d", 
					MI.dest.zone, MI.dest.net, MI.dest.node);
			sprintf(tostr,"%s@%s",MI.To,faddr);
			}
		else
			sprintf(tostr,"%s",MI.To);

		tmt = stampToTimeT(&MI.date_written);
		mtm=localtime(&tmt);
		strftime(timestr,81,"%H:%M  %m/%d/%Y",mtm);

		char2A(1,namestr);
		char2A(2,tostr);
		char2A(3,MI.Subj);
		char2A(5,fflags);
		char2A(6,timestr);

		for(i=1030;i<1040;i++){
			switch(i){
				case 1030:
				case 1031:
				case 1032:
				case 1033:
				case 1036:
				case 1039:
					strcpy(line,lingostr(i));
					mciEseries(line);
					mcimacros(line);
					mcicolor(line,FALSE);
					stripSC(line);
					mcihidden(line);
					fprintf(fptr,"%s",line);
					break;
				}
			}
		}

	lbeg=0;
	lend=0;
	
	fprintf(fptr,"\n");
	while(lend<buflen && lbeg<buflen){
		memset(line,0,120);
		/* Move along the line until we find a CR/NL or the user's */
		/* screen width */
		while((lend<buflen)						&& 
			lend<(thisuser.linelen+lbeg)		&& 
			buff[lend]!='\r' ){
			lend++;
			}
		/* Then we move back to the front of the line until we find a space. */
		while(	lend>lbeg 							&& 
				lend>0 								&& 
				buff[lend]!=' ' 					&& 
				buff[lend]!='\r'){
			lend--;
			}
		if((lend-lbeg)>0){
			memcpy(line,buff+lbeg,lend-lbeg);
			stripCR(line); 
			fprintf(fptr,"%s\n",line);
			}
		else
			fprintf(fptr,"\n");
		lend++;
		lbeg=lend;
		}
	fclose(fptr);
}



void MsgScanArea(unsigned long marea)
{
	char from[41],subj[41];
	int done=FALSE,count=0;
	unsigned long LastRead=1L;
	char timestr[81];
	time_t tmt;
	struct tm *mtm;

	if(!OpenMsgArea(marea)){
		mci("~SMUnable to read message base #%d~SM~SP",marea);
		return;
		}
	language(1489);
	language(1490);

	while(ReadMsg(marea,LastRead++,FALSE)){
		GetMsg();
		Add2MsgInfo();
   		tmt = stampToTimeT(&MI.date_written);
		mtm=localtime(&tmt);
		strftime(timestr,81,"%m/%d",mtm);
		strcpy(from,MI.From);
		strcpy(subj,MI.Subj);
		mcistrset(from,20);
		mcistrset(subj,40);
		
		int2A(1,MI.cur_msg);
		char2A(2,timestr);
		char2A(3,from);
		char2A(4,subj);
		language(1492);
		count++;
		if(count>thisuser.pagelen-3){
			count=0;
			if(ync()=='N')	done=TRUE;
			}
		}
	mci("~SM~SP");
}

int ReadOrScanMsgs(int ros, int multi)
{
	int retval=TRUE;

	do{

		if(ros)	retval=ReadMsg(thisuser.lastmbarea,thisuser.lastmsg,TRUE);
		else	NextTenMsgs(thisuser.lastmbarea);
		if(!retval && multi && thisuser.lastmbarea < total_mbases){
			thisuser.lastmbarea++;
			if(OpenMsgArea(thisuser.lastmbarea)){
				thisuser.lastmsg=1L;
				thisuser.lastmsg=GetLastRead(thisuser.userID);
				language(1250);
				}
			else
				thisuser.lastmbarea--;
			}

		}while(!retval && (thisuser.lastmbarea < total_mbases-1) && multi);

	if(!retval && multi){
		thisuser.lastmbarea--;
		}

	return retval;
}

int NextTenMsgs(unsigned long mbarea)
{
	char to[41],from[41],subj[41];
	int i,retval=TRUE;

	if(!OpenMsgArea(mbarea)){
		mci("~SMThis message area is unavailable.~SM~SP");
		retval=FALSE;
		return retval;
		}
	language(1075);
	language(1076);
	i=thisuser.lastmsg+10;
	while(thisuser.lastmsg<i && thisuser.lastmsg<MI.high_msg){
		thisuser.lastmsg++;
		ReadMsg(mbarea,thisuser.lastmsg,FALSE);
		strcpy(from,MI.From);
		mcistrset(from,20);
		strcpy(to,MI.To);
		mcistrset(to,20);
		strcpy(subj,MI.Subj);
		mcistrset(subj,30);
		
		char2A(1,"");
		int2A(2,thisuser.lastmsg);
		char2A(3,from);
		char2A(4,to);
		char2A(6,subj);
		language(1077);
		}
	mci("~SM");
	return retval;
	
}

void IgnoreTheRest(unsigned long marea)
{
	OpenMsgArea(marea);
	thisuser.lastmsg=MI.high_msg+1;
	SetLastRead(thisuser.userID,MI.high_msg);	
}

void BypassTheRest(unsigned long marea)
{
	SetLastRead(thisuser.userID,thisuser.lastmsg);	
	OpenMsgArea(marea);
	thisuser.lastmsg=MI.high_msg+1;
}

void zonematch(int tzone, char *zonestr)
{
	int i;

	for(i=0;i<20;i++){
		if(config.aka[i].zone==tzone)
			strcpy(zonestr,config.aka[i].domain);
		}
}

int GoToReplyTo(unsigned long mbarea)
{
	if(!OpenMsgArea(mbarea))	return 0;
	if(MI.replyto!=0)
		thisuser.lastmsg=thisuser.lastmsg;
	else{
		language(1335);
		}
	return 1;
}

void GoNextMsgArea()
{
	unsigned long oldarea;

	oldarea=thisuser.lastmbarea;	
	thisuser.lastmbarea++;
	while(thisuser.lastmbarea!=oldarea){
		if(thisuser.lastmbarea<total_mbases){
			if(OpenMsgArea(thisuser.lastmbarea)){
				if(checkACS(mr.ReadACS)){
					return;
					}
				}
			thisuser.lastmbarea++;
			}
		else
			thisuser.lastmbarea=0;
		}
}

void GoPrevMsgArea()
{
	unsigned long oldarea;

	oldarea=thisuser.lastmbarea;
	thisuser.lastmbarea--;
	while(thisuser.lastmbarea!=oldarea){
		if(thisuser.lastmbarea>=0){
			if(OpenMsgArea(thisuser.lastmbarea)){
				if(checkACS(mr.ReadACS)){
					return;
					}
				}
			thisuser.lastmbarea--;
			}
		else
			thisuser.lastmbarea=(total_mbases-1);
		}
}

void SendEmail(char *Towho, char *Subj)
{

	char towho[51],ok=TRUE;

	int mbnum=0;
	do{
		ok=OpenMsgArea(mbnum++);
		}while(mr.Kind!=EMAIL && mbnum<total_mbases && ok);

	if(mr.Kind!=EMAIL){
		mci("~SMUnable to find an Email Message Area.");
		mci("~SMAborting.~SM");
			return;
		}

	mci("~SMPosting message to %s~SM",mr.mbdisplay);
	mbnum--;

	if(strcasecmp(Towho,"SYSOP")==0){
		read_usr(&othr,0);
		strcpy(towho,othr.alias);
		}
	else
		strcpy(towho,Towho);

	if(mr.Allowalias)
		fill_xmsg(thisuser.alias,towho,Subj);
	else
		fill_xmsg(thisuser.realname,towho,Subj);

	PostMsg(mbnum);
}
