/*****************************************************************************
 *
 * File ..................: mbasedit.c
 * Purpose ...............: Message base editor routines.
 * Last modification date : 08-Feb-2001
 *
 *****************************************************************************
 * Copyright (C) 2000-2001
 *   
 * Darryl Perry			
 * FIDO:		1:211/105
 * Internet:	dperry.geo@yahoo.com
 *
 * This file is part of Gryphon/X BBS.
 *
 * This BBS is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Gryphon/X BBS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Gryphon/X BBS; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/

#include "structs.h"
#include "defs.h"
#include "acs.h"
#include "misc.h"
#include "basics.h"
#include "config.h"
#include "fileio.h"
#include "mci.h"
#include "msgapi.h"
#include "mbasedit.h"
#include "conio.h"

char mbtypes[5][21]={"Local","Netmail","Echomail","Email","NewsGroup"};
char posttyp[2][11]={"Public","Private"};

void import_backbone();

void mbeditmenu()
{
	int done=FALSE,x,page=0;
	char ch;
	
	while(!done){
		clr_scr();
		nl();
		mci("`0EMessage Base Editor`09");nl();
		nl();
		repeat(196,78);nl();
		x=list_message_bases(page);mci("`09");
		repeat(196,78);
		mci("~SMMessage Editor (]/[=Next/Prev, Q=Quit, ?=Help)`0F: ");
		ch=onekey("[]IMDPQB");
		switch(ch){
			case 'D':	delete_mbase();	break;
			case 'I': 	insert_mbase();	break;
			case 'M':	modify_mbase();	break;
			case 'P':	move_mbase();	break;
			case 'B':	import_backbone();	break;
			case 'Q': 	done=TRUE;		break;
			case '[':	
				page--;
				if(page<0)
					page=0;
				break;
			case ']':
				if(x)
					page++;
				break;
			}
		}
}

int list_message_bases(int page)
{
	int i1,rno,retval=TRUE;
	mb_list_rec mbl;
	char disp[61],tType[12];

	for(i1=0;i1<15;i1++){
		rno=(page*15);
		if(read_mbaselist(&mbl,rno+i1)){
			strcpy(disp,mbl.mbdisplay);
			mcistrset(disp,35);
			if(mbl.Type==MSGTYPE_JAM)	strcpy(tType,"Jam");
			if(mbl.Type==MSGTYPE_SQUISH)strcpy(tType,"Squish");
			mci("`0F%3d `0E%s `0F%-12.12s `09%7.7s %7.7s %7.7s",
				rno+1+i1,
				disp,
				mbl.mbfile,  
				mbtypes[mbl.Kind],tType,
				posttyp[mbl.Pubpriv]);
			}
		else {
			mci("`0F%3d",rno+1+i1);
			retval=FALSE;
			}
		nl();
		}
	return(retval);
}

void init_mbase(mb_list_rec *mb)
{
	strcpy(mb->mbdisplay,"New Message Base");
	strcpy(mb->mbpath,config.DefMsg.mbpath);
	strcpy(mb->mbfile,"newbase");
	copy_ACS(&mb->SysopACS,&config.DefMsg.SysopACS);
	copy_ACS(&mb->ReadACS,&config.DefMsg.ReadACS);
	copy_ACS(&mb->WriteACS,&config.DefMsg.WriteACS);
	copy_ACS(&mb->NetworkACS,&config.DefMsg.NetworkACS);
	strcpy(mb->OriginLine,config.DefMsg.OriginLine);
	mb->colors[MSG_QUOTE]=config.DefMsg.colors[MSG_QUOTE];
	mb->colors[MSG_TEXT]=config.DefMsg.colors[MSG_TEXT];
	mb->colors[MSG_TEAR]=config.DefMsg.colors[MSG_TEAR];
	mb->colors[MSG_ORIGIN]=config.DefMsg.colors[MSG_ORIGIN];
	mb->Kind=config.DefMsg.Kind;
	mb->Type=config.DefMsg.Type;
	mb->Pubpriv=config.DefMsg.Pubpriv;
	mb->Allowalias=config.DefMsg.Allowalias;
	mb->scantype=config.DefMsg.scantype;
	mb->fidoaddr=config.DefMsg.fidoaddr;
	mb->MaxMsgs=config.DefMsg.MaxMsgs;
	mb->MaxAge=config.DefMsg.MaxAge;
}

void kill_mbase(int mbnum)
{
	mb_list_rec mbin;
	int i1,count=0;
	char ppath[81];

	i1=0;
	while(read_mbaselist(&mbin,i1)){
		if(i1!=mbnum){
			mbin.idx=count;
			count++;
			if(!save_mbasetemp(&mbin,mbin.idx)){
				mci("Error saving to temp file.");nl();
				}
			}
		i1++;	
		}

	sprintf(ppath,"%smbases.data",config.datapath); 
	remove(ppath);
	i1=0;
	while(read_mbasetemp(&mbin,i1)){
		save_mbaselist(&mbin,mbin.idx);
		i1++;
		}
	sprintf(ppath,"%smbases.data.temp",config.datapath); 
	remove(ppath);
	total_mbases--;
}

void delete_mbase()
{
	char ttxt[21];
	int num;

	nl();
	mci("Delete which? [1-%d]: ",total_mbases);
	*ttxt='\0';
	num=get_num(ttxt)-1;
	if(num>=0 && num<=total_mbases){
		kill_mbase(num);
		}
}

void poke_mbase(int pokenum)
{
	mb_list_rec mbin;
	int i1;

	if(total_mbases>0){
		for(i1=total_mbases;i1>pokenum;i1--){
			printf("\n\rA");
			read_mbaselist(&mbin,i1-1);
			printf("\n\rB");
			mbin.idx++;
			printf("\n\rC");
			save_mbaselist(&mbin,mbin.idx);
			printf("\n\rD");
			}
		}
	else
		pokenum=0;
	init_mbase(&mbin);
	mbin.idx=pokenum;
	save_mbaselist(&mbin,mbin.idx);
	total_mbases++;
}

void insert_mbase()
{
	char ttxt[21];
	int num;
	mb_list_rec mbin;

	nl();
	mci("Insert before which? [1-%d]: ",total_mbases+1);
	*ttxt='\0';
	num=get_num(ttxt)-1;
	if(num>=0 && num<=total_mbases){
		if(num==0 && total_mbases==0){
			init_mbase(&mbin);
			mbin.idx=total_mbases;
			save_mbaselist(&mbin,mbin.idx);
			total_mbases++;
			}
		else{
			poke_mbase(num);
			}
		}
	else {
		nl();
		mci("Invalid number.  Try again!");nl();
		paws();
		}
}

void swap_mbase(int iFrom, int iTo)
{
	mb_list_rec mbto,mbfrom;
	int i1;


	read_mbaselist(&mbfrom,iFrom);

	if(iFrom<iTo){
		for(i1=iFrom+1;i1<=iTo;i1++){
			read_mbaselist(&mbto,i1);
			mbto.idx--;
			save_mbaselist(&mbto,mbto.idx);
			}
		}
	else{
		for(i1=iFrom;i1>iTo;i1--){
			read_mbaselist(&mbto,i1-1);
			mbto.idx++;
			save_mbaselist(&mbto,mbto.idx);
			}
		}

	mbfrom.idx=iTo;
	save_mbaselist(&mbfrom,mbfrom.idx);
}


void move_mbase()
{
	char ttxt[21],ttxt1[21];
	int num,num1;

	nl();
	mci("Position which? [1-%d]: ",total_mbases);
	*ttxt1='\0';
	num1=get_num(ttxt1)-1;
	if(num1>=0 && num1<total_mbases){
		mci("`09    Move to which? [1-%d]: ",total_mbases);
		*ttxt='\0';
		num=get_num(ttxt)-1;
		if(num>=0 && num<total_mbases)
			swap_mbase(num1,num);
		else {
			nl();
			mci("Invalid number.  Try again!");nl();
			paws();
			}
		}
	else{
		nl();
		mci("Invalid Number.  Try again!");nl();
		paws();
		}
}


void modify_mbase()
{
	char ttxt[21];
	int num;

	nl();
	mci("Modify which? [1-%d]: ",total_mbases);
	*ttxt='\0';
	num=get_num(ttxt)-1;
	num=atoi(ttxt)-1;
	if(num>=0 && num<=total_mbases){
		mod_mbase(num);
		}
}

int pick_aka()
{
	char ttxt[3];
	int num;

	while(1){
		clr_scr();
		nl();nl();
		list_akas();
		mci("~SM~SM`09Enter network address (1-20): `1F");
		ttxt[0]='\0';
		num=get_num(ttxt)-1;
		if(num>=0 && num<20)
			return(num);
		else
			return(0);
		}
}

void mod_mbase(int mbnum)
{
	int done=FALSE;
	char ch,faka[41];
	mb_list_rec mbl;
	char sigtxt[3][21]={"None","Short Sig.","Long Sig."};

	read_mbaselist(&mbl,mbnum);
	if(mbl.sigtype<0 || mbl.sigtype>2)	mbl.sigtype=0;
	while(!done){
		faddr2char(faka,&config.aka[mbl.fidoaddr]);
		clr_scr();
		mci("~SMModifying Message Base %d of %d~SM~SM",mbnum+1,total_mbases);
		mci("`09(`0EA`09). `0FDisplay       : %s~SM",mbl.mbdisplay);
		mci("`09(`0EB`09). `0FFilename      : %s~SM",mbl.mbfile);
		mci("`09(`0EK`09). `0FMsg Type      : %s~SM",
			(mbl.Type==MSGTYPE_JAM)?"Jaam":"Squish");
		mci("`09(`0EC`09). `0FMsg Path      : %s~SM",mbl.mbpath);
		mci("`09(`0EH`09). `0FMsg Kind      : %s~SM",mbtypes[mbl.Kind]);
		mci("`09(`0EI`09). `0FPosting Type  : %s~SM",posttyp[mbl.Pubpriv]);
		mci("`09(`0EO`09). `0FInfo Filename : %s~SM",mbl.infofile);
		mci("`09(`0EN`09). `0FAllow Aliases : %s~SM",
			(mbl.Allowalias)?lingostr(1):lingostr(2));
		mci("`09(`0ED`09). `0FPost ACS      : ~SM");
		mci("`09(`0EE`09). `0FRead ACS      : ~SM");
		mci("`09(`0EF`09). `0FSysop ACS     : ~SM");
		mci("`09(`0EM`09). `0FSignature     : %s~SM",sigtxt[mbl.sigtype]);
		mci("`09(`0EJ`09). `0FMail address  : %s~SM",faka);
		mci("`09(`0EL`09). `0FColors        : ");
		mci("%sQuoted (%d)`0F, ", 
			ansic(mbl.colors[MSG_QUOTE]),
			mbl.colors[MSG_QUOTE]);
		mci("%sText (%d)`0F,",
			ansic(mbl.colors[MSG_TEXT]),
			mbl.colors[MSG_TEXT]);
		mci("%sTear (%d)`0F,",
			ansic(mbl.colors[MSG_TEAR]),
			mbl.colors[MSG_TEAR]);
		mci("%sOrigin (%d)~SM",
			ansic(mbl.colors[MSG_ORIGIN]),
			mbl.colors[MSG_ORIGIN]);

		mci("`09(`0EG`09). `0FOrigin Line   : %s",mbl.OriginLine);nl();
		nl();
		mci("`09Modify Messegebase (]/[=Next/Prev, Q=Quit ?=Help)`0F: ");
		ch=onekey("ABCDEFGHIJKLMNQO[]");
		switch(ch){
			case '[':
				save_mbaselist(&mbl,mbnum);
				if(mbnum>0)	mbnum--;	
				else		mbnum=0;
				read_mbaselist(&mbl,mbnum);
				break;
			case ']':
				save_mbaselist(&mbl,mbnum);
				if(mbnum<total_mbases-1)	mbnum++;	
				else					mbnum=total_mbases-1;
				read_mbaselist(&mbl,mbnum);
				break;
			case 'A':
				nl(); nl(); mci("Enter New Display:~SM: `1F");
				get_str(mbl.mbdisplay,40);
				break;
			case 'B':
				nl(); nl(); mci("Enter New Filename:~SM: `1F");
				get_str(mbl.mbfile,20);
				break;
			case 'C':
				nl(); nl(); mci("Enter New Message Path:~SM: `1F");
				get_filename(mbl.mbpath,75);
				break;
			case 'D':	ACS_setup(&mbl.WriteACS,mbl.mbdisplay);	break;
			case 'E':	ACS_setup(&mbl.ReadACS,mbl.mbdisplay);	break;
			case 'F':	ACS_setup(&mbl.SysopACS,mbl.mbdisplay);	break;
			case 'G':
				mci("~SM~SMEnter New Origin Line:~SM: `1F");
				get_str(mbl.OriginLine,64);
				break;
			case 'H':
				mbl.Kind++;
				if(mbl.Kind>4)
					mbl.Kind=0;
				switch(mbl.Kind){
					case LOCAL  : mbl.Pubpriv=PUBLIC;	break;
					case ECHO   : mbl.Pubpriv=PUBLIC;	break;
					case NETMAIL: mbl.Pubpriv=PRIVATE;	break;
					case EMAIL  : mbl.Pubpriv=PRIVATE;	break;
					case NEWS   : mbl.Pubpriv=PUBLIC;	break;
					}
				break;
			case 'I':
				if(mbl.Pubpriv==PUBLIC) {
					switch(mbl.Kind){
						case LOCAL	 : mbl.Pubpriv=PRIVATE;	break;
						case ECHOMAIL: mbl.Pubpriv=PUBLIC;	break;
						case NETMAIL : mbl.Pubpriv=PRIVATE;	break;
						case EMAIL   : mbl.Pubpriv=PRIVATE;	break;
						case NEWS	 : mbl.Pubpriv=PUBLIC;	break;
						}
					}
				else{
					switch(mbl.Kind){
						case LOCAL		: mbl.Pubpriv=PUBLIC;	break;
						case ECHOMAIL 	: mbl.Pubpriv=PUBLIC;	break;
						case NETMAIL	: mbl.Pubpriv=PRIVATE;	break;
						case EMAIL  	: mbl.Pubpriv=PRIVATE;	break;
						case NEWS		: mbl.Pubpriv=PUBLIC;	break;
						}
					}
				break;
			case 'J':
				mbl.fidoaddr=pick_aka();
				break;
			case 'K':
				if(mbl.Type==MSGTYPE_JAM)	mbl.Type=MSGTYPE_SQUISH;
				else						mbl.Type=MSGTYPE_JAM;
				break;
			case 'L':	msg_color_config(&mbl);	break;
			case 'M':
				mbl.sigtype++;
				if(mbl.sigtype<0 || mbl.sigtype>2)
					mbl.sigtype=0;
				break;
			case 'N': mbl.Allowalias=(mbl.Allowalias)?0:1; break;
			case 'Q':	
				save_mbaselist(&mbl,mbnum); 
				save_msgbase(&mbl);
				done=TRUE;
				break;
			case 'O':
				mci("~SM~SMInfo File: `1F");
				get_str(mbl.infofile,35);
				break;
			}
		}
}

void save_msgbase(mb_list_rec *mb)
{
	struct _minf m;
	HAREA harea;
	HMSG hmsg;
	char path[81];

	sprintf(path,"%s%s",mb->mbpath,mb->mbfile);

	m.req_version = 0;
	m.def_zone = 1;
	if(MsgOpenApi(&m)==0){
		harea = MsgOpenArea(path,MSGAREA_CRIFNEC,mb->Type | MSGTYPE_ECHO);
		if(harea!=NULL){
			hmsg=MsgOpenMsg(harea,MOPEN_CREATE,0);
			if(hmsg!=NULL) 	MsgCloseMsg(hmsg);
			else 			mci("~SMUnable to create message area.");
		 	MsgCloseArea(harea);
			}
		else 				mci("~SM~SMUnable to open %s~SM",path);
		MsgCloseApi();
		}
}

void import_backbone()
{
	FILE *fptr;
	char bbtxt[121],*p;
	mb_list_rec mb;

	mci("~SM~SMPath to BACKBONE.NA~SM: ");
	get_filename(bbtxt,76);
	if(!file_exist(bbtxt)){
		mci("~SMUnable to locate file.");
		return;
		}
	fptr=fopen(bbtxt,"rt");
	if(fptr==NULL){
		mci("~SMUnable to open file.");
		return;
		}
	while(fgets(bbtxt,121,fptr)!=NULL){
		init_mbase(&mb);
		p=strtok(bbtxt," ");
		strcpy(mb.mbfile,p);
		strlwr(mb.mbfile);

		p=strtok(NULL,"\n\r");
		while(*(p)==' ') 
			*(p++);
		strncpy(mb.mbdisplay,p,60);

		mb.idx=total_mbases;
		save_mbaselist(&mb,mb.idx);
		save_msgbase(&mb);
		total_mbases++;
		}
	mci("~SP");
	fclose(fptr);
}
