/*****************************************************************************
 *
 * File ..................: mci.c
 * Purpose ...............: MaCro Interpretor routines.
 * Last modification date : 08-Feb-2001
 *
 *****************************************************************************
 * Copyright (C) 2000-2001
 *   
 * Darryl Perry			
 * FIDO:		1:211/105
 * Internet:	dperry.geo@yahoo.com
 *
 * This file is part of Gryphon/X BBS.
 *
 * This BBS is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Gryphon/X BBS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Gryphon/X BBS; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/

#include "structs.h"
#include "defs.h"
#include "basics.h"
#include "fileio.h"
#include "mci.h"
#include "nodedit.h"
#include "conio.h"
#include "misc.h"
#include <stdarg.h>
#include <stdio.h>

char fstr[41];
char A[10][128];
char retstr[128];

void mciEseries(char *ttxt)
{
	char *p,t1[512],ch=0,dump[41];
	int i,num=0,num1=0;

	while(strstr(ttxt,"~EC"))	strrepl(ttxt,500,"~EC","\x1b[");

	while((p=strstr(ttxt,"~EE"))){  /*  Create pattern of spaces to len n */
		if(isdigit(*(p+3))){
			num=*(p+3)-'0';
			}
		if(isdigit(*(p+4))){
			num*=10;
			num+= (*(p+4)-'0');
			}

		for(num1=0;num1<num;num1++) t1[num1]=' ';

		t1[num1]='\0';
		sprintf(dump,"~EE%c%d",ch,num);
		strrepl(ttxt,500,dump,t1);
		}
	
	while((p=strstr(ttxt,"~EF"))){    /*  Create fill pattern of c to len n */
		ch=*(p+3); 
		if(isdigit(*(p+4))){
			num=*(p+4)-'0';
			}
		if(isdigit(*(p+5))){
			num*=10;
			num+= (*(p+5)-'0');
			}

		for(num1=0;num1<num;num1++) t1[num1]=ch;

		t1[num1]='\0';
		sprintf(dump,"~EF%c%d",ch,num);
		strrepl(ttxt,500,dump,t1);
		}

	while((p=strstr(ttxt,"~EL"))){
		i=3;num=0;
		while(isdigit( *(p+i) ) ){
			num=(num*10) + (*(p+i)-'0');
			i++;
			}
		
		t1[0]=*(p+i); i++; 
		t1[1]=*(p+i); i++;
		t1[2]=*(p+i); i++;
		t1[3]='\0';

		sprintf(dump,"~EL%d%s",num,t1);
		mcimacros(t1);
		mcistrset(t1,num);
		strrepl(ttxt,500,dump,t1);
		}
	
	while((p=strstr(ttxt,"~EK"))){  /* Center & Justify, expand to n */
		dump[0]=*(p+3); dump[1]=*(p+4); dump[2]='\0'; num=atoi(dump);
		t1[0]=*(p+5); t1[1]=*(p+6); t1[2]=*(p+7); t1[3]='\0';

		sprintf(dump,"~EK%d%s",num,t1);
		mcimacros(t1);
		mcistrcset(t1,num);
		strrepl(ttxt,500,dump,t1);
		}
	while((p=strstr(ttxt,"~EN"))){  /* Strip all spaces*/
		t1[0]=*(p+3); t1[1]=*(p+4); t1[2]=*(p+5); t1[3]='\0';

		sprintf(dump,"~EN%s",t1);
		mcimacros(t1);
		while(strstr(t1," "))	strrepl(t1,500," ","");
		strrepl(ttxt,500,dump,t1);
		}

	while((p=strstr(ttxt,"~ER"))){
		i=3;num=0;
		while(isdigit( *(p+i) ) ){
			num=(num*10) + (*(p+i)-'0');
			i++;
			}

		t1[0]=*(p+i); i++;
		t1[1]=*(p+i); i++;
		t1[2]=*(p+i); i++;
		t1[3]='\0';

		sprintf(dump,"~ER%d%s",num,t1);
		mcimacros(t1);
		mcistrrset(t1,num);
		strrepl(ttxt,500,dump,t1);
		}

	while((p=strstr(ttxt,"~EU"))){  /* Convert to upper case */
		t1[0]=*(p+3); t1[1]=*(p+4); t1[2]=*(p+5); t1[3]='\0';

		sprintf(dump,"~EU%s",t1);
		mcimacros(t1);
		strupr(t1);
		strrepl(ttxt,500,dump,t1);
		}

	while((p=strstr(ttxt,"~EW"))){  /* Convert to lower case */
		t1[0]=*(p+3); t1[1]=*(p+4); t1[2]=*(p+5); t1[3]='\0';

		sprintf(dump,"~EW%s",t1);
		mcimacros(t1);
		strlwr(t1);
		strrepl(ttxt,500,dump,t1);
		}
	while((p=strstr(ttxt,"~ES"))){
		ttxt[p-ttxt]='\0';
		mcicolor(p+3,FALSE);
		strcat(ttxt,p+3);
		}
}


void mciAnd(char *ttxt)
{
	while(strstr(ttxt,"~&Y"))	strrepl(ttxt,500,"~&Y",lingostr(1));
	while(strstr(ttxt,"~&N"))	strrepl(ttxt,500,"~&N",lingostr(2));
	while(strstr(ttxt,"~&1"))	strrepl(ttxt,500,"~&1",A[1]);
	while(strstr(ttxt,"~&2"))	strrepl(ttxt,500,"~&2",A[2]);
	while(strstr(ttxt,"~&3"))	strrepl(ttxt,500,"~&3",A[3]);
	while(strstr(ttxt,"~&4"))	strrepl(ttxt,500,"~&4",A[4]);
	while(strstr(ttxt,"~&5"))	strrepl(ttxt,500,"~&5",A[5]);
	while(strstr(ttxt,"~&6"))	strrepl(ttxt,500,"~&6",A[6]);
	while(strstr(ttxt,"~&7"))	strrepl(ttxt,500,"~&7",A[7]);
	while(strstr(ttxt,"~&8"))	strrepl(ttxt,500,"~&8",A[8]);
	while(strstr(ttxt,"~&9"))	strrepl(ttxt,500,"~&9",A[9]);
}

void mciCseries(char *ttxt)
{
	mfgrouprec grp;
	char dump[121];
	long ts;
	time_t t;
	struct tm *ttm;

	(void) time(&t);
	ttm=localtime(&t);

	while(strstr(ttxt,"~CC")){
		readgroup(&grp,thisuser.lastgroup-'A');
		sprintf(dump,"%s",grp.grp[0].display);
		strrepl(ttxt,500,"~CC",dump); }
	while(strstr(ttxt,"~CE")){
		ttm=localtime(&thisuser.tltoday);
		sprintf(dump,"%02d",ttm->tm_sec);
		strrepl(ttxt,500,"~CE",dump); }
	while(strstr(ttxt,"~CG")){
		sprintf(dump,"%c",thisuser.lastgroup);
		strrepl(ttxt,500,"~CG",dump); }
	while(strstr(ttxt,"~CF")){
		strrepl(ttxt,500,"~CF",config.phone); }
	while(strstr(ttxt,"~CM")){
		ttm=localtime(&thisuser.tltoday);
		sprintf(dump,"%02d",ttm->tm_min);
		strrepl(ttxt,500,"~CM",dump); }
	while(strstr(ttxt,"~CO")){
		ts=t-thisuser.laston;
		show_timeleft(ts,dump);
		strrepl(ttxt,500,"~CO",dump); }
	while(strstr(ttxt,"~CT")){
		show_timeleft(thisuser.tltoday,dump);
		strrepl(ttxt,500,"~CT",dump); }
	while(strstr(ttxt,"~CP")){
		strrepl(ttxt,500,"~CP",thisuser_temp_path); }
	while(strstr(ttxt,"~CN"))	{
		sprintf(dump,"%d",iMyNode);
		strrepl(ttxt,500,"~CN",dump); }
}

void mciMseries(char *ttxt)
{
	mb_list_rec mb;
	char dump[121];
	read_mbaselist(&mb,thisuser.lastmbarea);

	while(strstr(ttxt,"~MA"))	{
		faddr2char(dump,&config.aka[mb.fidoaddr]);
		strrepl(ttxt,500,"~MA",dump); }
	while(strstr(ttxt,"~MB"))	{
		strrepl(ttxt,500,"~MB",mb.mbdisplay); }
	while(strstr(ttxt,"~MF"))	{
		strrepl(ttxt,500,"~MF",mb.mbfile); }
	while(strstr(ttxt,"~MH"))	{
		sprintf(dump,"%ld",MH);
		strrepl(ttxt,500,"~MH",dump); }
	while(strstr(ttxt,"~MI"))	{
		strrepl(ttxt,500,"~MI",mb.infofile); }
	while(strstr(ttxt,"~ML"))	{
		sprintf(dump,"%ld",ML);
		strrepl(ttxt,500,"~ML",dump); }
	while(strstr(ttxt,"~MO"))	{
		sprintf(dump,"%ld",MO);
		strrepl(ttxt,500,"~MO",dump); }
	while(strstr(ttxt,"~MN")){
		sprintf(dump,"%d",thisuser.lastmbarea+1);
		strrepl(ttxt,500,"~MN",dump); }
}

void mciUseries(char *ttxt)
{
	char dump[121];
	char ttype[4][11]={"ASCII","ANSI","AVATAR","RIP"};
	int i;
	time_t t;
	struct tm *ttm;

	(void) time(&t);
	ttm=localtime(&t);

	while(strstr(ttxt,"~UA"))	strrepl(ttxt,500,"~UA",thisuser.location);
	while(strstr(ttxt,"~UB"))	strrepl(ttxt,500,"~UB",thisuser.street);
	while(strstr(ttxt,"~UC"))	strrepl(ttxt,500,"~UC",thisuser.zipcode);
	while(strstr(ttxt,"~UD"))	strrepl(ttxt,500,"~UD",thisuser.phone1);
	while(strstr(ttxt,"~UE"))	strrepl(ttxt,500,"~UE",thisuser.phone2);
	while(strstr(ttxt,"~UF"))	{
			strrepl(ttxt,500,"~UF",thisuser.realname);
			for(i=0;i<strlen(ttxt);i++){
				if(ttxt[i]==' ')
					ttxt[i]='\0';
				}
			}
	while(strstr(ttxt,"~UG"))	{
		sprintf(dump,"%c",thisuser.gender);
		strrepl(ttxt,500,"~UG",dump);
		}
	while(strstr(ttxt,"~UH"))	strrepl(ttxt,500,"~UH",thisuser.alias);
	while(strstr(ttxt,"~UI")){
		ttm=localtime(&thisuser.laston);
		switch(thisuser.datefmt){
			case 0:	strftime(dump,40,"%m**%d**%Y",ttm); break;
			case 1:	strftime(dump,40,"%d**%m**%Y",ttm); break;
			case 2:	strftime(dump,40,"%Y**%m**%d",ttm); break;
			default: strftime(dump,40,"%m**%d**%Y",ttm); break;
			}
		if(strcmp(lingostr(83),"**")!=0)
			while(strstr(dump,"**"))	
				strrepl(dump,40,"**",lingostr(83));
		strrepl(ttxt,500,"~UI",dump);
		}
	while(strstr(ttxt,"~UJ")){
		memset(dump,0,41);
		ttm=localtime(&thisuser.laston);
		strftime(dump,40,"%H##%M##%S",ttm);
		if(strcmp(lingostr(84),"##")!=0)
			while(strstr(dump,"##"))	
				strrepl(dump,40,"##",lingostr(84));
		strrepl(ttxt,500,"~UJ",dump);}

	while(strstr(ttxt,"~UK")){
		ttm=localtime(&thisuser.firston);
		switch(thisuser.datefmt){
			case 0:	strftime(dump,40,"%H##%M##%S  %m**%d**%Y",ttm); break;
			case 1:	strftime(dump,40,"%H##%M##%S  %d**%m**%Y",ttm); break;
			case 2:	strftime(dump,40,"%H##%M##%S  %Y**%m**%d",ttm); break;
			default: strftime(dump,40,"%H##%M##%S  %m**%d**%Y",ttm); break;
			}
		if(strcmp(lingostr(84),"##")!=0)
			while(strstr(dump,"##"))	
				strrepl(dump,40,"##",lingostr(84));
		if(strcmp(lingostr(83),"**")!=0)
			while(strstr(dump,"**"))	
				strrepl(dump,40,"**",lingostr(83));
		strrepl(ttxt,500,"~UK",dump);
		}

	while(strstr(ttxt,"~UN"))	{
		sprintf(dump,"%d",(int)thisuser.userID);
		strrepl(ttxt,500,"~UN",dump); }

	while(strstr(ttxt,"~UO")){
		sprintf(dump,"%s%s%s%s%s",
			thisuser.birthday_mo,
			lingostr(83),
			thisuser.birthday_dy,
			lingostr(83),
			thisuser.birthday_yr);
		strrepl(ttxt,500,"~UO",dump); }

	while(strstr(ttxt,"~UP"))	{
		sprintf(dump,"%d",calc_age(&thisuser));
		strrepl(ttxt,500,"~UP",dump); }

	while(strstr(ttxt,"~UR"))	strrepl(ttxt,500,"~UR",thisuser.realname);

	while(strstr(ttxt,"~US"))	{
		sprintf(dump,"%d",thisuser.sl);
		strrepl(ttxt,500,"~US",dump); }

	while(strstr(ttxt,"~UT"))	{
		strrepl(ttxt,500,"~UT",ttype[thisuser.ugraphics]); }
	while(strstr(ttxt,"~UU"))	{
		sprintf(dump,"%ld",thisuser.userID);
		strrepl(ttxt,500,"~UU",dump); }
	while(strstr(ttxt,"~UW"))	{
		sprintf(dump,"%d",thisuser.ugraphics);
		strrepl(ttxt,500,"~UW",dump); }
}

void mciVseries(char *ttxt)
{
	char dump[121];
	fserec fse;
	lingorec lr;

	while(strstr(ttxt,"~VA")){
		strrepl(ttxt,500,"~VA",yna[thisuser.flags.hiddenlog]); }

	while(strstr(ttxt,"~VB")){
		strrepl(ttxt,500,"~VB",yna[thisuser.flags.hiddenlist]); }

	while(strstr(ttxt,"~VE"))	{
		if(thisuser.deffse){
			readFSE(&fse,thisuser.deffse-1);
			strcpy(dump,fse.display);
			}
		else
			strcpy(dump,"Line Editor");
		strrepl(ttxt,500,"~VE",dump);
		}

	while(strstr(ttxt,"~VD"))	{
		switch(thisuser.datefmt){
			case 0:	strcpy(dump,"MM/DD/YYYY");break;
			case 1:	strcpy(dump,"DD/MM/YYYY");break;
			case 2:	strcpy(dump,"YYYY/MM/DD");break;
			default:	strcpy(dump,"MM/DD/YYYY");break;
			}
		strrepl(ttxt,500,"~VD",dump);
		}
	
	while(strstr(ttxt,"~VI"))	{ strrepl(ttxt,500,"~VI",thisuser.notes[0]); }
	while(strstr(ttxt,"~VJ"))	{ strrepl(ttxt,500,"~VJ",thisuser.notes[1]); }
	while(strstr(ttxt,"~VK"))	{ strrepl(ttxt,500,"~VK",thisuser.notes[2]); }
	while(strstr(ttxt,"~VL"))	{
		readLingo(&lr,thisuser.language[0]);	
		strrepl(ttxt,500,"~VL",lr.display); }

	while(strstr(ttxt,"~VM"))	{
		readLingo(&lr,thisuser.language[0]);	
		strrepl(ttxt,500,"~VM",lr.lingofile); }

	while(strstr(ttxt,"~VS"))	{
		sprintf(dump,"%d",thisuser.pagelen);
		strrepl(ttxt,500,"~VS",dump); }

	while(strstr(ttxt,"~VU"))	{
		sprintf(dump,"%s",thisuser.comment);
		strrepl(ttxt,500,"~VU",dump); }

	while(strstr(ttxt,"~VW"))	{
		sprintf(dump,"%d",thisuser.linelen);
		strrepl(ttxt,500,"~VW",dump); }

	while(strstr(ttxt,"~VX"))	{
		strrepl(ttxt,500,"~VX",yna[thisuser.flags.novice]); }

}

void mciSseries(char *ttxt)
{
	struct tm *ttm;
	time_t t;
	char dump[121];

	(void) time(&t);
	ttm=localtime(&t);

	while(strstr(ttxt,"~SA"))	strrepl(ttxt,500,"~SA",config.bbsname);
	while(strstr(ttxt,"~SB"))	strrepl(ttxt,500,"~SB",config.location);
	while(strstr(ttxt,"~SD"))	{
		switch(thisuser.datefmt){
			case 0:	strftime(dump,40,"%m**%d**%Y",ttm); break;
			case 1:	strftime(dump,40,"%d**%m**%Y",ttm); break;
			case 2:	strftime(dump,40,"%Y**%m**%d",ttm); break;
			default: strftime(dump,40,"%m**%d**%Y",ttm); break;
			}
		if(strcmp(lingostr(83),"**")!=0)
			while(strstr(dump,"**"))	
				strrepl(dump,40,"**",lingostr(83));
		strrepl(ttxt,500,"~SD",dump);
			}
	while(strstr(ttxt,"~SF"))	strrepl(ttxt,500,"~SF",config.phone);
	while(strstr(ttxt,"~SH"))	strrepl(ttxt,500,"~SH","\b");
	while(strstr(ttxt,"~SI"))	strrepl(ttxt,500,"~SI","\b \b");
	
	while(strstr(ttxt,"~SJ"))	{
		strftime(dump,40,"%m**%d**%Y",ttm); 
		if(strcmp(lingostr(83),"**")!=0)
			while(strstr(dump,"**"))	
				strrepl(dump,40,"**",lingostr(83));
		strrepl(ttxt,500,"~SJ",dump); }

	while(strstr(ttxt,"~SN"))	{
		sprintf(dump,"%d",total_users);
		strrepl(ttxt,500,"~SN",dump); }

	while(strstr(ttxt,"~SO"))	{
		sprintf(dump,"%d",config.systemcalls);
		strrepl(ttxt,500,"~SO",dump); }

	while(strstr(ttxt,"~SR"))	strrepl(ttxt,500,"~SR","\r");
	while(strstr(ttxt,"~SS"))	strrepl(ttxt,500,"~SS",config.sysopname);
	
	while(strstr(ttxt,"~ST"))	{
		strftime(dump,81,"%H##%M##%S",ttm);
		if(strcmp(lingostr(84),"##")!=0)
			while(strstr(dump,"##"))	
				strrepl(dump,40,"##",lingostr(84));
			strrepl(ttxt,500,"~ST",dump); }
	while(strstr(ttxt,"~SV"))	strrepl(ttxt,500,"~SV",PROGNAME);
	while(strstr(ttxt,"~SC"))	strrepl(ttxt,500,"~SC","~XC");
	while(strstr(ttxt,"~SP"))	strrepl(ttxt,500,"~SP","~XP");
	while(strstr(ttxt,"~SM"))	strrepl(ttxt,500,"~SM","~XM");
}

void mciTseries(char *ttxt)
{
	char dump[121];
	long dumpl=0L;

	while(strstr(ttxt,"~TA"))	{
		sprintf(dump,"%d",thisuser.pubpost);
		strrepl(ttxt,500,"~TA",dump); }
	while(strstr(ttxt,"~TB"))	{
		sprintf(dump,"%d",thisuser.privpost);
		strrepl(ttxt,500,"~TB",dump); }
	while(strstr(ttxt,"~TC"))	{
		sprintf(dump,"%d",thisuser.netpost);
		strrepl(ttxt,500,"~TC",dump); }
	while(strstr(ttxt,"~TD"))	{
		dumpl=(thisuser.netpost+thisuser.privpost+thisuser.pubpost)+1;
		sprintf(dump,"%ld", (thisuser.totalcalls+1)/dumpl);
		strrepl(ttxt,500,"~TD",dump); }
	while(strstr(ttxt,"~TE"))	strrepl(ttxt,500,"~TE",thisuser_temp_path);
	while(strstr(ttxt,"~TF"))	{
		sprintf(dump,"%ld",thisuser.debitx);
		strrepl(ttxt,500,"~TF",dump); }

	while(strstr(ttxt,"~TH"))	{
		sprintf(dump,"%ld",thisuser.uk);
		strrepl(ttxt,500,"~TH",dump); }
	while(strstr(ttxt,"~TI"))	{
		sprintf(dump,"%d",thisuser.uploads);
		strrepl(ttxt,500,"~TI",dump); }
	while(strstr(ttxt,"~TJ"))	{
		sprintf(dump,"%ld",thisuser.dk);
		strrepl(ttxt,500,"~TJ",dump); }
	while(strstr(ttxt,"~TK"))	{
		sprintf(dump,"%d",thisuser.downloads);
		strrepl(ttxt,500,"~TK",dump); }
	while(strstr(ttxt,"~TL"))	{
		sprintf(dump,"%ld",thisuser.todaydk);
		strrepl(ttxt,500,"~TL",dump); }
	while(strstr(ttxt,"~TM"))	{
		sprintf(dump,"%d",thisuser.todaydl);
		strrepl(ttxt,500,"~TM",dump); }
	while(strstr(ttxt,"~TN"))	{
		sprintf(dump,"%ld",thisuser.filepoints);
		strrepl(ttxt,500,"~TN",dump); }
	while(strstr(ttxt,"~TO"))	{
		sprintf(dump,"%ld",thisuser.totaltime);
		strrepl(ttxt,500,"~TO",dump); }

	while(strstr(ttxt,"~TP"))	{
		sprintf(dump,"%d",thisuser.totalcalls);
		strrepl(ttxt,500,"~TP",dump); }
	while(strstr(ttxt,"~TQ"))	{
		sprintf(dump,"%d",thisuser.todaycalls);
		strrepl(ttxt,500,"~TQ",dump); }
	while(strstr(ttxt,"~TR"))	{
		sprintf(dump,"%d",(int)thisuser.illegal);
		strrepl(ttxt,500,"~TR",dump); }
	while(strstr(ttxt,"~TU"))	{
		sprintf(dump,"%d",(thisuser.uploads+1)/(thisuser.downloads+1));
		strrepl(ttxt,500,"~TU",dump); }
	while(strstr(ttxt,"~TV"))	{
		sprintf(dump,"%ld",(thisuser.uk+1)/(thisuser.dk+1));
		strrepl(ttxt,500,"~TV",dump); }
}


void mcimacros(char *ttxt)
{
	if(strstr(ttxt,"~&"))	mciAnd(ttxt);
	if(strstr(ttxt,"~C"))	mciCseries(ttxt);
	if(strstr(ttxt,"~M"))	mciMseries(ttxt);
	if(strstr(ttxt,"~T"))	mciTseries(ttxt);
	if(strstr(ttxt,"~U"))	mciUseries(ttxt);
	if(strstr(ttxt,"~V"))	mciVseries(ttxt);
	if(strstr(ttxt,"~S"))	mciSseries(ttxt);
}


char *strrepl(char *Str, size_t BufSiz, char *OldStr, char *NewStr)
{
	int OldLen, NewLen;
	char *p, *q;

	if(NULL == (p = strstr(Str, OldStr)))
		return Str;
	OldLen = strlen(OldStr);
	NewLen = strlen(NewStr);
	if ((strlen(Str) + NewLen - OldLen + 1) > BufSiz)
		return NULL;
	memmove(q = p+NewLen, p+OldLen, strlen(p+OldLen)+1);
	memcpy(p, NewStr, NewLen);
	return q;
}

void mci(char *strng, ...)
{
	char s[512],ttxt[512];
	va_list ap;

	va_start(ap,strng);
	vsprintf(s,strng,ap);
	va_end(ap);
	strcpy(ttxt,s);

	if(ttxt[0]=='@'){
		print_system_text(ttxt+1);	
		return;
		}
	mciEseries(ttxt);
	mcimacros(ttxt);
	mciansi(ttxt);
	mcicolor(ttxt,thisuser.ugraphics);
	mcihidden(ttxt);
	mcifuncts(ttxt);
}

void MciNoColor(char *strng, ...)
{
	char s[512],ttxt[512];
	va_list ap;

	va_start(ap,strng);
	vsprintf(s,strng,ap);
	va_end(ap);
	strcpy(ttxt,s);
	mcimacros(ttxt);
	mcihidden(ttxt);
	mcifuncts(ttxt);
}

void MciNoHidden(char *strng, ...)
{
	char s[512],ttxt[512];
	va_list ap;

	va_start(ap,strng);
	vsprintf(s,strng,ap);
	va_end(ap);
	strcpy(ttxt,s);
	mcimacros(ttxt);
	mcicolor(ttxt,thisuser.ugraphics);
	printf(ttxt);
}

int mcistrlen(char *ttxt)
{
	int i,count;

	count=strlen(ttxt);
	for(i=0;i<strlen(ttxt);i++) {
		if(ttxt[i]=='`'){
			count-=3;
			}
		}
	return(count);
}

int mcistrlenH(char *ttxt)
{
	int i,count;

	count=strlen(ttxt);
	for(i=0;i<strlen(ttxt);i++) {
		if(ttxt[i]=='`'){
			count-=3;
			}
		}
	return(count);
}

int oct2dec(char oct)
{
	int x=0;
	if(isdigit(oct))	x=oct-'0';	
	if(isalpha(oct))	x=oct-'A'+10;
	return(x);
}

void mcicolor(char *ttxt, int onoff)
{
	char *p;
	char mcistr[5];
	char outstr[21];
	int FG,BG,IN,BK,co[8]={0,4,2,6,1,5,3,7};

	while((p=strchr(ttxt,'`'))){
		if(isdigit(*(p+1)) || (*(p+1)>='A' && *(p+1)<='F') ){
			mcistr[0]='`';
			mcistr[1]=*(p+1);
			mcistr[2]=*(p+2);
			mcistr[3]='\0';

			FG=BG=IN=BK=0;


			/* Deal with the background first */
			BG=oct2dec(mcistr[1]);
			if(BG>7){ BG-=8; BK=1; }
			FG=oct2dec(mcistr[2]);
			if(FG>7){ FG-=8; IN=1; }

			/* if onoff==TRUE, replace MCI codes with ANSI color */
			/* if onoff==FALSE, strip out the MCI codes */
			if(onoff){  
				if(BK)	
					sprintf(outstr,"\x1b[%d;%d;%d;%dm",
						IN,BK*5,co[FG]+30,co[BG]+40);
				else
					sprintf(outstr,"\x1b[%d;%d;%dm",
						IN,co[FG]+30,co[BG]+40);
				}
			else
				strcpy(outstr,"");
			strrepl(ttxt,500,mcistr,outstr);
			}
		else
			{
			/* replace ` with ' if it is not part of an MCI code */
			strrepl(ttxt,500,"`","'");
			}
		}

}

void mcihidden(char *ttxt)
{
	int i;
	char outstr[81];

	while(strstr(ttxt,"~XM"))	strrepl(ttxt,500,"~XM","\n");
	while(strstr(ttxt,"~XC"))	{
		if(thisuser.ugraphics)
			strrepl(ttxt,500,"~XC","\x1b[2J\x1b[1;1H"); 
		else{
			for(i=0;i<thisuser.pagelen;i++)
				outstr[i]='\n';
			outstr[i]='\0';
			strrepl(ttxt,500,"~XC",outstr);
			}
		}
}

void mciansi(char *ttxt)
{	
	char in[5],out[5];

	sprintf(in,"%c",148);	sprintf(out,"%c",205);
	while(strstr(ttxt,in))	strrepl(ttxt,500,in,out);

	sprintf(in,"%c",128);	sprintf(out,"%c",187);
	while(strstr(ttxt,in))	strrepl(ttxt,500,in,out);
}

void mcifuncts(char *ttxt)
{
	int cnt=0;
	while(strstr(ttxt,"~XP"))	{
		strrepl(ttxt,500,"~XP","");
		cnt++;
		}
	printf(ttxt);
	while(cnt){
		paws();
		cnt--;
		}
}

char *ansic(unsigned char colrnum)
{
	int FG, BG;

	/* Break down each nibble */
	/* Left (high order), and Right */
	BG= ((colrnum & 0x00F0) >> 4);
	FG=  (colrnum & 0x000F);

	sprintf(fstr,"`%X%X",BG,FG);
	return(fstr);
}

void stripCR(char *ostr)
{
	while(strchr(ostr,'\n')) strrepl(ostr,500,"\n","");
	while(strchr(ostr,'\r')) strrepl(ostr,500,"\r","");
	while(strchr(ostr,'\b')) strrepl(ostr,500,"\b","");
	while(strchr(ostr,'\x1b')) strrepl(ostr,500,"\x1b","");
}
void stripSC(char *ttxt)
{
	while(strstr(ttxt,"~SC"))	strrepl(ttxt,500,"~SC","");
}

void char2A(int numa, char *ttxt)
{
	strcpy(A[numa],ttxt);
}

void int2A(int numa, int num)
{
	sprintf(A[numa],"%d",num);
}

void long2A(int numa, long lnum)
{
	sprintf(A[numa],"%ld",lnum);
}

char *lingostr(int ltag)
{
	char tag[10],path[91],line[128];
	FILE *fptr;
	int done;

	*retstr='\0';
	sprintf(tag,"%04d ",ltag);
	sprintf(path,"%s%s",config.datapath,deflingofile);
	fptr=fopen(path,"rt");
	if(fptr==NULL){
		mci("~SMUnable to access language file~SM~SM");
		return(retstr);
		}
	done=FALSE;
	while(fgets(line,128,fptr)!=NULL && !done){
		if(strncmp(line,tag,strlen(tag))==0){
			done=TRUE;
			stripCR(line);
			strcpy(retstr,line+strlen(tag));
			return(retstr);
			}
		}
	return(retstr);
}

void language(int ltag)
{
	mci(lingostr(ltag));
}
