/*****************************************************************************
 *
 * File ..................: menuedit.c
 * Purpose ...............: Menu Editor Routines.
 * Last modification date : 08-Feb-2001
 *
 *****************************************************************************
 * Copyright (C) 2000-2001
 *   
 * Darryl Perry			
 * FIDO:		1:211/105
 * Internet:	dperry.geo@yahoo.com
 *
 * This file is part of Gryphon/X BBS.
 *
 * This BBS is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Gryphon/X BBS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Gryphon/X BBS; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/
#include <dirent.h>
#include <sys/stat.h>
#include "structs.h"
#include "defs.h"
#include "acs.h"
#include "bbs.h"
#include "basics.h"
#include "fileio.h"
#include "gycfg.h"
#include "mci.h"
#include "misc.h"
#include "menuedit.h"
#include "nodedit.h"
#include "conio.h"

int modwhich=0;

void countcmds(char *menuname)
{
	numcmds=0;
	while(readmenucmd(menuname,numcmds++));
	numcmds--;
}

void menuedit()
{
	char ch;
	int done=FALSE;

	if(!sopw())	return;

	Select_Lingo();

	while(!done){
		mci("~SC~SM`0AMenu Editor - Menu path %s~SM~SM",defmenupath);
		listmenus();
		mci("~SM~SM`09Menu Editor (Q=Quit) : `03");
		ch=onekey("NMDQ");
		switch(ch){
			case 'D':	delmenu();  break;
			case 'M':	modmenu();	break;
			case 'N':	newmenu();	break;
			case 'Q':	done=TRUE;	break;
			}
		}

}

void listmenus()
{
	DIR *dp;
	int count=0;
	struct dirent *entry;
	struct stat statbuf;

	if((dp=opendir(defmenupath))==NULL) {
		mci("`03Unable to open %s~SM",defmenupath);
		return;
		}
	chdir(defmenupath);
	while((entry=readdir(dp)) != NULL) {
		stat(entry->d_name,&statbuf);
		if(S_ISDIR(statbuf.st_mode))
			;
		else{
			mci("`03%-19s",entry->d_name);
			count++;
			if(count > 3){
				nl();
				count=0;
				}
			}
		}
	chdir("..");
	closedir(dp);
}

void newmenu()
{
	char ttxt[41],*p;
	nl();
	mci("~SM`09Menu Name : `03");
	ttxt[0]='\0';
	get_str(ttxt,35);
	if(strlen(ttxt)>0){
		p=strstr(ttxt,".mnu");
		if(p)
			ttxt[p-ttxt]=0;
			
		initmenu();
		savemenutop(ttxt);
		savemenucmd(ttxt,0);
		}
}

void initmenu()
{
	strcpy(menutop.title[0],"`0ANew Gryphon BBS Menu");
	strcpy(menutop.title[1],"`0D~ST ~SD");
	strcpy(menutop.title[2],"`0F~BN");
	strcpy(menutop.prompt,"Command: ");
	strcpy(menutop.flags,"----------");
	strcpy(menucmd.keys,"Q");
	strcpy(menucmd.longcmd,"(Q)uit Menu");
	strcpy(menucmd.shortcmd,"(Q)uit Menu");
	strcpy(menucmd.options,"");
	initcmd();
}

void initcmd()
{
	strcpy(menucmd.longcmd,"(XXX) New Menu command");
	strcpy(menucmd.shortcmd,"(XXX) New Menu Command");
	strcpy(menucmd.options,"main");
	strcpy(menucmd.keys,"XXX");
	strcpy(menucmd.cmdtype,"-^");
	init_ACS(&menucmd.ACS,(unsigned char) 5);
}

void modmenu()
{
	char ttxt[41],mnu[91],*p;
	int xx=FALSE;

	nl();
	mci("`09Modify which menu? : `0F");
	ttxt[0]='\0';
	get_filename(ttxt,35);
	if(strlen(ttxt)>0){
		if((p=strstr(ttxt,".mnu"))!=NULL)
			ttxt[p-ttxt]=0;
		xx=TRUE;
		sprintf(mnu,"%s%s.mnu",defmenupath,ttxt);
		if(file_exist(mnu)){
			while(xx!=FALSE){
				if(modwhich==0) xx=edittop(ttxt);
				else			xx=editmenucmds(ttxt);
				}
			}
		else{
			mci("~SMMenu %s.mnu does not exist.~SM~SP",ttxt);
			}
		}
}

int edittop(char *menuname)
{
	char ch,ch2,ttxt[121];
	char modetxt[4][21];
	int done=FALSE,i,rt=0,num,stl;

	strcpy(modetxt[0],"User Defaults");
	strcpy(modetxt[1],"Force Novice");
	strcpy(modetxt[2],"Force Expert");
	strcpy(modetxt[3],"Force Long Display");

	readmenutop(menuname);
	
	while(!done){
		clr_scr();
		mci("`07Title:~SM");
		if(!print_system_text(menutop.ansimenu)){
			sprintf(ttxt,menutop.title[0]);
			mcimacros(ttxt);
			if(menutop.flags[1]=='-') 	center(ttxt);
			else						MciNoHidden(ttxt);
			nl();
			sprintf(ttxt,"%s",menutop.title[1]);
			mcimacros(ttxt);
			if(menutop.flags[7]=='-') 	center(ttxt);
			else						MciNoHidden(ttxt);
			nl();
			sprintf(ttxt,menutop.title[2]);
			mcimacros(ttxt);
			if(menutop.flags[7]=='-') 	center(ttxt);
			else						MciNoHidden(ttxt);
			}
		mci("~SM`07Prompt~SM");
		MciNoHidden("%s",menutop.prompt);nl();
		mci("~SM `07A. Menu Title :~SM");
		mci(" B. Menu Prompt:~SM");
		MciNoHidden(" C. Menu Flags : <%s>",menutop.flags);nl();
		MciNoHidden(" D. Columns    : %d",menutop.columns);nl();
		MciNoHidden(" E. Menu Text  : %s",menutop.ansimenu);nl();
		MciNoHidden(" F. Mode       : %d (%s)",
			menutop.mode,modetxt[menutop.mode]);nl();
		MciNoHidden(" G. Node Status: %s",menutop.nodemsg);nl();
		mci("~SM`09Menu Editor : ");
		ch=onekey("ABCDEFGTQS");
		switch(ch){
			case 'C':
				ch2=0;
				while(ch2!='\n'){
					nl();
	mci("`09Toggle which flag?  ?=Help <ENTER>=Quit [%c%c%c%c%c%c%c%c%c]: ",
						menutop.flags[0], menutop.flags[1], menutop.flags[2],
						menutop.flags[3], menutop.flags[4], menutop.flags[5],
						menutop.flags[6], menutop.flags[7], menutop.flags[8]);
					ch2=onekey("ABCDEFGHI?\n");
					if(ch2=='?'){
						nl();
						nl();
						mci("`09(`0FA`09) Clear screen before menu       ");
						mci("`09(`0FF`09) Force pause before display");nl();
						mci("`09(`0FB`09) Do not center menu headers     ");
						mci("`09(`0FG`09) No <CR> after prompt");nl();
						mci("`09(`0FC`09) Display input as lower case    ");
						mci("`09(`0FH`09) Do not center subheaders");nl();
						mci("`09(`0FD`09) No <CR> before prompt          ");
						mci("`09(`0FI`09) Time left display");nl();
						mci("`09(`0FE`09) No menu prompt display");nl();
						}
					else{
						if(menutop.flags[ch2-'A']==ch2)
							menutop.flags[ch2-'A']='-';
						else
							menutop.flags[ch2-'A']=ch2;
						}
					}
				break;
			case 'T':	
				savemenutop(menuname);
				modwhich=1;	
				done=TRUE;
				rt=1;
				break;
			case 'A':
				nl();
				mci("`0FMenu Title:");
				for(i=0;i<3;i++){
					mci("~SM:`0F");
					get_str(menutop.title[i],78);
					mci("`0F");
					}
				break;
			case 'B':
				stl=strlen(menutop.prompt);
				mci("~SM`0FPrompt: ~SM");
				get_str(menutop.prompt,78);
				break;
			case 'D':
				mci("~SM`09Enter number of Columns: `1F");
				sprintf(ttxt,"%d",menutop.columns);
				num=get_num(ttxt);
				if(num>0 && num<8)
					menutop.columns=num;
				break;
			case 'E':
				nl();
				mci("Ansi Menu: ");nl();
				get_str(menutop.ansimenu,11);
				break;
			case 'F':
				mci("~SM");
				for(i=0;i<4;i++)
					mci("~SM`0F%d`09) `0F%s",i,modetxt[i]);	
				mci("~SM`09Select: ");
				*ttxt='\0';
				menutop.mode=get_num(ttxt);
				break;
			case 'G':
				mci("~SMNode Message: ");
				*ttxt='\0';
				get_str(ttxt,40);
				if(strlen(ttxt)>0){
					strcpy(menutop.nodemsg,ttxt);
					}
				break;
			case 'S':	
				savemenutop(menuname);
				showmenu(menuname,0);	
				paws();	
				break;
			case 'Q':	
				if(!savemenutop(menuname)){
					nl();
					mci("Unable to save menu top");nl();
					paws();
					}
				done=TRUE;	
				rt=0;
				break;
			}
		}
	return(rt);
}

void listmenucmds(char *menuname)
{
	int i,j,n,q;

	char *listtop={"`09#  KE MC Options         "};
	char *listbar={"`09-- -- -- --------------- "};

	for(i=0;i<3;i++)
		mci(listtop);
	nl();
	for(i=0;i<3;i++)
		mci(listbar);
	i=0;
	readmenu(menuname);
	nl();
	n=(numcmds/3)+1;
	for(i=0;i<n;i++){
		for(j=0;j<3;j++){
			q=i+(j*n);
			if(q<numcmds){
				readmenucmd(menuname,q);
				mcistrset(menucmd.keys,3);
				mcimacros(menucmd.options);
				mcistrset(menucmd.options,16);
				MciNoHidden("`0F%2.2d %-3.3s%-2.2s %-16.16s",
					q+1, menucmd.keys, menucmd.cmdtype, menucmd.options);
				}
			if(j==2)	nl();
			}
		}
}

int editmenucmds(char *menuname)
{
	char ch;
	int done=FALSE,rt=0;


	countcmds(menuname);

	while(!done){
		clr_scr();
		nl();
		mci("`02Menu Editor - Editing %s.mnu",menuname);nl();
		nl();
		listmenucmds(menuname);
		nl();
		nl();
		mci("`09Menu editor (?=help) : `0F");
		ch=onekey("QMADPIT?");
		switch(ch){
			case 'A':	addmenucmd(menuname);	break;
			case 'D':	removecmd(menuname);	break;
			case 'I':	insertmenucmd(menuname);	break;
			case 'M':	modcmd(menuname);		break;
			case 'P':	positioncmd(menuname);	break;
			case 'Q':	done=TRUE;	rt=FALSE; 	break;
			case 'T':	modwhich=0;	done=TRUE; rt=TRUE; break;
			case '?':
				mci("~SM~SMMenu Command Editor Commands:~SM");
				mci("~SM(A)dd Command                (D)elete Command");
				mci("~SM(I)nsert Command             (M)odify Command");
				mci("~SM(P)osition Command           (T)oggle Editor");
				mci("~SM(Q)uit~SM~SP");
				break;
			}
		}
	return(rt);
}

void positioncmd(char *menuname)
{
	int num1,num2;
	char ttxt[21];


	nl();nl();
	mci("`09Position which command? [`0F1-%d`09]`0F: `1F",numcmds);
	*ttxt='\0';
	num1=get_num(ttxt)-1;
	if(num1>=0 && num1<numcmds){
		nl();nl();
		mci("`09Place it before which? [`0F1-%d`09]: `1F",numcmds);
		*ttxt='\0';
		num2=get_num(ttxt)-1;
		if(num2>=0 && num2<numcmds){
			swapcmd(menuname,num1,num2);
			}
		else{
			nl();nl();
			mci("Invalid number");nl();
			paws();
			}
		}
	else{
		nl();nl();
		mci("Invalid number");nl();
		paws();
		}
}
	
void swapcmd(char *menuname, int iFrom, int iTo)
{
	menucmdrec mcr;
	int i1,idx=0;

	readmenucmd(menuname,iFrom);
	mcr=menucmd;

	if(iFrom<iTo){
		for(i1=iFrom+1;i1<=iTo;i1++){
			readmenucmd(menuname,i1);
			savemenucmd(menuname,i1-1);
			}
		}
	else{
		for(i1=iFrom;i1>iTo;i1--){
			readmenucmd(menuname,i1-1);
			idx=i1;
			savemenucmd(menuname,idx);
			}
		}
	menucmd=mcr;
	savemenucmd(menuname,iTo);
}

void inscmd(char *menuname,int num)
{
	swapcmd(menuname,numcmds,num);
	initcmd();
	savemenucmd(menuname,num);
}

void insertmenucmd(char *menuname)
{
	char ttxt[11];
	int num;

	nl();nl();
	mci("`09Insert before which command? [`0F1-%d`09]: `1F",numcmds+1);
	*ttxt='\0';
	num=get_num(ttxt)-1;
	if(num>=0 && num<=numcmds+1){
		if(num==numcmds){
			addmenucmd(menuname);
			}
		else {
			inscmd(menuname,num);
			}
		}
}

void addmenucmd(char *menuname)
{
	initcmd();
	savemenucmd(menuname,numcmds);
}

void removecmd(char *menuname)
{
	char ttxt[21];
	int num;

	nl();
	mci("`09Remove which command? (%d-%d) : `1F",1,numcmds);
	*ttxt='\0';
	num=get_num(ttxt)-1;
	if(num>=0 && num<numcmds){
		delmnucmd(menuname,num);
		}
	else{
		mci("~SMUnable to delete this command.(%d)~SM",num);
		paws();
		}
}

void delmenu()
{
	char ttxt[36],menupath[81],*p;

	nl();
	mci("`09Delete which menu? : `0F");
	ttxt[0]='\0';
	get_str(ttxt,35);
	if(strlen(ttxt)>0){
		if((p=strstr(ttxt,".mnu"))!=NULL)
			ttxt[p-ttxt]=0;
		}
	sprintf(menupath,"%s%s.mnu",defmenupath,ttxt);
	remove(menupath);
			
}


void modcmd(char *menuname)
{
	char ttxt[21];
	int num;

	nl();
	mci("`09Modify which command? : `0F");
	*ttxt='\0';
	num=get_num(ttxt)-1;
	if(num>=0 && num<numcmds){
		edcmd(menuname,num);
		}
}

void menu_cmd_help(char *mcmd)
{	
	mci("`0F\n\r");
	if(mcmd[0]=='?'){
		mci("*?  Sysop Commands              ");
		mci("-?  Menu/Option Commands        ");nl();
		mci("D?  Door Commands               ");
		mci("F?  File Transfer Commands      ");nl();
		mci("H?  Hangup/Logoff Commands      ");
		mci("L?  Login Commands              ");nl();
		mci("M?  Message Area Commands       ");
		mci("N?  Multi-Node Commands         ");nl();
		mci("O?  Miscellaneous Commands      ");
		mci("Q?  QWK mail Commands           ");nl();
		mci("R?  Message Reading Commands    ");
		mci("S?  file Scanning Commands      ");nl();
		mci("T?  Timebank Commands           ");
		mci("U?  User/Auto-Message Commands  ");nl();
		}
	else {
		if(mcmd[1]=='?'){
			switch(mcmd[0]){
				case '-':
					mci("`0F-!  Unconditional en to command links ");
					mci("-$  Password Check                    "); nl();
					mci("-/  Menu - GOSUB                      ");
					mci("-;  Execute macro                     "); nl();
					mci("-C  Command line message              ");
					mci("-E  Execute Script                    "); nl();
					mci("-F  Display file (def. Paging)        ");
					mci("-G  Display file (def.Paging, End Paus"); nl();
					mci("-H  Display file (force Paging)       ");
					mci("-I  Display file (force Paging, end Pa"); nl();
					mci("-L  Display a line of text            ");
					mci("-M  Send short message                "); nl();
					mci("-O  Option Check                      ");
					mci("-S  Append line to SysOp Log          "); nl();
					mci("-V  BBS Version Information           ");
					mci("-Y  Yes/No Check                      "); nl();
					mci("-Z  Save user // Quit WFCQ* menus     ");
					mci("-\\  Menu - Return from GOSUB         "); nl();
					mci("-^  Menu - Goto");nl();	
					break;
				case 'H':
					mci("`0FHC  Logoff user w/ Relogon (cycle user)");
					mci("HH  Logoff user w/ LOGOFF file display ");nl();
					mci("HI  Logoff user immediately            ");  
					mci("HX  Logoff w/o Hangup                  ");nl();
						}
					}
				}
}

void edcmd(char *menuname, int cmdnum)
{
	int done=FALSE,done1=FALSE,i;
	char ch,ttxt[9];

	readmenucmd(menuname,cmdnum);

	while(!done){
		mci("~SC~SM`0AMenu %s.mnu - editing command %d (of %d)~SM~SM",
			menuname,cmdnum+1,numcmds);
		MciNoHidden("`031. Long Description");nl();
		MciNoHidden("   \"`07%s`03\"",menucmd.longcmd);nl();
		MciNoHidden("2. Short Description");nl();
		MciNoHidden("   \"`07%s`03\"",menucmd.shortcmd);nl();
		MciNoHidden("3. Keys       \"%s\"",menucmd.keys);nl();
		MciNoHidden("4. Command    %s",menucmd.cmdtype);nl();
		MciNoHidden("5. Options    \"`07%s\"`03",menucmd.options);nl();
		MciNoHidden("6. Access     : SL=%-3d, E=[%s], F=[%s]",
			menucmd.ACS.min_sl,
			Sflag2str(&menucmd.ACS.eflags),
			Sflag2str(&menucmd.ACS.fflags));nl();
		nl();
		mci("`09Edit menu (?=help) : `0F");
		ch=onekey("123456[]Q");
		switch(ch){
			case '[':
				savemenucmd(menuname,cmdnum);
				if(cmdnum>0)
					cmdnum--;
				readmenucmd(menuname,cmdnum);
				break;
			case ']':
				savemenucmd(menuname,cmdnum);
				if(cmdnum<numcmds)
					cmdnum++;
				readmenucmd(menuname,cmdnum);
				break;
			case '1':
				mci("~SM~SM`09Enter long description:~SM");
				for(i=0;i<15;i++)
					mci("....|");
				nl();
				get_str(menucmd.longcmd,69);
				break;
			case '2':
				mci("~SM~SM`09Enter short description:`0F~SM");
				for(i=0;i<8;i++)
					mci("....|");
				nl();
				get_str(menucmd.shortcmd,40);
				break;
			case '3':
				mci("~SM~SM`09Enter command letters : `0F");
				get_upcase(menucmd.keys,12);
				break;
			case '4':
				menucmd.cmdtype[2]='\0';
				done1=FALSE;
				while(!done1){
					mci("~SM~SM`09Enter command type (?=list) : `0F");
					*ttxt='\0';
					get_upcase(ttxt,2);
					strncpy(menucmd.cmdtype,ttxt,2);
					menucmd.cmdtype[2]='\0';
					done1=TRUE;
					}
				break;
			case '5':
				mci("~SM~SM`09Enter options : `0F");
				get_str(menucmd.options,61);
				break;
			case '6': ACS_setup(&menucmd.ACS,menucmd.shortcmd); break;
			case 'Q':
				savemenucmd(menuname,cmdnum);
				done=TRUE;
				break;
			}
		}
}

