/*****************************************************************************
 *
 * File ..................: nodedit.c
 * Purpose ...............: Node Editor.
 * Last modification date : 08-Feb-2001
 *
 *****************************************************************************
 * Copyright (C) 2000-2001
 *   
 * Darryl Perry			
 * FIDO:		1:211/105
 * Internet:	dperry.geo@yahoo.com
 *
 * This file is part of Gryphon/X BBS.
 *
 * This BBS is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Gryphon/X BBS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Gryphon/X BBS; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/

#include "structs.h"
#include "defs.h"
#include "acs.h"
#include "basics.h"
#include "fileio.h"
#include "mci.h"
#include "misc.h"
#include "nodedit.h"
#include "conio.h"

void reset_node();


void nodedit()
{
	int done=FALSE,page=0;
	char ch;
	
	while(!done){
		clr_scr();
		nl();
		mci("`0ENode Editor`09");nl();
		nl();
		repeat(196,78);nl();
		list_nodes(page);mci("`09");
		repeat(196,78);nl();
		mci("Node Editor (]/[=Next/Prev, Q=Quit, ?=Help)`0F: ");
		ch=onekey("[]AMDPQR");
		switch(ch){
			case 'A':	add_node();		break;
			case 'D':	delete_node();	break;
			case 'M':	modify_node();	break;
			case 'P':	move_node();	break;
			case 'Q': 	done=TRUE;		break;
			case 'R':	reset_node();	break;
			}
		}
}

void reset_node()
{
	int i=0,num;
	char ttxt[9];
	noderec nr;

	total_nodes=countnodes();
	if(total_nodes>0)	i=1;

	if(i<1){
		mci("~SMNo nodes available to reset.~SM~SP");
		return;
		}

	mci("~SMReset which node? [%d-%d]: ",i,total_nodes);
	*ttxt='\0';
	num=get_num(ttxt)-1;
	if(num>=0 && num<=total_nodes){
		init_node(&nr);
		nr.inuse=FALSE;
		savenode(&nr,num);
		}
}

void list_nodes(int page)
{
	int i1,rno;
	noderec ndl;

	for(i1=0;i1<15;i1++){
		rno=(page*15);
		if(readnode(&ndl,rno+i1)){
			mci("`0F%3d)",rno+1+i1);
			if(ndl.inuse){
				mci("%-25s %-25s",ndl.alias,ndl.homepath);
				}	
			else{
				mci("Waiting for a call   %s",ndl.homepath);
				}
			}
		else {
			mci("`0F%3d)",rno+1+i1);
			}
		nl();
		}
}

void kill_node(int ndnum)
{
	noderec ndin;
	int i1,count=0;
	char ppath[81];

	i1=0;
	while(readnode(&ndin,i1)){
		if(i1!=ndnum){
			ndin.idx=count;
			count++;
			if(!savenodetemp(&ndin,ndin.idx)){
				mci("Error saving to temp file.");nl();
				}
			}
		i1++;	
		}

	sprintf(ppath,"%snode.data",config.datapath); 
	remove(ppath);
	i1=0;
	while(readnodetemp(&ndin,i1)){
		savenode(&ndin,ndin.idx);
		i1++;
		}
	sprintf(ppath,"%snode.data.temp",config.datapath); 
	remove(ppath);
	total_nodes=i1-1;
}

void delete_node()
{
	char ttxt[21];
	int num;

	mci("~SMDelete which? [1-%d]: ",total_nodes);
	*ttxt='\0';
	num=get_num(ttxt)-1;
	if(num>=0 && num<=total_nodes){
		kill_node(num);
		}
}

void swap_node(int iFrom, int iTo)
{
	noderec ndto,ndfrom;
	int i1;


	readnode(&ndfrom,iFrom);

	if(iFrom<iTo){
		for(i1=iFrom+1;i1<=iTo;i1++){
			readnode(&ndto,i1);
			ndto.idx--;
			savenode(&ndto,ndto.idx);
			}
		}
	else{
		for(i1=iFrom;i1>iTo;i1--){
			readnode(&ndto,i1-1);
			ndto.idx++;
			savenode(&ndto,ndto.idx);
			}
		}

	ndfrom.idx=iTo;
	savenode(&ndfrom,ndfrom.idx);
}


void move_node()
{
	char ttxt[21],ttxt1[21];
	int num,num1;

	mci("~SMPosition which? [1-%d]: ",total_nodes);
	*ttxt1='\0';
	num1=get_num(ttxt1)-1;
	if(num1>=0 && num1<total_nodes){
		mci("`09    Move to which? [1-%d]: ",total_nodes);
		*ttxt='\0';
		num=get_num(ttxt)-1;
		if(num>=0 && num<total_nodes)
			swap_node(num1,num);
		else {
			nl();
			mci("Invalid nunder.  Try again!");nl();
			paws();
			}
		}
	else{
		nl();
		mci("Invalid Nunder.  Try again!");nl();
		paws();
		}
}


void modify_node()
{
	char ttxt[21];
	int num;

	mci("~SMModify which? [1-%d]: ",total_nodes);
	*ttxt='\0';
	num=get_num(ttxt)-1;
	if(num>=0 && num<=total_nodes){
		mod_node(num);
		}
	
}

void mod_node(int nodenum)
{
	int done=FALSE;
	char ch;
	noderec nr;

	while(!done){
		readnode(&nr,nodenum);
		clr_scr();
		mci("Modifying Node  %d of %d",nodenum+1,total_nodes);nl();
		nl();
		mci("`09(`0AA`09) `0FDevice     : %s",nr.homepath);nl();
		mci("`09(`0AB`09) `0FFast Sysop : %s",(nr.sysoplogin)?"Yes":"No");nl();
		mci("`09(`0AC`09) `0FStart Time : %s",nr.starttime);nl();
		mci("`09(`0AD`09) `0FStop Time  : %s",nr.stoptime);nl();
		mci("`09(`0AE`09) `0FMin. BPS   : %s",nr.bps);nl();
		nl();
		mci("`09Modify Node (]/[=Next/Prev, Q=Quit ?=Help)`0F: ");
		ch=onekey("ABCDEFGQ");
		switch(ch){
			case 'A':
				nl();nl();
				mci("New Device: ");
				get_str(nr.homepath,40);
				break;
			case 'B':
				if(nr.sysoplogin)	nr.sysoplogin=FALSE;
				else				nr.sysoplogin=TRUE;
				break;
			case 'Q':	
				savenode(&nr,nr.idx);
				done=TRUE;	break;
			}
		savenode(&nr,nodenum);
		}
}

void FSEconfig()
{
	int done=FALSE,page=0;
	char ch;

	while(!done){
		clr_scr();
		nl();
		mci("`0EFSE Editor`09");nl();
		nl();
		repeat(196,78);nl();
		list_FSE(page);mci("`09");
		repeat(196,78);nl();
		mci("FSE Editor (]/[=Next/Prev, Q=Quit, ?=Help)`0F: ");
		ch=onekey("[]IMDPQ");
		switch(ch){
			case 'D':	delete_FSE();	break;
			case 'I': 	insert_FSE();	break; 
			case 'M':	modify_FSE();	break;
			case 'P':	move_FSE();	break;
			case 'Q': 	done=TRUE;		break;
			}
		}
}

void insert_FSE()
{
	char ttxt[21];
	int num;

	mci("~SMInsert before which? [1-%d]: ",total_FSEs+1);
	*ttxt='\0';
	num=get_num(ttxt)-1;
	if(num>=0 && num<=total_FSEs)
		poke_FSE(num);
	else {
		mci("~SMInvalid nunder.  Try again!~SM~SP");
		}
}

void delete_FSE()
{
	char ttxt[21];
	int num;

	mci("~SMDelete which? [1-%d]: ",total_FSEs);
	*ttxt='\0';
	num=get_num(ttxt)-1;
	if(num>=0 && num<=total_FSEs){
		kill_FSE(num);
		}
}

void move_FSE()
{
	char ttxt[21],ttxt1[21];
	int num,num1;

	mci("~SMPosition which? [1-%d]: ",total_FSEs);
	*ttxt1='\0';
	num1=get_num(ttxt1)-1;
	if(num1>=0 && num1<total_FSEs){
		mci("`09    Move to which? [1-%d]: ",total_FSEs);
		*ttxt='\0';
		num=get_num(ttxt)-1;
		if(num>=0 && num<total_FSEs)
			swap_FSE(num1,num);
		else {
			mci("~SMInvalid nunder.  Try again!~SM~SP");
			}
		}
	else{
		mci("~SMInvalid Nunder.  Try again!~SM~SP");
		}
}

void modify_FSE()
{
	char ttxt[21];
	int num;

	mci("~SMModify which? [1-%d]: ",total_FSEs);
	*ttxt='\0';
	num=get_num(ttxt)-1;
	if(num>=0 && num<=total_FSEs){
		mod_FSE(num);
		}
}

void poke_FSE(int pokenum)
{
	fserec ndin;
	int i1;

	for(i1=total_FSEs;i1>pokenum;i1--){
		readFSE(&ndin,i1-1);
		ndin.idx++;
		saveFSE(&ndin,ndin.idx);
		}
	init_FSE(&ndin);
	ndin.idx=pokenum;
	saveFSE(&ndin,ndin.idx);
	total_FSEs++;
}

void kill_FSE(int ndnum)
{
	fserec ndin;
	int i1,count=0;
	char ppath[81];

	i1=0;
	while(readFSE(&ndin,i1)){
		if(i1!=ndnum){
			ndin.idx=count;
			count++;
			if(!saveFSEtemp(&ndin,ndin.idx)){
				mci("Error saving to temp file.~SM");
				}
			}
		i1++;	
		}

	sprintf(ppath,"%sfse.data",config.datapath); 
	remove(ppath);
	i1=0;
	while(readFSEtemp(&ndin,i1)){
		saveFSE(&ndin,ndin.idx);
		i1++;
		}
	sprintf(ppath,"%sfse.data.temp",config.datapath); 
	remove(ppath);
	total_FSEs--;
}

void swap_FSE(int iFrom, int iTo)
{
	fserec ndto,ndfrom;
	int i1;


	readFSE(&ndfrom,iFrom);

	if(iFrom<iTo){
		for(i1=iFrom+1;i1<=iTo;i1++){
			readFSE(&ndto,i1);
			ndto.idx--;
			saveFSE(&ndto,ndto.idx);
			}
		}
	else{
		for(i1=iFrom;i1>iTo;i1--){
			readFSE(&ndto,i1-1);
			ndto.idx++;
			saveFSE(&ndto,ndto.idx);
			}
		}

	ndfrom.idx=iTo;
	saveFSE(&ndfrom,ndfrom.idx);
}

void mod_FSE(int nodenum)
{
	int done=FALSE;
	char ch;
	fserec nr;

	while(!done){
		readFSE(&nr,nodenum);
		mci("~SC~SMModifying FSE %d of %d~SM~SM",nodenum+1,total_FSEs);nl();
		mci("A. Display      : %s~SM",nr.display);
		mci("B. Command Path : %s~SM",nr.fsecmdpath);
		mci("C. Security ACS : ~SM");
		mci("~SM`09Modify FSE(]/[=Next/Prev, Q=Quit ?=Help)`0F: ");
		ch=onekey("ABCDEFGQ");
		switch(ch){
			case 'A':
				mci("~SM~SMNew Display: ");
				get_str(nr.display,60);
				break;
			case 'B':
				mci("~SM~SMFSE command line~SM:");
				get_str(nr.fsecmdpath,76);
				break;
			case 'Q':	
				saveFSE(&nr,nr.idx);
				done=TRUE;	break;
			}
		saveFSE(&nr,nodenum);
		}
}

void init_FSE(fserec *nd)
{
	strcpy(nd->display,"New FSE");
	strcpy(nd->fsecmdpath,"");
	init_ACS(&nd->ACS,5);
}

void list_FSE(int page)
{
	int i1,rno;
	fserec ndl;

	for(i1=0;i1<15;i1++){
		rno=(page*15);
		if(readFSE(&ndl,rno+i1)){
			mci("`0F%3d `0E%s",rno+1+i1,ndl.display);
			}
		else {
			mci("`0F%3d",rno+1+i1);
			}
		nl();
		}
}


void lingoconfig()
{
	int done=FALSE,page=0;
	char ch;

	while(!done){
		mci("~SC~SM`0ELanguage Editor`09~SM~SM");
		mci("~EF-78~SM");
		list_lingo(page);mci("`09");
		mci("~EF-78~SM");
		mci("Language Editor (]/[=Next/Prev, Q=Quit, ?=Help)`0F: ");
		ch=onekey("[]IMDPQ");
		switch(ch){
			case 'D':	delete_lingo();	break;
			case 'I': 	insert_lingo();	break;
			case 'M':	modify_lingo();	break;
			case 'P':	move_lingo();	break;
			case 'Q': 	done=TRUE;		break;
			}
		}
}

void delete_lingo()
{
	char ttxt[21];
	int num;

	mci("~SMDelete which? [1-%d]: ",total_lingo);
	*ttxt='\0';
	num=get_num(ttxt)-1;
	if(num>=0 && num<=total_lingo){
		kill_lingo(num);
		}
}

void kill_lingo(int ndnum)
{
	lingorec ndin;
	int i1,count=0;
	char ppath[81];

	i1=0;
	while(readLingo(&ndin,i1)){
		if(i1!=ndnum){
			ndin.idx=count;
			count++;
			if(!saveLingotemp(&ndin,ndin.idx)){
				mci("Error saving to temp file.~SM");
				}
			}
		i1++;	
		}

	sprintf(ppath,"%slanguage.data",config.datapath); 
	remove(ppath);
	i1=0;
	while(readLingotemp(&ndin,i1)){
		saveLingo(&ndin,ndin.idx);
		i1++;
		}
	sprintf(ppath,"%slanguage.data.temp",config.datapath); 
	remove(ppath);
	total_lingo--;
}

void insert_lingo()
{
	char ttxt[21];
	int num;

	mci("~SMInsert before which? [1-%d]: ",total_lingo+1);
	*ttxt='\0';
	num=get_num(ttxt)-1;
	if(num>=0 && num<=total_lingo)
		poke_lingo(num);
	else {
		mci("~SMInvalid nunder.  Try again!~SM~SP");
		}
}

void poke_lingo(int pokenum)
{
	lingorec ndin;
	int i1;

	for(i1=total_lingo;i1>pokenum;i1--){
		readLingo(&ndin,i1-1);
		ndin.idx++;
		saveLingo(&ndin,ndin.idx);
		}
	init_lingo(&ndin);
	ndin.idx=pokenum;
	saveLingo(&ndin,ndin.idx);
	total_lingo++;
}

void init_lingo(lingorec *nd)
{
	strcpy(nd->display,"New Language");
	strcpy(nd->menupath,config.menupath);
	strcpy(nd->textpath,config.textpath);
	strcpy(nd->lingofile,"newlingo.text");
	init_ACS(&nd->ACS,5);
}

void modify_lingo()
{
	char ttxt[21];
	int num;

	mci("~SMModify which? [1-%d]: ",total_lingo);
	*ttxt='\0';
	num=get_num(ttxt)-1;
	if(num>=0 && num<=total_lingo){
		mod_lingo(num);
		}
}

void mod_lingo(int nodenum)
{
	int done=FALSE;
	char ch;
	lingorec nr;

	while(!done){
		readLingo(&nr,nodenum);
		mci("~SC~SMModifying Language %d of %d~SM~SM",nodenum+1,total_lingo);
		mci("A. Display      : %s~SM",nr.display);
		mci("B. File Name    : %s~SM",nr.lingofile);
		mci("C. Menu Path    : %s~SM",nr.menupath);
		mci("D. Text Path    : %s~SM",nr.textpath);
		mci("E. Security ACS : ~SM");
		mci("~SM`09Modify Language(Q=Quit ?=Help)`0F: ");
		ch=onekey("ABCDEQ?");
		switch(ch){
			case 'A':
				mci("~SM~SMNew Display: ");
				get_str(nr.display,60);
				break;
			case 'B':
				mci("~SM~SMLanguage file name~SM:");
				get_str(nr.lingofile,35);
				break;
			case 'C':
				mci("~SM~SMMenu Path~SM:");
				get_filename(nr.menupath,75);
				break;
			case 'D':
				mci("~SM~SMText Path~SM:");
				get_filename(nr.textpath,75);
				break;
			case 'Q':	
				saveLingo(&nr,nr.idx);
				done=TRUE;	break;
			}
		saveLingo(&nr,nodenum);
		}
}

void move_lingo()
{
	char ttxt[21],ttxt1[21];
	int num,num1;

	mci("~SMPosition which? [1-%d]: ",total_lingo);
	*ttxt1='\0';
	num1=get_num(ttxt1)-1;
	if(num1>=0 && num1<total_FSEs){
		mci("`09    Move to which? [1-%d]: ",total_lingo);
		*ttxt='\0';
		num=get_num(ttxt)-1;
		if(num>=0 && num<total_lingo)
			swap_lingo(num1,num);
		else {
			mci("~SMInvalid nunder.  Try again!~SM~SP");
			}
		}
	else{
		mci("~SMInvalid Nunder.  Try again!~SM~SP");
		}
}

void swap_lingo(int iFrom, int iTo)
{
	lingorec ndto,ndfrom;
	int i1;


	readLingo(&ndfrom,iFrom);

	if(iFrom<iTo){
		for(i1=iFrom+1;i1<=iTo;i1++){
			readLingo(&ndto,i1);
			ndto.idx--;
			saveLingo(&ndto,ndto.idx);
			}
		}
	else{
		for(i1=iFrom;i1>iTo;i1--){
			readLingo(&ndto,i1-1);
			ndto.idx++;
			saveLingo(&ndto,ndto.idx);
			}
		}

	ndfrom.idx=iTo;
	saveLingo(&ndfrom,ndfrom.idx);
}

void list_lingo(int page)
{
	int i1,rno;
	lingorec ndl;

	for(i1=0;i1<15;i1++){
		rno=(page*15);
		if(readLingo(&ndl,rno+i1)){
			mci("`0F%3d `0E%s",rno+1+i1,ndl.display);
			}
		else {
			mci("`0F%3d",rno+1+i1);
			}
		nl();
		}
}

