/*****************************************************************************
 *
 * File ..................: useredit.c
 * Purpose ...............: user editor functions.
 * Last modification date : 08-Feb-2001
 *
 *****************************************************************************
 * Copyright (C) 2000-2001
 *   
 * Darryl Perry			
 * FIDO:		1:211/105
 * Internet:	dperry.geo@yahoo.com
 *
 * This file is part of Gryphon/X BBS.
 *
 * This BBS is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Gryphon/X BBS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Gryphon/X BBS; see the file COPYING.  If not, write to the Free
 * Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************/

#include "structs.h"
#include "defs.h"
#include "acs.h"
#include "basics.h"
#include "config.h"
#include "fileio.h"
#include "logon.h"
#include "mail.h"
#include "mci.h"
#include "misc.h"
#include "conio.h"
#include "useredit.h"
#include "sysop.h"

void useredit()
{
	int page=0,done=FALSE;
	int uid;
	char ch;

	Syslog("%s entered UserEditor",thisuser.alias);

	uid=thisuser.userID;

	while(!done){
		mci("~SC~SM`0EUser Editor~SM~SM");
		mci("`09UserID  Alias                     Realname                  Last On    Sec~SM");
		mci("`09------  ------------------------- ------------------------- ---------- ---~SM");
		list_users(page);
		mci("`09------  ------------------------- ------------------------- ---------- ---~SM");
		mci("`09User Editor (]/[=Next/Prev, ?=Help, Q=Quit): `0F");
		ch=onekey("[]?DMQ");
		switch(ch){
			case 'D':	delete_user();		break;
			case 'M':	modify_user();		break;
			case 'Q':	done=TRUE;			break;
			}
		}
	read_usr(&thisuser,uid);
}

void list_users(int page)
{
	int i1;

	for(i1=0;i1<15;i1++){
		if(read_usr(&thisuser,(page*15)+i1)){
			mci("`0F%6d  `0E%-25s `08%-25s ~UI `0E%3d~SM",
				thisuser.userID+1,thisuser.alias,thisuser.realname,thisuser.sl);
			}
		else{
			mci("`0F%6d~SM",(page*15)+i1+1);
			}
		}
}

void delete_user()
{
	int done=FALSE,num;
	char ttxt[9];

	while(!done){
		nl();nl();
		mci("`0EDelete which user? [1-%d]: `0F",total_users);
		*ttxt='\0';
		num=get_num(ttxt)-1;
		if(num>=0 && num<total_users){
			delusr(num);
			done=TRUE;
			}
		}
}

void delusr(int du)
{
	int i,count=0;
	unsigned long lr;
	mb_list_rec mb;

	i=0;
	while(read_usr(&thisuser,i)){
		if(thisuser.userID!=du){
			thisuser.userID=count;
			save_usr_temp(&thisuser,thisuser.userID);
			count++;	
			}
		i++;	
		}	
	restore_user_data();
	total_users=countusers();

	i=0;
	count=du;
	while(read_mbaselist(&mb,i++)){
		for(count=du;count<total_users;count++){
			lr=GetLastRead(count);
			SetLastRead(count-1,lr);
			count++;
			}
	
		}
}

void modify_user()
{
	int num;
	char ttxt[9];

	nl();nl();
	strcpy(ttxt,"");
	mci("`0EModify which user? [1-%d]`0F: ",total_users);
	num=get_num(ttxt)-1;
	if(num>=0 && num<total_users)
		modusr(num);
}

void modflags(char *fflag)
{
	int done=FALSE;
	char ch;

	while(!done){
		mci("`09~SM~SMChange Flag :<`0F%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c`09>`0F: ",
			(fflag[0]=='A')?'A':'-',
			(fflag[1]=='B')?'B':'-',
			(fflag[2]=='C')?'C':'-',
			(fflag[3]=='D')?'D':'-',
			(fflag[4]=='E')?'E':'-',
			(fflag[5]=='F')?'F':'-',
			(fflag[6]=='G')?'G':'-',
			(fflag[7]=='H')?'H':'-',
			(fflag[8]=='I')?'I':'-',
			(fflag[9]=='J')?'J':'-',
			(fflag[10]=='K')?'K':'-',
			(fflag[11]=='L')?'L':'-',
			(fflag[12]=='M')?'M':'-',
			(fflag[13]=='N')?'N':'-',
			(fflag[14]=='O')?'O':'-',
			(fflag[15]=='P')?'P':'-',
			(fflag[16]=='Q')?'Q':'-',
			(fflag[17]=='R')?'R':'-',
			(fflag[18]=='S')?'S':'-',
			(fflag[19]=='T')?'T':'-',
			(fflag[20]=='U')?'U':'-',
			(fflag[21]=='V')?'V':'-',
			(fflag[22]=='W')?'W':'-',
			(fflag[23]=='X')?'X':'-',
			(fflag[24]=='Y')?'Y':'-',
			(fflag[25]=='Z')?'Z':'-');
		ch=onekey("ABCDEFGHIJKLMNOPQRSTUVWXYZ\n");
		if(ch=='\n')	done=TRUE;
		else{
			if(fflag[ch-'A']==ch)	fflag[ch-'A']='-';
			else					fflag[ch-'A']=ch;
			}
		}
}

void user_toggles()
{
	int done=FALSE;
	char ch,grtxt[4][11]={"ASCII","ANSI","None","N/A"};

	while(!done){
		mci("~SC~SM`0EUser Toggles~SM~SM");
		mci("`0E(`0FA`0E) Ansi Graphics: `0F%s~SM",grtxt[thisuser.ugraphics]);
		mci("`0E(`0FB`0E) Screen Size  : `0F%dx%d~SM",
			thisuser.linelen,thisuser.pagelen);
		mci("`0E(`0FC`0E) Date Format  : `0F~VD~SM");
		mci("~SMUser Toggles (A-X, Q=Quit): ");
		ch=onekey("ABCQ");
		switch(ch){
			case 'A':	get_termtype(&thisuser);	break;
			case 'B':	
				get_screen_width(&thisuser);
				get_screen_length(&thisuser);
				save_usr(&thisuser,thisuser.userID);
				break;
			case 'C':	
				get_datefmt(&thisuser);		
				save_usr(&thisuser,thisuser.userID);
				break;
			case 'Q':	done=TRUE;	break;
			}
		}
	
}

void modusr(int mu)
{
	char dump[41],ttxt[10],ch,*p,ch1,done=FALSE;
	int num,part,age;
	levelsrec lev;
	struct tm *tm;

	while(!done){
		read_usr(&thisuser,mu);
		age=calc_age(&thisuser);
		mci("~SC~SM`0EUser Editor - Editing %d of %d~SM~SM",mu+1,total_users);
		mci("`07Handle      : `0E~EL30~UH `07User-ID : `0E~UN~SM");
		mci("`07Real Name   : `0F~EL30~UR `07Security: `0F~US~SM");
		mci("`07Address     : `0F~EL30~UB `07First On: `0F~UK~SM");
		mci("`07Location    : `0F~EL30~UA `07Last On : `0F~UJ  ~UI~SM");
		mci("`07Postal Code : `0F~EL30~UC `07Times On: `0F~TP~SM~SM");
		mci("`07Email       : `0F~EL30~UD `07Password: `0F<--hidden-->~SM");
		mci("`07Voice Phone : `0F~EL30~UE `07Sex/Age : `0F~UG,~UP~SM~SM");
		mci("`07Note 1      : `0F~VI~SM");
		mci("`07Note 2      : `0F~VJ~SM");
		mci("`07Note 3      : `0F~VK~SM");
		mci("`07Flag 1      : `0F%s~SM",thisuser.EFlags);
		mci("`07Flag 2      : `0F%s~SM",thisuser.FFlags);
		mci("~SMEnter command or ? for Help, Q=Quit : ");
		ch=onekey("123ACDEFGHNOQV$T?@[]%");
		switch(ch){
			case '1':	get_notes(1,&thisuser);	break;
			case '2':	get_notes(2,&thisuser);	break;
			case '3':	get_notes(3,&thisuser);	break;
			case 'A':
				get_street(&thisuser);
				get_location(&thisuser);
				get_zipcode(&thisuser);
				save_usr(&thisuser,mu);
				break;
			case 'C':
				mci("~SMComment: ");
				get_str(thisuser.comment,40);
				save_usr(&thisuser,mu);
				break;
			case 'D':
				get_email(&thisuser);
				save_usr(&thisuser,mu);
				break;
			case 'E':
				modflags(thisuser.EFlags);
				save_usr(&thisuser,mu);
				break;
			case 'F':
				modflags(thisuser.FFlags);
				save_usr(&thisuser,mu);
				break;
			case 'G':
				get_gender(&thisuser);
				get_birthdate(&thisuser);
				save_usr(&thisuser,mu);
				break;
			case 'H':
				get_alias(&thisuser);
				save_usr(&thisuser,mu);
				break;
			case 'N':
				get_real_name(&thisuser);
				save_usr(&thisuser,mu);
				break;
			case 'O':
				tm=localtime(&thisuser.firston);
				mci("~SM`09Enter new First On date`0F: ");
				*ttxt='\0';
				get_date(ttxt,10);
				part=0;
				p=strtok(ttxt,"/");
				while(p && part<3){
					switch(part){
						case 0: tm->tm_mon=atoi(p)-1;		break;
						case 1: tm->tm_mday=atoi(p);	break;
						case 2: tm->tm_year=atoi(p)-1900;	break;
						}
					part++;
					p=strtok(NULL,"/");
					}
				thisuser.firston=mktime(tm);
				save_usr(&thisuser,mu);
				break;
			case 'Q':	
				done=TRUE;	
				break;
			case 'S':
				mci("~SMSecurity Level: ");
				*ttxt='\0';
				num=get_num(ttxt);
				if(num>0 && num<256)
					thisuser.sl=(unsigned char )num;
				save_usr(&thisuser,mu);
				break;
			case 'T':
				tm=localtime(&thisuser.laston);
				mci("~SM`09Enter new laston date`0F: ");
				*ttxt='\0';
				get_date(ttxt,10);
				part=0;
				p=strtok(ttxt,"/");
				while(p && part<3){
					switch(part){
						case 0: tm->tm_mon=atoi(p)-1;		break;
						case 1: tm->tm_mday=atoi(p);	break;
						case 2: tm->tm_year=atoi(p)-1900;	break;
						}
					part++;
					p=strtok(NULL,"/");
					}
				thisuser.laston=mktime(tm);
				save_usr(&thisuser,mu);
				break;
			case 'V':
				get_voice_phone(&thisuser);
				save_usr(&thisuser,mu);
				break;
			case ']':
				if(mu<total_users-1) 	mu++;
				else					mu=0;
				break;
			case '[':
				if(mu>0)	mu--;
				else		mu=0;
				break;
			case '$':
				get_new_password(&thisuser);
				save_usr(&thisuser,mu);
				break;
			case '@': 
				nl();
				showlevels();
				mci("`09Select level: ");
				ch1=onekey("ABCDEFGHIJKLMNOPQRSTUVWXYZ");
				num=ch1-'A';	
				readlevel(&lev,num);
				if(lev.active==TRUE){
					thisuser.sl=lev.sl;
					strcpy(thisuser.EFlags,lev.EFlags);
					strcpy(thisuser.FFlags,lev.FFlags);
					thisuser.tltoday=config.ULim[thisuser.sl-1].SecondsPerDay;
					}
				save_usr(&thisuser,mu);
				break;
			case '%':
				user_toggles();	
				save_usr(&thisuser,mu);
				break;
			case '?':
				mci("~SM~SM`08(`0FA`08)ddress Info    ");
				mci("`08(`0FH`08)andle          ");
				mci("`08(`0FS`08)ecurity Level  ");
				mci("`08(`0F#`08)Subscription~SM");
				mci("`08(`0FC`08)Sysop Comment  ");
				mci("`08(`0FL`08)ocation        ");
				mci("`08(`0FT`08)Laston Date    ");
				mci("`08(`0F%`08)User Toggles~SM");
				mci("`08(`0FD`08)Email Address  ");
				mci("`08(`0FN`08)ame            ");
				mci("`08(`0FV`08)oice Phone     ");
				mci("`08(`0F&`08)Statistics~SM");
				mci("`08(`0FE`08)Flags 1        ");
				mci("`08(`0FO`08)Firston Date   ");
				mci("`08(`0F!`08)PW Date        ");
				mci("`08(`0F1`08)Note 1~SM");
				mci("`08(`0FF`08)Flags 2        ");
				mci("`08(`0FP`08)ostal code     ");
				mci("`08(`0F$`08)Password       ");
				mci("`08(`0F2`08)Note 2~SM");
				mci("`08(`0FG`08)enger/Age      ");
				mci("`08(`0FR`08)estrictions    ");
				mci("`08(`0F@`08)Upgrade Level  ");
				mci("`08(`0F3`08)Note 3~SM~SP");
				break;
			}
		}
}
